      COMPLEX*16 FUNCTION ZCEXIW(Z1,Z2,DEPW,RHOW,GRHOW,
     1                          ALPHA1,ALPHA2)
C
C     THIS FUNCTION EVALUATES THE INTEGRAL OF THE PRODUCT OF DEPTH
C     (Z) AND TWO BASIC DEPTH FUNCTIONS OVER THE INTERVAL Z1 TO
C     Z2 IN THE WATER, WEIGHTED BY AN EXPONENTIAL DENSITY PROFILE.
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      COMPLEX*16 ALPHA1,ALPHA2
      COMPLEX*16 CFAC,CGRHOW,CI
      COMPLEX*16 U,V,W,X
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      CI=DCMPLX(0.0D0,1.0D0)
      CGRHOW=DCMPLX(GRHOW,0.0D0)
C
      CFAC=-FKB**4/(4.0D0*RHOW*ALPHA1*ALPHA2)
C
      ZCEXIW=DCMPLX(0.0D0,0.0D0)
C
      W=CI*(ALPHA1+ALPHA2)-CGRHOW
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(CI*(ALPHA1+ALPHA2)*Z2-CGRHOW*(Z2-DEPW))
      V=CDEXP(CI*(ALPHA1+ALPHA2)*Z1-CGRHOW*(Z1-DEPW))
      ZCEXIW=ZCEXIW+(((U*Z2-V*Z1)/W)-((U-V)/W**2))
      ELSE 
      X=CDEXP(CGRHOW*DEPW)
      ZCEXIW=ZCEXIW+(X*(Z2**2-Z1**2)/2.0D0)
      END IF
C
      W=CI*(ALPHA1-ALPHA2)-CGRHOW
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(CI*(ALPHA1-ALPHA2)*Z2-CGRHOW*(Z2-DEPW))
      V=CDEXP(CI*(ALPHA1-ALPHA2)*Z1-CGRHOW*(Z1-DEPW))
      ZCEXIW=ZCEXIW-(((U*Z2-V*Z1)/W)-((U-V)/W**2))
      ELSE 
      X=CDEXP(CGRHOW*DEPW)
      ZCEXIW=ZCEXIW-(X*(Z2**2-Z1**2)/2.0D0)
      END IF
C
      W=CI*(ALPHA2-ALPHA1)-CGRHOW
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(CI*(ALPHA2-ALPHA1)*Z2-CGRHOW*(Z2-DEPW))
      V=CDEXP(CI*(ALPHA2-ALPHA1)*Z1-CGRHOW*(Z1-DEPW))
      ZCEXIW=ZCEXIW-(((U*Z2-V*Z1)/W)-((U-V)/W**2))
      ELSE 
      X=CDEXP(CGRHOW*DEPW)
      ZCEXIW=ZCEXIW-(X*(Z2**2-Z1**2)/2.0D0)
      END IF
C
      W=-CI*(ALPHA1+ALPHA2)-CGRHOW
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(-CI*(ALPHA1+ALPHA2)*Z2-CGRHOW*(Z2-DEPW))
      V=CDEXP(-CI*(ALPHA1+ALPHA2)*Z1-CGRHOW*(Z1-DEPW))
      ZCEXIW=ZCEXIW+(((U*Z2-V*Z1)/W)-((U-V)/W**2))
      ELSE 
      X=CDEXP(CGRHOW*DEPW)
      ZCEXIW=ZCEXIW+(X*(Z2**2-Z1**2)/2.0D0)
      END IF
C
      ZCEXIW=CFAC*ZCEXIW
      RETURN
      END

      COMPLEX*16 FUNCTION CDTAN(Z)
C
C     THIS FUNCTION EVALUATES THE COMPLEX TAN OF Z WHEN Z HAS
C     A NEGATIVE IMAGINARY PART WITH A LARGE ABSOLUTE VALUE.
C 
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 Z,U,V
      COMPLEX*16 CI
      REAL*8 X,Y,SNEG,DREAL
C
      SNEG=-44.368D0
      CI=DCMPLX(0.0D0,1.0D0)
      X=DREAL(Z)
      Y=DIMAG(Z)
C
C     EXP(2.*(-44.368)) SHOULD UNDERFLOW TO ZERO GIVING CDTAN=-CI.
C     THIS IS A MACHINE DEPENDENT CONSTANT
C
      CDTAN=-CI
      IF(Y .LT. SNEG) GO TO 100
C 
      U=2.0D0*Y-CI*X
      V=CI*X
C
      CDTAN=CI*(CDEXP(U)-CDEXP(V))/(CDEXP(U)+CDEXP(V))
C
  100 CONTINUE
      RETURN
      END      

      SUBROUTINE GALRKN(HW,M,ZZ,EGVL,FNORM,
     1              BEGVL,UMATL,VMATL,MX,MULT,A,B,H,HL,INT,INTH,
     2              MXSD2,FA,FB,FU,FV,FCS,FZ1,FZ2,FD,FE,
     3              DEPW,CGRADW,CINTW,RHOW,GRHOW,NPW,AVGW,LHW,
     4              DEPB,CGRADB,CINTB,RHOB,GRHOB,NPB,AVGB,LHB)
C
C     THIS SUBROUTINE FINDS COMPLEX EIGENVALUES EGVL AND EIGEN-
C     FUNCTIONS USING THE GALERKIN-MATRIX METHOD. THE GALERKIN 
C     MATRIX METHOD REDUCES THE PROBLEM TO A GENERALIZED MATRIX 
C     EIGENVALUE PROBLEM OF THE FORM: A UMATL = B UMATL DIAG(EGVL).
C     THE EIGENVALUES ARE THE SAME FOR BOTH PROBLEMS AND THE EIGEN-
C     FUNCTIONS MAY BE CONSTRUCTED FROM THE MATRIX EIGENVECTORS IN
C     UMATL. THE GENERALIZED MATRIX EIGENVALUE PROBLEM IS SYMMETRIZED 
C     USING THE CHOLESKY DECOMPOSITION OF B TO ASSURE OTHOGONALITY 
C     OF THE EIGENFUNCTIONS CONSTRUCTED FROM THE MATRIX EIGENVECTORS
C     IN UMATL.
C 
C     THIS VERSION ALLOWS PIECEWISE LINEAR VARIATONS IN THE SQUARE 
C     OF THE INDEX OF REFRACTION AND PIECEWISE EXPONENTIAL DENSITY    
C     VARIATION IN BOTH WATER AND BOTTOM. THE SQUARE OF THE INDEX 
C     OF REFRACTON CAN BE COMPLEX DUE TO ATTENUATION. 
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      DIMENSION INT(MX),INTH(MX)
      LOGICAL EIVEC
C
      REAL*8 ZZ(MX),ZERO,ESP,DREAL
C 
      DIMENSION DEPW(MX),RHOW(MX),GRHOW(MX)
      DIMENSION DEPB(MX),RHOB(MX),GRHOB(MX)
      REAL*8 B(MX,MX),VMATL(MX,MX)
      REAL*8 FA(MXSD2),FB(MXSD2),FU(MX,MX),FV(MX,MX)
      REAL*8 FCS(MX),FZ1(MX),FZ2(MX),FD(MX),FE(MX)
      COMPLEX*16 CGRADW(MX),CINTW(MX)
      COMPLEX*16 CGRADB(MX),CINTB(MX)
      COMPLEX*16 EGVL(MX),FNORM(MX),BEGVL(MX)
      COMPLEX*16 A(MX,MX),H(MX,MX),HL(MX,MX)
      COMPLEX*16 UMATL(MX,MX)
      COMPLEX*16 CDSRT,GAMA0
      COMPLEX*16 MULT(MX),CZERO,ONE
      COMPLEX*16 ALPHA1,BETA1
      COMPLEX*16 CKH,CSH
C
      ESP=.1D-9
      ZERO=DBLE(0.0)     
      ONE=DCMPLX(1.0,0.0)
      CZERO=DCMPLX(0.0,0.0)
C
C     FIND THE BASIC EIGENVALUES
C 
      CALL EGNVAL(HW,M,ZZ,MX)
C
C     FIND THE NORMALIZATION FACTORS FOR THE BASIC EIGENFUNCTIONS
C
      DO 100 I=1,M
C
      BEGVL(I)=DCMPLX(ZZ(I),ZERO)
      ALPHA1=CDSRT(FKW**2+FKB**2*(BEGVL(I)-ONE))
      BETA1=CDSRT(FKB**2*BEGVL(I))
      FNORM(I)=GAMA0(HW,ALPHA1,BETA1)
C
C      WRITE(6,50) I,BEGVL(I),FNORM(I),ALPHA1,BETA1
C      WRITE(9,50) I,BEGVL(I),FNORM(I),ALPHA1,BETA1
C   50 FORMAT(1X,I3,2X,4(2E12.4,1X))
C
  100 CONTINUE
C
C     COMPUTE THE REAL POSITIVE DEFINITE SYMMETRIC MATRIX B THAT
C     APPEARS ON THE RIGHT HAND SIDE OF THE GENERALIZED MATRIX EIGEN-
C     VALUE PROBLEM A UMATL = B UMATL DIAG(EGVL)
C
      CALL BMAT(HW,M,BEGVL,FNORM,B,MX,DEPW,RHOW,GRHOW,NPW,LHW,
     1          DEPB,RHOB,GRHOB,NPB,LHB)
C
C     PRINT THE MATRIX B
C
C      DO 170 I=1,M
C      DO 160 II=1,M
C      H(II,I)=DCMPLX(B(II,I),0.0D0)
C  160 CONTINUE
C  170 CONTINUE
C      CALL PRTMAT(M,M,'B   ',H,MX)
C
C     COMPUTE THE CHOLESKY DECOMPOSTION OF B
C
C                             T
C          B  =   VMATL  VMATL
C
C     INTO THE LOWER TRIANGULAR MATRIX VMATL AND ITS TRANSPOSE
C
      CALL CHOLDC(B,VMATL,M,MX)
C
C     CONSTRUCT THE COMPLEX SYMMETRIC MATRIX A THAT APPEARS ON THE
C     LEFT HAND SIDE OF THE GENERALIZED MATRIX EIGENVALUE PROBLEM
C     A UMATL = B UMATL DIAG(EGVL) 
C
      CALL AMAT(HW,M,BEGVL,FNORM,A,MX,
     1          DEPW,CGRADW,CINTW,RHOW,GRHOW,NPW,AVGW,LHW,
     2          DEPB,CGRADB,CINTB,RHOB,GRHOB,NPB,AVGB,LHB)
C
C     PRINT THE MATRIX A
C
C      CALL PRTMAT(M,M,'A   ',A,MX)
C
C     USE FORWARD SUBSTITUTION TWICE TO COMPUTE THE COMPLEX SYMMETRIC 
C     MATRIX
C                -1         T -1
C           VMATL   A  VMATL     ,    
C
C     WHICH IS STORED IN A, AND WHOSE EIGENVALUES ARE THE SAME AS THE
C     GENERALIZED EIGENVALUE PROBLEM A UMATL = B UMATL DIAG(EGVL) 
C
      CALL FORESUB(VMATL,HL,A,M,MX)
C
C     DEFINE THE TRANSPOSE OF HL
C
      DO 230 I=1,M
      DO 210 II=1,M
      H(II,I)=HL(I,II)
  210 CONTINUE
  230 CONTINUE
C
C     SOLVE FOR THE SYMMETRIIC MATIX
C
      CALL FORESUB(VMATL,A,H,M,MX)
C
C     PRINT THE SYMMETRIC MATRIX A 
C
C      CALL PRTMAT(M,M,'SA  ',A,MX)
C
C     STORE THE REAL AND IMAGINARY PARTS OF THE DIAGONAL AND SUPER
C     DIAGONAL OF THE SYMMETRIC MATRIX A, BY COLUNMS, TO BE PASSED 
C     TO THE JACOBI TYPE ALGORITHM CSYMEIG
C
      DO 270 J=1,M
      DO 250 I=1,J
      JJI=(J*(J-1)/2)+I
      FA(JJI)=DREAL(A(I,J))
      FB(JJI)=DIMAG(A(I,J))
  250 CONTINUE
  270 CONTINUE
      EIVEC=.TRUE.
C
C     FIND THE EIGENVALUES AND EIGENVECTORS USING THE JACOBI TYPE 
C     ALGORITHM. 
C
      CALL CSYMEIG(FA,FB,FU,FV,FCS,FZ1,FZ2,FD,FE,M,EIVEC,MX,MXSD2)
C
C     DEFINE THE COMPLEX EIGENVALUES
C
C      WRITE(9,*) ' '
C      WRITE(9,*) 'HORIZONTAL WAVE NUMBERS:'
C      WRITE(9,*) ' '
C
      DO 400 I=1,M
      II=I*(I+1)/2
      EGVL(I)=DCMPLX(FA(II),FB(II))
C
C      CKH=FKB*CDSRT(ONE-EGVL(I))
C      WRITE(6,390) I,EGVL(I)
C      WRITE(9,390) I,CKH
C  390 FORMAT(1X,I5,2G23.14)
C
  400 CONTINUE
C
C      WRITE(9,*) ' '
C      WRITE(9,*) 'HORIZONTAL SLOWNESS:'
C      WRITE(9,*) ' '
C      OMEGA=CB*FKB
C      DO 410 I=1,M
C      CKH=FKB*CDSRT(ONE-EGVL(I))
C      CSH=1000.0D0*CKH/OMEGA
C      WRITE(6,390) I,CSH
C      WRITE(9,390) I,CSH
C  410 CONTINUE
C
C     DEFINE THE COMPLEX EIGENVECTORS
C
      DO 500 I=1,M
      DO 490 II=1,M
      UMATL(II,I)=DCMPLX(FU(II,I),FV(II,I))
  490 CONTINUE
  500 CONTINUE
C
C     PRINT THE MATRIX OF EIGENVECTORS
C
C      CALL PRTMAT(M,M,'UMAT',UMATL,MX)
C
C     IN SOME CASES WHEN THE EIGENVALUES HAVE A SMALL IMAGINARY
C     PART, THE COMPLEX CONJUGATE OF THE PHYSICAL EIGENVALUE IS
C     FOUND. IN THESE CASES THE COMPLEX CONJUGATE IS TAKEN.
C     THIS IS A REALLY DUMB FIX.
C
      DO 600 I=1,M
      ICONJG=0
C
      IF((DIMAG(EGVL(I)) .GT. ZERO) .AND.
     1   (DIMAG(EGVL(I)) .LT. ESP )) THEN
      ICONJG=1
      EGVL(I)=DCONJG(EGVL(I))
      DO 590 II=1,M
      UMATL(II,I)=DCONJG(UMATL(II,I))
  590 CONTINUE
      END IF
C
      IF(ICONJG .NE. 0) THEN
      WRITE(9,*) '*** WARNING CONJUGATE EIGENVLAUE FOUND',
     1           ' MODE = ',I,' IN GALRKN ***'
      WRITE(6,*) '*** WARNING CONJUGATE EIGENVLAUE FOUND',
     1           ' MODE = ',I,' IN GALRKN ***'
      END IF
C
  600 CONTINUE
C
C     DEFINE THE TRANSPOSE OF VMATL
C
      DO 800 I=1,M
      DO 700 II=1,M
      H(II,I)=DCMPLX(VMATL(I,II),0.0D0)
  700 CONTINUE
  800 CONTINUE
C
C     RECOVER THE EIGENVECTORS OF THE GENERALIZED MATRIX EIGENVALUE
C     PROBLEM
C                 T -1  
C            VMATL     UMATL    
C
C     USING BACKSUBSTITUTION AND STORE THE RESULTS IN HL.
C
      CALL BACKSUB(H,HL,UMATL,M,MX)
C
C     RETURN THE EIGENVECTORS IN UMATL AND STORE THE REAL SYMMETRIC
C     POSITIVE DEFINITE MATRIX B IN THE COMPLEX MATRIX A FOR ORTHO-
C     GONALITY CHECK
C
      DO 1000 I=1,M
      DO 900 II=1,M
      UMATL(II,I)=HL(II,I)
      A(II,I)=DCMPLX(B(II,I),0.0D0)
  900 CONTINUE
 1000 CONTINUE
C
C     CHECK ORTHOGONALITY
C
C      CALL TMMULT(M,UMATL,A,UMATL,MX,H)
C      CALL PRTMAT(M,M,'ORTH',A,MX)
C
      RETURN 
      END      

      COMPLEX*16 FUNCTION CDSRT(Z)
C
C     THIS FUNCTION PROVIDES A SQUARE ROOT WITH A 
C     NON-NEGATIVE IMAGINARY PART.
C
CHS     H. SCHMIDT, 14.APR.87. CHANGED TO WORK CORRECTLY FOR
CHS     SMALL NEGATIVE IMAGINARY PART OF THE ARGUMENT BY MOVING
CHS     THE BRANCH CUT TO THE NEGATIVE IMAGINARY AXIS.
C 
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 Z,U,W
C
CHS      IF (DREAL(Z) .LE. 0.0D0) THEN
CHS        CDSRT=DCMPLX(0.0D0,1.0D0)*CDSQRT(-Z)
CHS      ELSE
CHS        CDSRT=CDSQRT(Z)
CHS      END IF
C
      U=CDSQRT(Z)
      W=DCMPLX(-1.0D0,0.0D0)
      IF(DIMAG(U) .LT. 0.0D0) U=W*U
      CDSRT=U
C 
      RETURN
      END

      SUBROUTINE HEADER(TITLE,FREQ,ZS,NDEP,NDINC,ZR,N,RANGE,DEPTH,MD,
     1                  NRX,MAMP,IOUT)
C
C     THIS SUBROUTINE WRITES THE HEADERS ON THE OUTPUT FILES.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION ZR(MD)
      DIMENSION RANGE(NRX),DEPTH(NRX)
C
      CHARACTER*10 TITLE(8),DA
C
C    FIND DATE IN LAHEY
C               
      CALL DATE(DA) 
C
C     FIND DATE IN SVS
C
C      CALL GETDAT(IY,IM,ID)
C     WRITE(DA,50) IM,ID,IY
C   50 FORMAT(I2,'-',I2,'-',I4)    
C
      NR=0
C
C     UNFORMATTED COMPLEX PRESSURE: TOTAL,OUTGOING,INGOING
C     AND SCATTERED.
C     
      WRITE(7) (TITLE(I),I=1,8),DA,SNGL(FREQ),SNGL(ZS),NR,NDEP,
     1         (SNGL(ZR(I)),I=1,NDEP)
C
      IF(IOUT .NE. 1) THEN
      WRITE(14) (TITLE(I),I=1,8),DA,SNGL(FREQ),SNGL(ZS),NR,NDEP,
     1         (SNGL(ZR(I)),I=1,NDEP)
      WRITE(15) (TITLE(I),I=1,8),DA,SNGL(FREQ),SNGL(ZS),NR,NDEP,
     1         (SNGL(ZR(I)),I=1,NDEP)
      WRITE(16) (TITLE(I),I=1,8),DA,SNGL(FREQ),SNGL(ZS),NR,NDEP,
     1         (SNGL(ZR(I)),I=1,NDEP)
      END IF
C
C      THE FOLLOWING RECORD WAS USED FOR COUTOUR PLOTS AND IS
C      CURRENTLY INACTIVE
C      WRITE(7) N,(SNGL(RANGE(I)),I=1,N),(SNGL(DEPTH(I)),I=1,N)
C
C     FORMATTED TRANSMISSION LOSS
C
      XND=FLOAT(NDEP)
      XNI=FLOAT(NDINC)
      ND=XND/XNI+.999
      WRITE(10,100) (TITLE(I),I=1,8)
  100 FORMAT(8A10)
      WRITE(10,200) DA,FREQ,ZS,NR,ND
  200 FORMAT(A10,2F13.7,2I5)
      WRITE(10,300) (ZR(I),I=1,NDEP,NDINC)
  300 FORMAT(20F13.7)
C
      IF(IOUT .NE. 1) THEN
C
C     OUTGOING TL
C
      WRITE(12,100) (TITLE(I),I=1,8)
      WRITE(12,200) DA,FREQ,ZS,NR,ND
      WRITE(12,300) (ZR(I),I=1,NDEP,NDINC)
C
C     INGOING TL
C
      WRITE(13,100) (TITLE(I),I=1,8)
      WRITE(13,200) DA,FREQ,ZS,NR,ND
      WRITE(13,300) (ZR(I),I=1,NDEP,NDINC)
C
C     SCATTERED TL
C
      WRITE(17,100) (TITLE(I),I=1,8)
      WRITE(17,200) DA,FREQ,ZS,NR,ND
      WRITE(17,300) (ZR(I),I=1,NDEP,NDINC)
C
      END IF
C
      IF(MAMP .LE. 0) GO TO 400
      WRITE(11,100) (TITLE(I),I=1,8)
      WRITE(11,200) DA,FREQ,ZS,NR,NDEP
      WRITE(11,300) (ZR(I),I=1,NDEP)
  400 CONTINUE
C
      RETURN
      END

      SUBROUTINE MMULT(A,B,C,N,NX)
C
C     THIS SUBROUTINE DOES MATRIX MULTIPLICATION: A*B=C
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 A(NX,NX),B(NX,NX),C(NX,NX)
C
      DO 500 I=1,N
      DO 400 J=1,N
C
      C(I,J)=DCMPLX(0.0,0.0)
      DO 300 II=1,N
      C(I,J)=C(I,J)+A(I,II)*B(II,J)
  300 CONTINUE
C
  400 CONTINUE
  500 CONTINUE
C
      RETURN
      END 

      SUBROUTINE PRTTL(TITLE,FREQ,ZS,ZR,TL)
C
C     THIS SUBROUTINE PRINTS THE TRANSMISSION LOSS WHICH WAS WRITTEN
C     ON TAPE10 IN CPRES.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION ZR(1),TL(1)
C
      CHARACTER*6 IDENT
      CHARACTER*10 TITLE(8),DA
C
      READ(10,10) (TITLE(I),I=1,8)
   10 FORMAT(8A10)
      READ(10,20) DA,FREQ,ZS,NR,ND
   20 FORMAT(A10,2F13.7,2I5)
      READ(10,30) (ZR(I),I=1,ND)
   30 FORMAT(20F13.7)
C
C
      WRITE(9,100)
  100 FORMAT(///)
      WRITE(9,300) (TITLE(I),I=1,8),DA
  300 FORMAT(1X,8A10,5X,A10)
      WRITE(9,500) ZS
  500 FORMAT(21H TRANSMISSION LOSS --,//
     1           15H INPUT DEPTH = ,F7.1,2H M)
      WRITE(9,520) FREQ,(ZR(I),I=1,ND)
  520 FORMAT(14H FREQUENCY   =,F7.1,3H HZ//
     1       9H DEPTH=  ,20F6.1)
      WRITE(9,600)
  600 FORMAT(8H RANGE  ,120(1H-))
C
  800 CONTINUE
C
      READ(10,810,END=900) RKM,(TL(I),I=1,ND)
  810 FORMAT(F13.7,20F13.7)
C
      WRITE(9,850) RKM,(TL(I),I=1,ND)
  850 FORMAT(1X,F8.2,20F6.1)
C
      GO TO 800
C
  900 CONTINUE
C
      REWIND 10
C
      RETURN
      END

      COMPLEX*16 FUNCTION CUPW(HW,ALPHA1,ALPHA2,
     1                         DEPW,RHOW,GRHOW,LHW,MX)
C
C     THIS FUNCTION COMPUTES THE INTEGRAL OF TWO BASIC DEPTH
C     FUNCTIONS OVER THE WATER FROM DEPW(1)=0 TO HW, WEIGHTED
C     BY THE WATER DENSITY PROFILE RHOW.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION DEPW(MX),RHOW(MX),GRHOW(MX)
      COMPLEX*16  CEXIW
      COMPLEX*16  ALPHA1,ALPHA2
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      LHWM1=LHW-1
C
      CUPW=DCMPLX(0.0,0.0)
C     
      IF(LHWM1 .LT. 1 ) GO TO 320
      DO 300 L=1,LHWM1
      Z1=DEPW(L)
      Z2=DEPW(L+1)
      CUPW=CUPW+CEXIW(Z1,Z2,DEPW(L),RHOW(L),GRHOW(L),
     1          ALPHA1,ALPHA2)
  300 CONTINUE
  320 CONTINUE
      Z1=DEPW(LHW)
      CUPW=CUPW+CEXIW(Z1,HW,DEPW(LHW),RHOW(LHW),GRHOW(LHW),
     1          ALPHA1,ALPHA2)
C
C
      RETURN
      END

      SUBROUTINE CLINEQS(N,NDIM,M,MDIM,A,B,CLU,X,R,IPS,IER) 
C     
C     THIS SUBROUTINE SOLVES THE COMPLEX MATRIX EQUATION A*X=B USING
C     COMPLEX*16 VERSIONS OF THE REAL NCAR SUBROUTINES IN LINEQSV.
C     A IS A NXN COMPLEX MATRIX AND B IS NXM COMPLEX MATRIX. THE RESULT
C     IS RETURNED IN B.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION IPS(NDIM)
C     
      REAL*8 DIGITS,XMIN,XMAX,XMAG
C
      COMPLEX*16 B(NDIM,MDIM),X(NDIM),R(NDIM)
      COMPLEX*16 A(NDIM,NDIM),CLU(NDIM,NDIM),CDET
C
C     SCALE THE MATRIX A AND B
C
      XMIN=DBLE(.1E+38)
      XMAX=DBLE(0.0)
C
      DO 20 I=1,N
      DO 20 II=1,N
C
      XMIN=DMIN1(XMIN,CDABS(A(II,I)))
      XMAX=DMAX1(XMAX,CDABS(A(II,I)))
C
   20 CONTINUE
C
      XMAG=(XMIN+XMAX)/2.
      IFLAG=2
      IF(XMAG .EQ. 0.0) CALL ABORTC(IFLAG)
C
      DO 40 I=1,N
      DO 40 II=1,N
      A(II,I)=A(II,I)/XMAG
   40 CONTINUE
C
      DO 50 I=1,M
      DO 50 II=1,N
      B(II,I)=B(II,I)/XMAG
   50 CONTINUE
C
C 
      CALL DECOMP(N,NDIM,A,CLU,CDET,IPS,IER)
C
C
      IF(CDABS(CDET) .EQ. 0.0) CALL ABORTC(IFLAG)
C
      DO 500 I=1,M
C
C
      CALL SOLVE(N,NDIM,CLU,B(1,I),IPS,X)
C
C
      CALL IMPRUV(N,NDIM,A,CLU,B(1,I),IPS,X,R,DIGITS,IER) 
C
C
      DO 100 II=1,N
      B(II,I)=X(II)
  100 CONTINUE
C
  500 CONTINUE
C
      RETURN
      END
C LINEQSV    FROM NSSL                                     08/15/79    
      SUBROUTINE DECOMP (N,NDIM,A,CLU,D,IPS,IER)    
C    
C PACKAGE LINEQSV    
C    
C    
C LATEST REVISION        JANUARY 1979    
C    
C PURPOSE                LINEQSV IS A PACKAGE OF THREE    
C                        SUBROUTINES--DECOMP, SOLVE AND IMPRUV--WHICH   
C                        MAY BE USED TO SOLVE A SYSTEM OF LINEAR    
C                        EQUATIONS BY GAUSSIAN ELIMINATION WITH PARTIAL 
C                        PIVOTING AND (OPTIONALLY) WITH ITERATIVE    
C                        IMPROVEMENT.    
C    
C ACCESS CARDS           *FORTRAN,S=ULIB,N=LINEQSV    
C    
C    
C USAGE                  TO SOLVE A SYSTEM OF EQUATIONS, AX = B, THE    
C                        USER FIRST CALLS DECOMP BY    
C                            CALL DECOMP (N,NDIM,A,CLU,D,IPS,IER)    
C                        WHICH DECOMPOSES A INTO THE PRODUCT OF A UNIT  
C                        LOWER TRIANGULAR MATRIX AND AN UPPER TRIANGULAR
C                        MATRIX.  AFTER CHECKING D TO INSURE THAT THE   
C                        DETERMINANT OF A IS NOT ZERO, THE USER THEN    
C                        FOLLOWS THIS CALL WITH A CALL TO SOLVE BY    
C                            CALL SOLVE (N,NDIM,CLU,B,IPS,X)    
C                        WHICH USES THE DECOMPOSITION TO FIND THE    
C                        SOLUTION X.  IF DESIRED, THE USER MAY THEN TRY 
C                        TO IMPROVE THE ACCURACY OF THE SOLUTION BY    
C                        CALLING IMPRUV BY    
C                            CALL IMPRUV (N,NDIM,A,CLU,B,IPS,X,R,DIGITS, 
C                                         IER)    
C                        IF THE USER WANTS TO SOLVE SEVERAL LINEAR    
C                        SYSTEMS OF EQUATIONS WITH THE SAME COEFFICIENT 
C                        MATRIX A, ONLY ONE CALL TO DECOMP IS NECESSARY.
C                        THIS IS THEN FOLLOWED BY A CALL TO SOLVE FOR   
C                        EACH DIFFERENT B VECTOR.    
C                        . EACH OF THE ABOVE ROUTINES IS WRITTEN UP IN  
C                          DETAIL BELOW.    
C    
C ENTRY POINTS           DECOMP, SOLVE, IMPRUV    
C    
C SPACE REQUIRED         723 (OCTAL) = 467 (DECIMAL) LOCATIONS    
C    
C SUBROUTINE DECOMP (N,NDIM,A,CLU,D,IPS,IER)    
C    
C    
C DIMENSION OF           A(NDIM,N),CLU(NDIM,N),IPS(N)    
C ARGUMENTS    
C    
C PURPOSE                DECOMPOSE MATRIX INTO THE PRODUCT OF UPPER AND 
C                        UNIT LOWER TRIANGULAR MATRICES USING GAUSSIAN  
C                        ELIMINATION WITH PARTIAL PIVOTING.    
C    
C USAGE                  CALL DECOMP (N,NDIM,A,CLU,D,IPS,IER)    
C    
C ARGUMENTS    
C    
C ON INPUT               N    
C                          ORDER OF MATRIX A.    
C    
C                        NDIM    
C                          DECLARED FIRST (ROW) DIMENSIONS OF A AND CLU  
C                          IN THE CALLING PROGRAM.    
C    
C                        A    
C                          MATRIX TO BE DECOMPOSED.    
C    
C ON OUTPUT              CLU    
C                          LOWER AND UPPER TRIANGULAR MATRICES OF A,    
C                          WHERE    
C                              CLU(I,J), FOR I .LE. J,    
C                          IS THE UPPER TRIANGULAR MATRIX WITH ROW    
C                          INTERCHANGES COMPLETED, AND    
C                              CLU(I,J), FOR I .GT. J,    
C                          IS THE NEGATIVE OF LOWER TRIANGULAR MATRIX   
C                          EXCLUDING DIAGONAL ELEMENTS, BUT WITH ROW    
C                          INTERCHANGES PARTIALLY COMPLETED.    
C    
C                          IF MATRIX A NEED NOT BE SAVED, THEN THE    
C                          MATRIX A MAY BE USED AS THE DECOMPOSITION    
C                          MATRIX CLU IN THE CALL, I.E.,    
C                              CALL DECOMP (N,NDIM,A,A,D,IPS,IER)    
C                          NOTE:  IF SUBROUTINE IMPRUV WILL BE USED, A  
C                                 MUST BE RETAINED.    
C    
C                        D    
C                          DETERMINANT OF A.    
C    
C                        IPS    
C                          VECTOR (OF DIMENSION AT LEAST N) STORING ROW 
C                          PERMUTATIONS RESULTING FROM PIVOTING, WHERE  
C                          IPS(K) = KTH PIVOT ROW AFTER ROW INTERCHANGES
C                          FROM PREVIOUS PIVOTS.    
C    
C                        IER    
C                          ERROR FLAG USED BY STANDARD ERROR MESSAGE    
C                          ROUTINE, ULIBER, AND RETURNED TO USER.    
C                          =  0,  NO ERROR.    
C                          = 32,  DETERMINANT OF A EQUALS ZERO, HENCE   
C                                 DECOMPOSITION IS IMPOSSIBLE.  A    
C                                 MESSAGE IS PRINTED.    
C    
C    
C    
C    
C    
C    
C COMMON BLOCKS          NONE    
C    
C I/O                    NONE
C    
C PRECISION              COMPLEX*16
C    
C REQUIRED ULIB          NONE    
C ROUTINES    
C    
C SPECIALIST             R. K. SATO, NCAR, BOULDER, COLORADO  80303    
C    
C LANGUAGE               FORTRAN    
C    
C HISTORY                TRANSCRIBED FROM A PAPER BY C. B. MOLER,    
C                        LINEAR EQUATION SOLVER, COMM. ACM 15    
C                        (APRIL, 1972), 74.    
C    
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION IPS(NDIM)
C    
      COMPLEX*16 A(NDIM,NDIM),CLU(NDIM,NDIM)
      COMPLEX*16 T,D
C    
      IER = 0    
C    
C INITIALIZE ARRAYS    
C    
C    
      DO 101 J=1,N    
         IPS(J) = J    
  101 CONTINUE    
C    
      DO 103 J=1,N    
         DO 102 I=1,N    
            CLU(I,J) = A(I,J)    
  102    CONTINUE    
  103 CONTINUE    
  104 D = 1.    
C    
C LU DECOMPOSITION USING GAUSSIAN ELIMINATION WITH PARTIAL PIVIOTING.   
C    
      DO 110 K=1,N    
         IF (K .EQ. N) GO TO 109    
         KP1 = K+1    
         M = K    
C    
C FIND PIVOT ELEMENT.    
C    
         DO 105 I=KP1,N    
            IF (CDABS(CLU(I,K)) .GT. CDABS(CLU(M,K))) M = I    
  105    CONTINUE    
C    
C SAVE ROW PERMUTATIONS.    
C    
         IPS(K) = M    
         IF (M .NE. K) D = -D    
         T = CLU(M,K)    
         CLU(M,K) = CLU(K,K)    
         CLU(K,K) = T    
         IF (T .EQ. 0.0) GO TO 112    
C    
C CALCULATE AND STORE ELEMENTS OF FACTORS, L AND U.    
C    
         DO 106 I=KP1,N    
            CLU(I,K) = -CLU(I,K)/T    
  106    CONTINUE    
         DO 108 J=KP1,N    
            T = CLU(M,J)    
            CLU(M,J) = CLU(K,J)    
            CLU(K,J) = T    
            IF (T .EQ. 0.0) GO TO 108    
            DO 107 I=KP1,N    
               CLU(I,J) = CLU(I,J)+CLU(I,K)*T    
  107       CONTINUE    
  108    CONTINUE    
  109    IF (CLU(K,K) .EQ. 0.0) GO TO 112    
  110 CONTINUE    
C    
C COMPUTE DETERMINANT OF MATRIX A.    
C    
      DO 111 K=1,N    
         D = D*CLU(K,K)    
  111 CONTINUE    
      RETURN    
  112 IER = 32    
      D = 0.0    
      RETURN    
      END    
      SUBROUTINE SOLVE (N,NDIM,CLU,B,IPS,X)    
C    
C    
C DIMENSION OF           CLU(NDIM,N),B(N),IPS(N),X(N)    
C ARGUMENTS    
C    
C PURPOSE                SOLVES FOR VECTOR X OF UNKNOWNS OF THE LINEAR  
C                        SYSTEM AX = B USING THE LU DECOMPOSITION OF A  
C                        FROM SUBROUTINE DECOMP.    
C    
C USAGE                  CALL SOLVE (N,NDIM,CLU,B,IPS,X)    
C    
C ARGUMENTS    
C    
C ON INPUT               N    
C                          ORDER OF MATRIX A (NUMBER OF EQUATIONS).    
C    
C                        NDIM    
C                          DECLARED FIRST (ROW) DIMENSION OF CLU IN THE  
C                          CALLING PROGRAM.    
C    
C                        CLU    
C                          LU DECOMPOSITION MATRIX FROM SUBROUTINE    
C                          DECOMP.    
C    
C                        B    
C                          RIGHT HAND SIDE VECTOR (OF DIMENSION AT    
C                          LEAST N) OF CONSTANTS.    
C    
C                        IPS    
C                          VECTOR (OF DIMENSION AT LEAST N) FROM    
C                          SUBROUTINE DECOMP STORING ROW PERMUTATIONS   
C                          RESULTING FROM PIVOTING, WHERE IPS(K) = KTH  
C                          PIVOT ROW AFTER ROW INTERCHANGES FROM    
C                          PREVIOUS PIVOTS.    
C    
C ON OUTPUT              X    
C                          SOLUTION VECTOR (OF DIMENSION AT LEAST N).   
C                          IF VECTOR B NEED NOT BE SAVED, THEN THE    
C                          VECTOR B MAY BE USED AS THE SOLUTION VECTOR  
C                          IN THE CALL, I.E.,    
C                              CALL SOLVE (N,NDIM,CLU,B,IPS,B)    
C                          NOTE:  IF SUBROUTINE IMPRUV WILL BE USED, B  
C                                 MUST BE RETAINED.    
C    
C    
C COMMON BLOCKS          NONE    
C    
C I/O                    NONE    
C    
C PRECISION              COMPLEX*16
C    
C REQUIRED ULIB          NONE    
C ROUTINES    
C    
C SPECIALIST             R. K. SATO, NCAR, BOULDER, COLORADO  80303    
C    
C LANGUAGE               FORTRAN    
C    
C HISTORY                TRANSCRIBED FROM A PAPER BY C. B. MOLER,    
C                        LINEAR EQUATION SOLVER, COMM. ACM 15    
C                        (APRIL, 1972), 74.    
C    
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION IPS(NDIM)
C   
      COMPLEX*16 CLU(NDIM,NDIM)
      COMPLEX*16 B(NDIM),X(NDIM)  
      COMPLEX*16 T  
C    
C    
C    
C    
C    
      DO 101 K=1,N    
         X(K) = B(K)    
  101 CONTINUE    
  102 IF (N .EQ. 1) GO TO 107    
      NM1 = N-1    
      DO 104 K=1,NM1    
         KP1 = K+1    
         M = IPS(K)    
         T = X(M)    
         X(M) = X(K)    
         X(K) = T    
         DO 103 I=KP1,N    
            X(I) = X(I)+CLU(I,K)*T    
  103    CONTINUE    
  104 CONTINUE    
      DO 106 KB=1,NM1    
         KM1 = N-KB    
         K = KM1+1    
         X(K) = X(K)/CLU(K,K)    
         T = -X(K)    
         DO 105 I=1,KM1    
            X(I) = X(I)+CLU(I,K)*T    
  105    CONTINUE    
  106 CONTINUE    
  107 X(1) = X(1)/CLU(1,1)    
      RETURN    
      END    
      SUBROUTINE IMPRUV (N,NDIM,A,CLU,B,IPS,X,R,DIGITS,IER)    
C    
C    
C DIMENSION OF           A(NDIM,N),CLU(NDIM,N),B(N),IPS(N),X(N),R(N)    
C ARGUMENTS    
C    
C PURPOSE                ITERATIVE IMPROVEMENT OF THE SOLUTION OBTAINED 
C                        FROM SUBROUTINE SOLVE.    
C    
C USAGE                  CALL IMPRUV (N,NDIM,A,CLU,B,IPS,X,R,DIGITS,IER) 
C    
C ARGUMENTS    
C    
C ON INPUT               N    
C                          ORDER OF MATRIX A (NUMBER OF EQUATIONS).    
C    
C                        NDIM    
C                          DECLARED FIRST (ROW) DIMENSIONS OF A AND CLU  
C                          IN THE CALLING PROGRAM.    
C    
C                        A    
C                          ORIGINAL COEFFICIENT MATRIX.    
C    
C                        CLU    
C                          LU DECOMPOSITION MATRIX OF A FROM SUBROUTINE 
C                          DECOMP.    
C    
C                        B    
C                          ORIGINAL RIGHT HAND SIDE VECTOR (OF DIMENSION
C                          AT LEAST N) OF CONSTANTS.    
C    
C                        IPS    
C                          VECTOR (OF DIMENSION AT LEAST N) FROM    
C                          SUBROUTINE DECOMP STORING ROW PERMUTATIONS   
C                          RESULTING FROM PIVOTING, WHERE IPS(K) = KTH  
C                          PIVOT ROW AFTER ROW INTERCHANGES FROM    
C                          PREVIOUS PIVOTS.    
C    
C                        X    
C                          SOLUTION VECTOR (OF DIMENSION AT LEAST N)    
C                          FROM SUBROUTINE SOLVE.    
C    
C                        R    
C                          WORK ARRAY (OF DIMENSION AT LEAST N) USED IN 
C                          THE COMPUTATION OF RESIDUALS.    
C    
C ON OUTPUT              X    
C                          SOLUTION VECTOR AFTER ITERATIVE IMPROVEMENT. 
C    
C                        DIGITS    
C                          APPROXIMATE NUMBER OF CORRECT DIGITS IN X.   
C    
C                        IER    
C                          ERROR FLAG USED BY STANDARD ERROR MESSAGE    
C                          ROUTINE ULIBER AND RETURNED TO USER.    
C                          = 0,  NO ERROR.    
C                          = 1,  NO CONVERGENCE IN THE ITERATION.    
C    
C COMMON BLOCKS          NONE    
C    
C I/O                    NOME
C    
C PRECISION              COMPLEX*16
C    
C REQUIRED ULIB          NONE    
C ROUTINES    
C    
C SPECIALIST             R. K. SATO, NCAR, BOULDER, COLORADO  80303    
C    
C LANGUAGE               FORTRAN    
C    
C HISTORY                TRANSCRIBED FROM FORSYTHE AND MOLER, COMPUTER  
C                        SOLUTIONS OF LINEAR ALGEBRAIC SYSTEMS, 1967.   
C    
C    
C    
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION IPS(NDIM)
C
      REAL*8 EPS,DIGITS,XNORM,DXNORM
C
      COMPLEX*16 A(NDIM,NDIM),CLU(NDIM,NDIM)    
      COMPLEX*16 B(NDIM),X(NDIM),R(NDIM)
      COMPLEX*16 SUM,T   
C
C      
C EPS AND ITMAX ARE MACHINE DEPENDENT CONSTANTS.    
C EPS = LARGEST FLOATING POINT NUMBER SUCH THAT 1.0 + EPS = 1.0    
C ITMAX = NUMBER OF BINARY BITS IN THE MANTISSA OF A FLOATING POINT    
C         NUMBER AND IS THE MAXIMUM NUMBER OF ITERATIONS.    
      DATA EPS,ITMAX/1.E-15,48/    
C    
      IER = 0    
      XNORM = 0.0    
      DO 101 I=1,N    
         XNORM = DMAX1(XNORM,CDABS(X(I)))    
  101 CONTINUE    
      IF (XNORM .GT. 0.0) GO TO 102    
      DIGITS = -DLOG10(EPS)    
      GO TO 108    
  102 DO 107 ITER=1,ITMAX    
C    
C CALCULATION OF DOUBLE PRECISION RESIDUALS.    
C    
         DO 104 I=1,N    
            SUM = 0.0    
            DO 103 J=1,N    
               SUM = SUM+A(I,J)*X(J)    
  103       CONTINUE    
            SUM = B(I)-SUM    
            R(I) = SUM    
  104    CONTINUE    
         CALL SOLVE (N,NDIM,CLU,R,IPS,R)    
         DXNORM = 0.0    
         DO 105 I=1,N    
            T = X(I)    
            X(I) = X(I)+R(I)    
            DXNORM = DMAX1(DXNORM,CDABS(X(I)-T))    
  105    CONTINUE    
         IF (ITER .GT. 1) GO TO 106    
         DIGITS = -DLOG10(DMAX1(DXNORM/XNORM,EPS))    
  106    IF (DXNORM .LE. EPS*XNORM) GO TO 108    
  107 CONTINUE    
C    
C ITERATION DID NOT CONVERGE    
C    
      IER = 1    
  108 CONTINUE    
      RETURN    
C    
C REVISION HISTORY---    
C    
C JUNE 1977        REMOVED REFERENCE TO THE  LOC  FUNCTION    
C                  TO ENHANCE PORTABILITY.    
C    
C JANUARY 1978     DELETED REFERENCES TO THE  *COSY  CARDS, MOVED    
C                  THE REVISION HISTORIES TO APPEAR BEFORE THE    
C                  FINAL END CARD, AND MOVED THE INITIAL COMMENT    
C                  CARDS TO APPEAR AFTER THE FIRST SUBROUTINE CARD    
C JANUARY 1979     REMOVED COMMENTS ABOUT LOC FUNCTION.    
C-----------------------------------------------------------------------
      END    

      SUBROUTINE SEARCH(JREG,RKM,H1,H2,M,ZZ,EGVL,FNORM,EGVR,NATEN,NDPTH,
     1                   IEIG,IPRT,MX,EGV)
C
C     THIS SUBROUTINE ORGANIZES THE LOGIC FOR FINDING THE EIGEN VALUES
C
C     IEIG=1 - USE THE EIGEN VALUES IN THE PREVIOUS REGION TO START.
C               IEIG IS IGNORED I ON THE FIRST PASS AND NATEN IS USED.
C               IN SUBSEQUENT REGIONS IEIG TAKES PRIORITY AND NATEN IS
C               IGNORED.
C
C     IEIG=0 - ALWAYS START WITH EIGEN VALUES OF REAL PROBLEM AND USE
C              NATEN.
C
C
C     NATEN .GT. 1 - INTRODUCE THE ATENUATION A LITTLE (DATEN=
C                    ATEN/NATEN) AT A TIME STARTING FROM THE REAL PROB.
C
C     NATEN=0 OR 1 - OMIT INCREMENTAL APPROACH BUT START FROM REAL PROB.
C
C
C     NDPTH .GT. 1 - IF MULTIPLE EIGEN VALUES ARE
C                    INCOUNTERED WITH IEIG=1 START SEARCH AGAIN AND
C                    INTRODUCE THE DEPTH STEP H2-H1 A LITTLE ( (H2-H1)/
C                    NDPTH ) AT A TIME STARTING WITH THE EIGEN VALUES
C                    OF THE PREVIOUS REGION.
C
C     NDPTH=1      - OMIT INCREMENTAL APPROACH WITH DEPTH BUT USE THE
C                    EIGEN VALUES OF THE PREVIOUS REGION TO START.
C
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 ZZ(MX),ERMAX
      COMPLEX*16 EGVL(MX),FNORM(MX),EGVR(MX)
      COMPLEX*16 GAMA,EGV(MX),CDSRT,ONE
      COMPLEX*16 CKH,CSH
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      ONE=DCMPLX(1.0D0,0.0D0)
C
      IF(IPRT .GE. 1) WRITE(9,40) JREG,RKM
   40 FORMAT(1H0,41HSEARCH FOR COMPLEX EIGEN VALUES IN REGION,I5,
     1           10H ENDING AT,F10.3,11H KM ENTERED)
C
      IF((JREG .GT. 1) .AND. (IEIG .EQ. 1)) GO TO 400
C
   50 CONTINUE
C
      IF(NATEN .LE.1) GO TO 100
C
      DATEN=ATEN/NATEN
      ATEN=DATEN
C
  100 CONTINUE
C
C
      CALL EGNVAL(H2,M,ZZ,MX)
      CALL PTURB(H2,M,ZZ,EGVR,MX)
      CALL CEGV(H2,M,EGVR,MX,ERMAX)
C
C
      IF(NATEN .LE. 1) GO TO 300
C
      NATM1=NATEN-1
      DO 200 JA=1,NATM1
C
C
      CALL CPTURB(H2,M,EGVR,DATEN,MX)
      CALL CEGV(H2,M,EGVR,MX,ERMAX)
C
C
  200 CONTINUE
C
  300 CONTINUE
C
C
      CALL CHECK(M,EGVR,IABRT,MX)
C
C
      IF(IABRT .GT.0) GO TO 320
C
      GO TO 900
C
  320 CONTINUE
C
      WRITE(9,350) IABRT,JREG,RKM
  350 FORMAT(1X,I5,39H REDUNDANT EIGEN VALUES FOUND IN REGION,I5,
     1       16H ENDING AT RANGE,F10.3,3H KM)
C
      IFLAG=1
      CALL ABORTC(IFLAG)
C
C
  400 CONTINUE
C
C
      CALL CPTBH(M,H1,H2,EGVL,FNORM,EGVR,MX)
      CALL CEGV(H2,M,EGVR,MX,ERMAX)
C
C
      CALL CHECK(M,EGVR,IABRT,MX)
C
C
      IF(IABRT .EQ. 0) GO TO 900
C
      IF((IABRT .GT. 0) .AND. (NDPTH .LE.1)) GO TO 320
C
      DO 500 I=1,M
      EGV(I)=EGVL(I)
  500 CONTINUE
C
      DDEP=(H2-H1)/NDPTH
C
      DO 700 JD=1,NDPTH
C
      HL=H1+(JD-1)*DDEP
      HR=H1+JD*DDEP
C
C
      CALL CPTBH(M,HL,HR,EGV,FNORM,EGVR,MX)
      CALL CEGV(HR,M,EGVR,MX,ERMAX)
C
C
      IF(JD .EQ. NDPTH) GO TO 700
      DO 600 I=1,M
      EGV(I)=EGVR(I)
      FNORM(I)=GAMA(HL,EGV(I))
  600 CONTINUE
C
  700 CONTINUE
C
C
      CALL CHECK(M,EGVR,IABRT,MX)
C
C
C     AS A LAST RESORT TRY STARTING FROM THE REAL PROBLEM
C     AND USE NATEN
C
      IF(IABRT .GT. 0) GO TO 50
C
  900 CONTINUE
C
      IF(IPRT .GE. 1) WRITE(9,950) ERMAX
  950 FORMAT(1X, 70HSEARCH FOR COMPLEX EIGEN VALUES COMPLETED WITH MAXIM
     1UM RELATIVE ERROR=,E12.4/)
C
C     WRITE(9,*) ' '
C
      DO 1000 I=1,M
      FNORM(I)=GAMA(H2,EGVR(I))
C
C      CKH=FKB*CDSRT(ONE-EGVR(I))
C      WRITE(9,990) I,CKH
C  990 FORMAT(1X,I5,2G23.14)
C
 1000 CONTINUE
C
C      WRITE(9,*) ' '
C
C      OMEGA=CB*FKB
C      DO 1100 I=1,M
C      CKH=FKB*CDSRT(ONE-EGVR(I))
C      CSH=1000.0D0*CKH/OMEGA
C      WRITE(9,990) I,CSH
C 1100 CONTINUE
C
      RETURN
      END

      COMPLEX*16 FUNCTION CUPBW(H1,H2,ALPHA1,ALPHA2,BETA1,BETA2,
     1                           DEPB,RHOB,GRHOB,LHB,LH1B,MX)
C
C     THIS FUNCTION COMPUTES THE INTEGRAL OF TWO BASIC DEPTH
C     FUNCTIONS OVER THE BOTTOM FROM DEPB(1)=H2 TO HB, WEIGHTED
C     BY THE BOTTOM DENSITY PROFILE RHOB. THIS INTEVAL STRADDLES
C     THE DEPTH H1, WHICH IS THE WATER BOTTOM INTERFACE FOR THE 
C     FIRST DEPTH FUNCITON. THE LOGIC IS DESIGNED TO ACCOMODATE
C     THIS CHANGE AT H1, WHICH IS IN THE INTERVAL BETWEEN DEPB(LH1B) 
C     AND DEPW(LH1B+1). NOTE THAT H1 IS .GT. H2.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION DEPB(MX),RHOB(MX),GRHOB(MX)
      COMPLEX*16  CEXIWB,CEXIB
      COMPLEX*16  ALPHA1,ALPHA2,BETA1,BETA2
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      LH1BM1=LH1B-1
      LH1BP1=LH1B+1
      LHBM1=LHB-1
C
      CUPBW=DCMPLX(0.0,0.0)
C
      IF(LH1BM1 .LT. 1 ) GO TO 600
      DO 500 L=1,LH1BM1
      Z1=DEPB(L)
      Z2=DEPB(L+1)
      CUPBW=CUPBW+CEXIWB(H2,Z1,Z2,DEPB(L),RHOB(L),GRHOB(L),
     1          ALPHA1,ALPHA2,BETA1,BETA2)
  500 CONTINUE
  600 CONTINUE
C
      Z1=DEPB(LH1B)
      CUPBW=CUPBW+CEXIWB(H2,Z1,H1,DEPB(LH1B),RHOB(LH1B),GRHOB(LH1B),
     1          ALPHA1,ALPHA2,BETA1,BETA2)
C
      IF(LH1B .EQ. LHB) THEN
C
C     H1 IS IN THE LAYER WITH HB
C
      CUPBW=CUPBW+CEXIB(H1,H2,H1,HB,DEPB(LHB),RHOB(LHB),GRHOB(LHB),
     1          ALPHA1,ALPHA2,BETA1,BETA2)
C
      ELSE
C      
      Z2=DEPB(LH1BP1)
      CUPBW=CUPBW+CEXIB(H1,H2,H1,Z2,DEPB(LH1B),RHOB(LH1B),GRHOB(LH1B),
     1          ALPHA1,ALPHA2,BETA1,BETA2)
C
      IF(LHBM1 .LT. LH1BP1) GO TO 800
      DO 700 L=LH1BP1,LHBM1
      Z1=DEPB(L)
      Z2=DEPB(L+1)
      CUPBW=CUPBW+CEXIB(H1,H2,Z1,Z2,DEPB(L),RHOB(L),GRHOB(L),
     1          ALPHA1,ALPHA2,BETA1,BETA2)
  700 CONTINUE
  800 CONTINUE
C
      Z1=DEPB(LHB)
      CUPBW=CUPBW+CEXIB(H1,H2,Z1,HB,DEPB(LHB),RHOB(LHB),GRHOB(LHB),
     1          ALPHA1,ALPHA2,BETA1,BETA2)
C
      END IF
C
      RETURN
      END

      REAL*8 FUNCTION DREAL(Z)
C
C     THIS FUNCTION PROVIDES THE DOUBLE PRECISION REAL PART
C     OF A COMPLEX*16 NUMBER 
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 Z,CI
C
      CI=DCMPLX(0.0D0,1.0D0)
      DREAL=DIMAG(CI*Z)
C 
      RETURN
      END

      COMPLEX*16 FUNCTION CISP(AA,XA,BB,XB)
C
C     THIS FUNCTION IS USED TO EVALUATE THE INDEFINITE INTEGRAL OF
C     CDSIN(AA*XA)*CDSIN(BB*XB) WHERE XA AND XB EQUALS X OR X-HB.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 AA,BB,U,V
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      IF(CDABS(AA-BB)/FKB .LT. .5D-13) GO TO 200
C
      U=BB*CDSIN(AA*XA)*CDCOS(BB*XB)-AA*CDCOS(AA*XA)*CDSIN(BB*XB)
      V=AA**2-BB**2
      CISP=U/V
      GO TO 300
C
  200 CONTINUE
      U=CDCOS(AA*(XA-XB))*XA/2.0
      V=CDSIN(AA*(XA+XB))/(4.0*AA)
      CISP=U-V
C
  300 CONTINUE
C
      RETURN
      END

      COMPLEX*16 FUNCTION CUPB(H1,H2,ALPHA1,ALPHA2,BETA1,BETA2,
     1                         DEPB,RHOB,GRHOB,LHB,MX)
C
C     THIS FUNCTION COMPUTES THE INTEGRAL OF TWO BASIC DEPTH
C     FUNCTIONS OVER THE BOTTOM FROM DEPB(1) TO HB, WEIGHTED
C     BY THE BOTTOM DENSITY PROFILE RHOB
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION DEPB(MX),RHOB(MX),GRHOB(MX)
      COMPLEX*16  CEXIB
      COMPLEX*16  ALPHA1,ALPHA2,BETA1,BETA2
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      LHBM1=LHB-1
C
      CUPB=DCMPLX(0.0,0.0)
C     
      IF(LHBM1 .LT. 1 ) GO TO 320
      DO 300 L=1,LHBM1
      Z1=DEPB(L)
      Z2=DEPB(L+1)
      CUPB=CUPB+CEXIB(H1,H2,Z1,Z2,DEPB(L),RHOB(L),GRHOB(L),
     1          ALPHA1,ALPHA2,BETA1,BETA2)
  300 CONTINUE
  320 CONTINUE
      Z1=DEPB(LHB)
      CUPB=CUPB+CEXIB(H1,H2,Z1,HB,DEPB(LHB),RHOB(LHB),GRHOB(LHB),
     1          ALPHA1,ALPHA2,BETA1,BETA2)
C
C
      RETURN
      END

      COMPLEX*16 FUNCTION HK02(Z)
C
C     THIS FUNCTION COMPUTES THE FIRST TERM IN THE ASYMPTOTIC EXPANSION
C     OF THE HANKEL FUNCTION OF ORDER ZERO OF THE SECOND KIND.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 PI
C
      COMPLEX*16 CI,Z,U,V,CDSRT
C
      PI=2.0D0*DACOS(0.0D0)
      CI=DCMPLX(0.0D0,1.0D0)
C
      U=CDSRT(2.0/(PI*Z))
      IF(DIMAG(Z) .GT. 675.0D0) GO TO 50
      V=CDEXP(-CI*Z)*CDEXP(-CI*PI/4.0)
      GO TO 100
   50 CONTINUE
      STOP 'OVERFLOW IN HK02 - MAKE FIRST REGION SMALLER'
  100 CONTINUE
      HK02=U*V
C
      RETURN
      END

      COMPLEX*16 FUNCTION CIWB(H1,H2,ALPHA1,ALPHA2,BETA1,BETA2)
C
C     THIS FUNCTION EVALUATES THE PART OF THE CROSS COUPLING INTEGRAL
C     BETWEEN WATER AND SEDIMENT. 
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 ALPHA1,ALPHA2,BETA1,BETA2,Z,U,V,W
      COMPLEX*16 CSDS,CCDS
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
C      FOLLOWING LINE IS A BUG AND SHOULD BE REPLACED AS BELOW
CC      IF(H2 .LE. H1) GO TO 200
C
      IF(H2 .GE. H1) GO TO 200
      IF(CDABS(ALPHA1-BETA2) .LT. .5D-13) GO TO 100
C
      U=FKB**4*CDSIN(ALPHA2*H2)/(ALPHA1*ALPHA2)
      Z=ALPHA1**2-BETA2**2
      V=BETA2*CDSIN(ALPHA1*H1)*CCDS(H1,H2,BETA2)-
     1  ALPHA1*CDCOS(ALPHA1*H1)*CSDS(H1,H2,BETA2)
      W=BETA2*CDSIN(ALPHA1*H2)*CCDS(H2,H2,BETA2)-
     1  ALPHA1*CDCOS(ALPHA1*H2)
      CIWB=U*(V-W)/Z
      GO TO 300
C
  100 CONTINUE
C
      U=FKB**4*CDSIN(ALPHA2*H2)
      Z=ALPHA1*ALPHA2*CDSIN(ALPHA1*(H2-HB))
      V=CDCOS(ALPHA1*HB)*(H1-H2)/2.
      W=CDSIN(ALPHA1*(2.*H2-HB))-CDSIN(ALPHA1*(2.*H1-HB))      
      W=W/(4.*ALPHA1)
      CIWB=U*(V-W)/Z
      GO TO 300 
C
  200 CONTINUE
C
      CIWB=DCMPLX(0.0,0.0)           
C
  300 CONTINUE
C    
      RETURN
      END

      SUBROUTINE PROPM(M,RNG1,RNG2,EGVL,EGVR,CLR,CRL,R,MX,MXT2,
     1                  IOUT)
C
C     THIS SUBROUTINE COMPUTES THE COMPLEX PROPAGATOR MATRIX R
C     CORRESPONDING TO THE INTERVAL RNG1 TO RNG2.
C       
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 EGVL(MX),EGVR(MX),CRL(MX,MX),CLR(MX,MX)
      COMPLEX*16 R(MXT2,MXT2)
      COMPLEX*16 ONE,CI,FK1,FK2,FAC,U,V
      COMPLEX*16 CHDH,CJDJ,CDSRT
      COMPLEX*16 WJ,WH
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      ONE=DCMPLX(1.0,0.0)
      CI=DCMPLX(0.0,1.0)
C
C
      DO 200 II=1,M
C
      FK2=FKB*CDSRT(ONE-EGVR(II))
      FAC=2.*FK2
C
      DO 100 I=1,M
C
      FK1=FKB*CDSRT(ONE-EGVL(I))
C
      U=FK2*CRL(II,I)
      V=FK1*CLR(II,I)
C
C     IOUT =  0 KEEPS U AND V DESTINCT AND GIVES THE TWO WAY SOLUTION.
C 
C     IOUT = -1 ALSO KEEPS U AND V DESTINCT BUT GIVES AN APPROXIMATION
C     TO THE SINGLE SCATTER APPROXIMATION SEE: 'THE PROBLEM OF ENERGY 
C     CONSERVATION IN ONE WAY MODELS,'BY PORTER, JENSEN AND FERLA, 
C     JASA 89, PG. 1058-1067 (1991).
C
C     IOUT =  1 EQUATES U AND V AND GIVES THE ONE WAY SOLUTION.
C
      IF(IOUT .EQ. 1) V=U
C
      WJ=CJDJ(EGVL(I),RNG1,RNG2)
      WH=CHDH(EGVL(I),RNG1,RNG2)
      R(M+II,M+I)=(U+V)*WH/FAC
      R(M+II,I)=(U-V)*WJ/FAC
      R(II,M+I)=(U-V)*WH/FAC
      R(II,I)=(U+V)*WJ/FAC
C
  100 CONTINUE
  200 CONTINUE
C
      RETURN
      END

      SUBROUTINE MGS(T,Q,U,N,NX)
C
C     THIS SUBROUTINE DOES A MODIFIED GRAM-SCHMIDT DECOMPOSITION
C     T=Q*U WHERE Q IS UNITARY AND U IS UPPER TRIANGULAR. THE 
C     INPUT MATRIX T IS USED AS WORK SPACE AND ITS ORIGINAL VALUES
C     ARE NOT PRESERVED. 
C   
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 T(NX,NX),Q(NX,NX),U(NX,NX),CPROD
      REAL*8 AMP
C
      DO 50 I=1,N
      DO 50 II=1,N
      U(II,I)=DCMPLX(0.0D0,0.0D0)
   50 CONTINUE
C
      U(1,1)=DCMPLX(AMP(T(1,1),N),0.0D0)
      DO 100 II=1,N
      Q(II,1)=T(II,1)/U(1,1)
  100 CONTINUE
C
      NM1=N-1
      DO 500 I=1,NM1
      IP1=I+1
C
      DO 400 J=IP1,N
      U(I,J)=CPROD(T(1,J),Q(1,I),N)
C 
      DO 300 II=1,N
      T(II,J)=T(II,J)-U(I,J)*Q(II,I)
  300 CONTINUE
C
  400 CONTINUE
C
      U(IP1,IP1)=DCMPLX(AMP(T(1,IP1),N),0.0D0)
      DO 450 II=1,N
      Q(II,IP1)=T(II,IP1)/U(IP1,IP1)
  450 CONTINUE
C
  500 CONTINUE
C
      RETURN
      END
C
      COMPLEX*16 FUNCTION CPROD(V1,V2,N)
C  
C     THIS FUNCTION COMPUTES THE COMPLEX SCALAR PRODUCT OF THE 
C     VECTORS V1 AND V2 (V1 DOT CONJG(V2)).
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 V1(N),V2(N)
C
      CPROD=DCMPLX(0.D0,0.D0)
      DO 100 I=1,N
      CPROD=CPROD+V1(I)*DCONJG(V2(I))
  100 CONTINUE
C
      RETURN
      END
C
      REAL*8 FUNCTION AMP(V1,N)
C  
C     THIS FUNCTION COMPUTES THE AMPLITUDE OF THE COMPLEX 
C     VECTORS V1. 
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 V1(N)
C
      AMP=0.D0
      DO 100 I=1,N
      AMP=AMP+CDABS(V1(I))**2
  100 CONTINUE
C
      AMP=DSQRT(AMP)
C
      RETURN
      END

      COMPLEX*16 FUNCTION CEXIWB(H2,Z1,Z2,DEPB,RHOB,GRHOB,
     1                          ALPHA1,ALPHA2,BETA1,BETA2)
C
C     THIS FUNCTION EVALUATES THE CROSS COUPLING INTEGRAL OF 
C     TWO BASIC DEPTH FUNCTIONS OVER THE INTERVAL Z1 TO Z2 
C     WITH WATER ON ONE SIDE AND THE BOTTOM ON THE SECOND. 
C     THE INTEGRAL IS WEIGHTED BY AN EXPONENTIAL DENSITY PROFILE.
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      COMPLEX*16 ALPHA1,ALPHA2,BETA1,BETA2
      COMPLEX*16 B2,CFAC,CGRHOB,CI
      COMPLEX*16 U,V,W,X
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      CI=DCMPLX(0.0D0,1.0D0)
      CGRHOB=DCMPLX(GRHOB,0.0D0)
      THBMH2=2.0D0*HB-H2
C
      CEXIWB=CMPLX(0.0D0,0.0D0)
      IF(Z2 .LE. Z1) GO TO 200
C
      CFAC=FKB**4*CDSIN(ALPHA2*H2)/(2.0D0*CI*RHOB*ALPHA1*ALPHA2)
C
      B2=2.0D0*BETA2*(HB-H2)
      IF(DIMAG(B2) .LT. 88.0D0) THEN
      CFAC=CFAC/(1.0D0-CDEXP(CI*B2))
      END IF
C
      W=CI*(ALPHA1+BETA2)-CGRHOB
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(CI*(ALPHA1*Z2+BETA2*(Z2-H2))-CGRHOB*(Z2-DEPB))
      V=CDEXP(CI*(ALPHA1*Z1+BETA2*(Z1-H2))-CGRHOB*(Z1-DEPB))
      CEXIWB=CEXIWB+(U-V)/W
      ELSE 
      X=CDEXP(CI*(ALPHA1*DEPB+BETA2*(DEPB-H2)))
      CEXIWB=CEXIWB+X*(Z2-Z1)
      END IF
C
      W=CI*(ALPHA1-BETA2)-CGRHOB
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(CI*(ALPHA1*Z2+BETA2*(THBMH2-Z2))-CGRHOB*(Z2-DEPB))
      V=CDEXP(CI*(ALPHA1*Z1+BETA2*(THBMH2-Z1))-CGRHOB*(Z1-DEPB))
      CEXIWB=CEXIWB-(U-V)/W
      ELSE 
      X=CDEXP(CI*(ALPHA1*DEPB+BETA2*(THBMH2-DEPB)))
      CEXIWB=CEXIWB-X*(Z2-Z1)
      END IF
C
      W=CI*(BETA2-ALPHA1)-CGRHOB
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(CI*(BETA2*(Z2-H2)-ALPHA1*Z2)-CGRHOB*(Z2-DEPB))
      V=CDEXP(CI*(BETA2*(Z1-H2)-ALPHA1*Z1)-CGRHOB*(Z1-DEPB))
      CEXIWB=CEXIWB-(U-V)/W
      ELSE 
      X=CDEXP(CI*(BETA2*(DEPB-H2)-ALPHA1*DEPB))
      CEXIWB=CEXIWB-X*(Z2-Z1)
      END IF
C
      W=-CI*(ALPHA1+BETA2)-CGRHOB
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(CI*(BETA2*(THBMH2-Z2)-ALPHA1*Z2)-CGRHOB*(Z2-DEPB))
      V=CDEXP(CI*(BETA2*(THBMH2-Z1)-ALPHA1*Z1)-CGRHOB*(Z1-DEPB))
      CEXIWB=CEXIWB+(U-V)/W
      ELSE 
      X=CDEXP(CI*(BETA2*(THBMH2-DEPB)-ALPHA1*DEPB))
      CEXIWB=CEXIWB+X*(Z2-Z1)
      END IF
C
      CEXIWB=CFAC*CEXIWB
C
  200 CONTINUE
C
      RETURN
      END

      COMPLEX*16 FUNCTION CEXIBD(HW,Z1,Z2,DEPB,RHOB,GRHOB,
     1                          ALPHA1,ALPHA2,BETA1,BETA2)
C
C     THIS FUNCTION EVALUATES THE INTEGRAL OF THE PRODUCT OF
C     THE DERIVATIVES OF TWO BASIC DEPTH FUNCTIONS OVER THE 
C     INTERVAL Z1 TO Z2 IN THE BOTTOM, WEIGHTED BY AN EXPONENTIAL
C     DENSITY PROFILE.
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      COMPLEX*16 ALPHA1,ALPHA2,BETA1,BETA2
      COMPLEX*16 B1,B2,CFAC,CGRHOB,CI
      COMPLEX*16 U,V,W,X
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      CI=DCMPLX(0.0D0,1.0D0)
      CGRHOB=DCMPLX(GRHOB,0.0D0)
      THBMHW=2.0D0*HB-HW
C
C     THE FOLLOWING INCLUDES A FACTOR OF 1/FKB**2 TO MAKE 
C     THE INTEGRAL NONDIMENSIONAL
C
      CFAC=-FKB**2*(CDSIN(ALPHA1*HW)*CDSIN(ALPHA2*HW)*
     1     BETA1*BETA2)/(RHOB*ALPHA1*ALPHA2)
C
      B1=2.0D0*BETA1*(HB-HW)
      IF(DIMAG(B1) .LT. 88.0D0) THEN
      CFAC=CFAC/(1.0D0-CDEXP(CI*B1))
      END IF
C
      B2=2.0D0*BETA2*(HB-HW)
      IF(DIMAG(B2) .LT. 88.0D0) THEN
      CFAC=CFAC/(1.0D0-CDEXP(CI*B2))
      END IF
C
      CEXIBD=CMPLX(0.0D0,0.0D0)
C
      W=CI*(BETA1+BETA2)-CGRHOB
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(CI*(BETA1+BETA2)*(Z2-HW)-CGRHOB*(Z2-DEPB))
      V=CDEXP(CI*(BETA1+BETA2)*(Z1-HW)-CGRHOB*(Z1-DEPB))
      CEXIBD=CEXIBD+(U-V)/W
      ELSE 
      X=CDEXP(CI*(BETA1+BETA2)*(DEPB-HW))
      CEXIBD=CEXIBD+X*(Z2-Z1)
      END IF
C
      W=CI*(BETA1-BETA2)-CGRHOB
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(CI*(BETA1*(Z2-HW)+BETA2*(THBMHW-Z2))-CGRHOB*(Z2-DEPB))
      V=CDEXP(CI*(BETA1*(Z1-HW)+BETA2*(THBMHW-Z1))-CGRHOB*(Z1-DEPB))
      CEXIBD=CEXIBD+(U-V)/W
      ELSE 
      X=CDEXP(CI*(BETA1*(DEPB-HW)+BETA2*(THBMHW-DEPB)))
      CEXIBD=CEXIBD+X*(Z2-Z1)
      END IF
C
      W=CI*(BETA2-BETA1)-CGRHOB
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(CI*(BETA2*(Z2-HW)+BETA1*(THBMHW-Z2))-CGRHOB*(Z2-DEPB))
      V=CDEXP(CI*(BETA2*(Z1-HW)+BETA1*(THBMHW-Z1))-CGRHOB*(Z1-DEPB))
      CEXIBD=CEXIBD+(U-V)/W
      ELSE 
      X=CDEXP(CI*(BETA2*(DEPB-HW)+BETA1*(THBMHW-DEPB)))
      CEXIBD=CEXIBD+X*(Z2-Z1)
      END IF
C
      W=-CI*(BETA1+BETA2)-CGRHOB
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(CI*(BETA1+BETA2)*(THBMHW-Z2)-CGRHOB*(Z2-DEPB))
      V=CDEXP(CI*(BETA1+BETA2)*(THBMHW-Z1)-CGRHOB*(Z1-DEPB))
      CEXIBD=CEXIBD+(U-V)/W
      ELSE 
      X=CDEXP(CI*(BETA1+BETA2)*(THBMHW-DEPB))
      CEXIBD=CEXIBD+X*(Z2-Z1)
      END IF
C
      CEXIBD=CFAC*CEXIBD
      RETURN
      END

      SUBROUTINE INPUT(TITLE,FREQ,M,N,IPRT,IOUT,BSOUT,NSDEP,NDEP,
     1                 NATEN,NDPTH,IEIG,IMAT,RANGE,DEPTH,NREG,MAMP,
     2                 ZS,ZSD,RMIN,RMAX,RINC,ZR,NDINC,MD,NRX,
     3                 RANG,DPTH,IRLIN,IREIG,MX,  
     4                 DEPW,SVPW,DBPWLW,CGRADW,CINTW,RHOW,GRHOW,
     5                 DEPB,SVPB,DBPWLB,CGRADB,CINTB,RHOB,GRHOB,
     6                 NEWSVP,LUSVP)
C
C     THIS SUBROUTINE READS THE INPUT, GENERATES THE INDEX OF REFRACTION
C     TABLES, STORES THE INDEX OF REFRACTION TABLES ON DISK (LUSVP), 
C     INTERPOLATES OR EXTENDS THE BATHYMETRY, COMPUTES AN ESTIMATE 
C     OF THE SUB BOTTOM REFLECTED FIELD (IN THE TWO ISOSPEED LAYERS CASE
C     ONLY) AND GENERATES THE SOURCE AND RECEIVER DEPTHS.
C       
C     IMAT IS THE FLAG WHICH CONTROLS HOW THE COMPLEX EIGENVALUES
C     ARE FOUND AND HOW THE DEPTH FUNCTIONS ARE CONSTRUCTED.
C     IF NSVP(1) .LT. 2 (THERE ARE TWO ISOSPEED LAYERS) THEN IMAT=0.
C     THE EIGENVALUES ARE FOUND IN SUBROUTINE SEARCH AND THE ANALYTIC
C     FORM OF THE DEPTH FUNCTIONS IS USED. IF NSVP(1) .GE. 2 A SOUND
C     SPEED PROFILE IN THE WATER AND A SOUND SPEED AND ATTUNUATION 
C     PROFILE IN THE BOTTOM ARE INPUT (BOTH LAYERS MAY BE NONHOMO-
C     GENEOUS) THEN IMAT=1. THE EIGENVALUES ARE FOUND BY THE GALERKIN
C     MATRIX METHOD IN SUBROUTINE GALRKN. THE DEPTH FUNCTIONS ARE 
C     CONSTRUCTED FROM THE MATRIX EIGENVECTORS.     
C     
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER BSOUT
      DIMENSION RANGE(NRX),DEPTH(NRX)
      DIMENSION ZSD(MD),ZR(MD)
      DIMENSION DEPW(MX),SVPW(MX),DBPWLW(MX),RHOW(MX),GRHOW(MX)
      DIMENSION DEPB(MX),SVPB(MX),DBPWLB(MX),RHOB(MX),GRHOB(MX)
      DIMENSION RANG(NRX),DPTH(NRX),IRLIN(NRX),IREIG(NRX)
C
      COMPLEX*16 CGRADW(MX),CINTW(MX)
      COMPLEX*16 CGRADB(MX),CINTB(MX)
      COMPLEX*16 CI,ONE,FKH,FKVS,FKVW
      COMPLEX*16 CXP
      COMPLEX*16 CDSRT
      COMPLEX*16 CDEM
      COMPLEX*16 CKB,PREFL,CPG
C
      CHARACTER*10 TITLE(8)
      CHARACTER*3 NEWSVP(NRX) 
C
      COMMON /BLKEVN/ HB,CW1,CB,FKW,FKB,ROHW,ROHB,ATEN
      COMMON/FLAGS/IGEOM,NEWSBC
C
      PI=2.*ACOS(0.0)
      CI=DCMPLX(0.0,1.0)
      ONE=DCMPLX(1.0,0.0)
      NREG=0
C
C     READ INPUT 
C
      WRITE(9,50)
   50 FORMAT(1H1)
      READ(5,100) (TITLE(I),I=1,8)
  100 FORMAT(8A10)
      WRITE(6,110) (TITLE(I),I=1,8)
      WRITE(9,110) (TITLE(I),I=1,8)
  110 FORMAT(1X,8A10/)
C
      READ(5,*) HB,FREQ,ROHW,ROHB,DBPWL
      WRITE(6,120) HB,FREQ,ROHW,ROHB,DBPWL
      WRITE(9,120) HB,FREQ,ROHW,ROHB,DBPWL
  120 FORMAT(1X,'HB=',F10.2,2X,'FREQ=',F10.2,2X,'ROHW=',F10.2,2X,
     1       'ROHB=',F10.2,2X,/,1X,'DBPWL=',E14.6,/)
C
      WRITE(9,125)
  125 FORMAT(/)
      READ(5,*) CB,CW1
      WRITE(6,130) CB,CW1
      WRITE(9,130) CB,CW1
  130 FORMAT(1X,'CB=',4PE16.7,2X,'CW=',4PE16.7,2X,/)
      WRITE(9,125)
C
C     FIND THE WAVE NUMBER IN THE BOTTOM
C
      FKB=2.0*PI*FREQ/CB
      WRITE(6,140) FKB   
      WRITE(9,140) FKB   
  140 FORMAT(1X,/,1X,'THE WAVE NUMBER IN THE BOTTOM= ',1P,
     1       E13.5,1X,'1/M'/)
C
C     CONVERT THE ATTENUATION IN THE BOTTOM (DBPWL) TO AN 
C     IMAGINARY PART OF THE SQUARE OF THE INDEX OF REFRACTION 
C     (ATEN).
C
      CALL ESPI(DBPWL,FREQ,CB,FKB,ATEN)
C
C
      WRITE(6,150) ATEN   
      WRITE(9,150) ATEN   
  150 FORMAT(1X,/,'THE IMAGINARY PART OF THE SQUARE OF THE ',
     1       'COMPLEX INDEX OF REFRACTION IN AN',/,1X,
     2       'ISOSPEED BOTTOM BASED ON DBPWL= ',1P,E13.5,///)
C
C
      READ(5,*) M,NATEN,IEIG,NDPTH,IGEOM,NEWSBC
      IF(IGEOM .EQ. 0)   THEN
      WRITE(6,155)
      WRITE(9,155)
      ELSE
      WRITE(6,160)
      WRITE(9,160)
      IGEOM=1
      NEWSBC=1
      END IF
  155 FORMAT(1X,//,' ********  CYLINDRICAL GEOMETRY PROBLEM *******',/)   
  160 FORMAT(1X,//,' ********  PLANE GEOMETRY PROBLEM ******* ',/)   
C
      IF(NEWSBC .EQ. 0)   THEN
      WRITE(6,165)
      WRITE(9,165)
      ELSE
      WRITE(6,170)
      WRITE(9,170)
      NEWSBC=1
      END IF
  165 FORMAT(1X,/,'  ********* ',/,
     & '  OLD INITIAL SOURCE BOUNDARY CONDITIONS PROBLEM',
     & /,'  ********* ',/)
  170 FORMAT(1X,/,' ********',
     & '  NEW INITIAL SOURCE BOUNDARY CONDITIONS PROBLEM',
     & '  ******** ',/)
C
      WRITE(9,125)
      WRITE(6,180) M,NATEN,IEIG,NDPTH
      WRITE(9,180) M,NATEN,IEIG,NDPTH
  180 FORMAT(1X,2HM=,I5,3X,6HNATEN=,I5,3X,5HIEIG=,I5,3X,
     1       6HNDPTH=,I5,/)
C
C     READ SOURCE SPECIFICATIONS
C
      WRITE (6,125)
      READ(5,*) NSDEP,ZSMIN,ZSINC
      WRITE(6,190) NSDEP,ZSMIN,ZSINC
      WRITE(9,190) NSDEP,ZSMIN,ZSINC
  190 FORMAT(1X,'NSDEP= ',I5,5X,'ZSMIN=',F10.2,5X,'ZSINC= ',F10.2)
C
      IF(NSDEP .GT. MD) NSDEP=MD
      DO 200 J=1,NSDEP
      ZSD(J)=ZSMIN+(J-1)*ZSINC
  200 CONTINUE
C
C     FIND THE MIDPOINT OF THE SOURCE ARRAY
C
      ZS=(ZSD(1)+ZSD(NSDEP))/2.0D0
C
C     READ RECEIVER SPECIFICATIONS
C
      WRITE (6,125)
      READ(5,*) NDEP,ZMIN,ZINC
      WRITE(6,210) NDEP,ZMIN,ZINC
      WRITE(9,210) NDEP,ZMIN,ZINC
  210 FORMAT(1X,'NDEP= ',I5,5X,'ZMIN=',F10.2,5X,'ZINC= ',F10.2)
C
      IF(NDEP .GT. MD) NDEP=MD
      NDINC= 1 
C      NDINC=FLOAT(NDEP)/20.+.950001
      DO 240 J=1,NDEP
      ZR(J)=ZMIN+(J-1)*ZINC
  240 CONTINUE
C
      WRITE (6,125)
      READ(5,*) RMIN,RMAX,RINC
      WRITE(6,250) RMIN,RMAX,RINC
      WRITE(9,250) RMIN,RMAX,RINC
  250 FORMAT(1X,'RMIN= ',F10.3,5X,'RMAX= ',F10.3,5X,'RINC= ',F10.3)
C
      READ(5,*) N,IPRT,IOUT,MAMP
C
C     SET IOUT AND BSOUT
C
      IF(IOUT .GT. 0) THEN
C
C     ONE-WAY SOLUTION
C
      IOUT=1
      BSOUT=1
      ELSE IF(IOUT .LT. 0) THEN
C
C     SINGLE SCATTER APPROXIMATION
C
      IOUT=-1
      BSOUT=1
      ELSE
C
C     TWO-WAY SOLUTION
C
      IOUT=0
      BSOUT=0
      END IF
C
      WRITE (6,125)
      WRITE(6,270) N,IPRT,IOUT,MAMP
      WRITE(9,270) N,IPRT,IOUT,MAMP
  270 FORMAT(1X,'N=',I5,3X,'IPRT=',I5,3X,'IOUT=',I5,3X,
     1       'MAMP=',I5,/)
C
       IF(N .GT. NRX) THEN
       NRXX=NRX
       WRITE(9,280) N,NRXX
  280  FORMAT(1X,//,'  TOO MANY INPUT REGIONS  ',
     & /,' NUMBER OF REGIONS  : ',I5,
     & /,' MAX ALLOWED NUMBER : ',I5,
     & /,' EXECUTION IS TERMINATED ')
       STOP
       END IF 
C     WRITE(9,290) N
  290 FORMAT(1X,/,' ******',/,
     & ' THE BATHYMETRY AND SOUND VELOCITY PROFILES',
     & ' FOR THE ',I5,' INPUT REGION(S) ARE:',/,' ******',/)
C
      IMAT=0
      NRTOT=1
      IRLTOT=0
      IRETOT=0
C
      DO 500 J=1,N
C
      WRITE(6,310) J
      WRITE(9,310) J
  310 FORMAT(1X,///,'   REGION NO. ',I4,/)
C
      READ(5,*) RANG(J),IRLIN(J),DPTH(J),NPW,NPB,IREIG(J)
C
      IF(((NPW .LT. 2) .AND. (NPB .GE. 2)) .OR.
     1   ((NPW .GE. 2) .AND. (NPB .LT. 2))) THEN
      WRITE(6,*) 'SPECIFY AT LEAST TWO PROFILE POINTS IN',
     1            ' BOTH THE WATER AND BOTTOM' 
      WRITE(9,*) 'SPECIFY AT LEAST TWO PROFILE POINTS IN',
     1            ' BOTH THE WATER AND BOTTOM' 
      STOP 'INPUT BOTH WATER AND BOTTOM PROFILE'
      END IF
C
      IF( (NPW .LT. 2) .AND. (IMAT .GT. 0) ) THEN
      WRITE(6,*) 'DO NOT MIX SEARCH AND GALERKIN REGIONS' 
      WRITE(9,*) 'DO NOT MIX SEARCH AND GALERKIN REGIONS' 
      STOP 'INPUT PROFILE FOR EVERY REGION'
      END IF
C
      IRLTOT=IRLTOT+IRLIN(J)
      IRETOT=IRETOT+IREIG(J)
      IF( (IRLTOT .NE. 0) .AND. (IRETOT .NE. 0) ) THEN
      WRITE(9,*) ' IREIG OPTION NOT VALID WITH IRLIN .NE. ZERO',
     1           ' REVISE INPUT RUN STREAM '
      STOP
      END IF
C
      IF(J.LT.N)   THEN
      NRTOT=NRTOT+MAX(1,IRLIN(J))
      IF(NRTOT+N-J.GT.NRX)   THEN
      WRITE(9,*) ' TOO MANY REGIONS. REVISE INPUT RUN STREAM '
      STOP
      END IF
      END IF
      IF(NPW .LT. 2)   NPW=0
      IF(NPB .LT. 2)   NPB=0
      WRITE(LUSVP,*) NPW,NPB
      IF(NPW .GE. 2)   THEN
       IF(NPW .GT. MX) THEN
       MXP=MX
       WRITE(9,320) J,NPW,MXP
  320  FORMAT(1X,//,'  TOO MANY POINTS IN PROFILE NO. ',I5,
     & /,' NUMBER OF PROFILE POINTS : ',I5,
     & /,' MAX ALLOWED NUMBER : ',I5,
     & /,' EXECUTION IS TERMINATED ')
       STOP
       END IF 
C
C
C      ********** SET IMAT=1 **********
C
C
       IMAT=1
C
       WRITE(9,330) 
  330  FORMAT(1X,' THE SOUND VELOCITY-DENSITY PROFILE IN THE WATER',
     1        ' IS AS ','FOLLOWS:',//2X,'DEPTH (M) ',3X,
     2        'SOUND SPEED (M/SEC)',4X,
     3        'ATTENUATION (DB/WL)',4X,
     4        'DENSITY (GM/CM**3)',/)
C
       DO 340 K=1,NPW
       READ(5,*) DEPW(K),SVPW(K),DBPWLW(K),RHOW(K)
       WRITE(9,335) DEPW(K),SVPW(K),DBPWLW(K),RHOW(K)
  335  FORMAT(1X,F10.2,7X,F10.4,13X,F10.4,10X,F10.4)
  340  CONTINUE
C
       WRITE(9,125)
       WRITE(9,345) 
  345  FORMAT(1X,' THE SOUND VELOCITY-DENSITY PROFILE IN THE BOTTOM',
     1        ' IS AS ','FOLLOWS:',//2X,'DEPTH (M) ',3X,
     2        'SOUND SPEED (M/SEC)',4X,
     3        'ATTENUATION (DB/WL)',4X,
     4        'DENSITY (GM/CM**3)',/)
       DO 360 K=1,NPB
       READ(5,*) DEPB(K),SVPB(K),DBPWLB(K),RHOB(K)
       WRITE(9,335) DEPB(K),SVPB(K),DBPWLB(K),RHOB(K)
  360  CONTINUE
C
      END IF
C
      IF(IMAT .EQ. 0)   THEN
C      FIND THE WAVE NUMBER IN THE WATER
C
       FKW=2.0*PI*FREQ/CW1
       WRITE(6,365) FKW   
       WRITE(9,365) FKW   
  365  FORMAT(1X,/31H THE WAVE NUMBER IN THE WATER= ,1P,
     &        E13.5,4H 1/M/)
      ELSE
C
C      GENERATE COEFFICIENTS IN PIECEWISE LINEAR REPRESENTATION
C      OF THE SQUARE OF THE INDEX OF REFRACTION IN THE WATER AND
C      BOTTOM
C
       CALL CFACIN(FREQ,DEPW,SVPW,DBPWLW,CGRADW,CINTW,NPW,MX)
       CALL CFACIN(FREQ,DEPB,SVPB,DBPWLB,CGRADB,CINTB,NPB,MX)
C
C     FIND THE AVERAGE OF THE SQUARE OF THE INDEX OF REFRACTION
C     IN THE WATER
C
      H=DEPW(NPW)
      CALL AVGIN(DEPW,CGRADW,CINTW,NPW,MX,H,AVG,LHW)
C
C     COMPUTE THE AVERAGE SOUND SPEED AND CORRESPONDING WAVE NUMBER  
C
      CW=CB/SQRT(AVG)
      FKW=2.0*PI*FREQ/CW
C
      WRITE(9,125)
      WRITE(6,370) AVG,CW
      WRITE(9,370) AVG,CW
C
  370 FORMAT(1X,/' THE AVERAGE (INDEX OF REF.)**2 = ',E12.5,
     1       '  OR ',4PE12.5 ,' M/SEC')
C
      WRITE(6,375) FKW
      WRITE(9,375) FKW
  375 FORMAT(1X,' THE AVERAGE WAVE NUMBER IN THE WATER= ',1P,
     1        E13.5,' 1/M')
C
      WRITE(9,380)
      WRITE(6,380)
  380 FORMAT(1X,'THE PIECEWISE LINEAR (INDEX OF REF.)**2 ',
     1       'IN THE WATER IS AS FOLLOWS:',//2X,'DEPTH (M)',6X,
     2       '(INDEX OF REF.)**2',10X,'GRADIENT'/)
C
C     PRINT INDEX OF REFRACTION TABLE IN THE WATER,
C     DEFINE LOGARITHMIC GRADIENTS OF THE WATER DENSITY
C     AND WRITE RESULTS ON LUSVP FOR USE IN THE MAIN
C     PROGRAM COUPLE
C
      NPWM1=NPW-1
      DO 400 K=1,NPWM1
      GRHOW(K)=DLOG(RHOW(K+1)/RHOW(K))/(DEPW(K+1)-DEPW(K))
      WRITE(6,390) DEPW(K),CINTW(K)+CGRADW(K)*DEPW(K),CGRADW(K)
      WRITE(9,390) DEPW(K),CINTW(K)+CGRADW(K)*DEPW(K),CGRADW(K)
      WRITE(LUSVP,*) DEPW(K),CINTW(K),CGRADW(K),RHOW(K),GRHOW(K)
  390 FORMAT(1X,F10.2,2X,F10.4,E12.4,2X,2E12.4)
  400 CONTINUE
      WRITE(6,390) DEPW(NPW),CINTW(NPWM1)+CGRADW(NPWM1)*DEPW(NPW),
     1             CGRADW(NPW)
      WRITE(9,390) DEPW(NPW),CINTW(NPWM1)+CGRADW(NPWM1)*DEPW(NPW),
     1             CGRADW(NPW)
      WRITE(LUSVP,*) DEPW(NPW),CINTW(NPW),CGRADW(NPW),RHOW(NPW),
     1               GRHOW(NPW)
C
      WRITE(9,125)
      WRITE(6,125)
      WRITE(9,405)
      WRITE(6,405)
  405 FORMAT(1X,'THE PIECEWISE LINEAR (INDEX OF REF.)**2 ',
     1       'IN THE BOTTOM IS AS FOLLOWS:',//2X,'DEPTH (M)',6X,
     2       '(INDEX OF REF.)**2',10X,'GRADIENT'/)
      NPBM1=NPB-1
C
C     PRINT INDEX OF REFRACTION TABLE IN THE BOTTOM,
C     DEFINE LOGARITHMIC GRADIENTS OF THE BOTTOM DENSITY
C     AND WRITE RESULTS ON LUSVP FOR USE IN THE MAIN
C     PROGRAM COUPLE
C
      DO 420 K=1,NPBM1
      GRHOB(K)=DLOG(RHOB(K+1)/RHOB(K))/(DEPB(K+1)-DEPB(K))
      WRITE(6,390) DEPB(K),CINTB(K)+CGRADB(K)*DEPB(K),CGRADB(K)
      WRITE(9,390) DEPB(K),CINTB(K)+CGRADB(K)*DEPB(K),CGRADB(K)
      WRITE(LUSVP,*) DEPB(K),CINTB(K),CGRADB(K),RHOB(K),GRHOB(K)
  420 CONTINUE
      GRHOB(NPB)=GRHOB(NPBM1)
      WRITE(6,390) DEPB(NPB),CINTB(NPBM1)+CGRADB(NPBM1)*DEPB(NPB)
      WRITE(9,390) DEPB(NPB),CINTB(NPBM1)+CGRADB(NPBM1)*DEPB(NPB)
      WRITE(LUSVP,*) DEPB(NPB),CINTB(NPB),CGRADB(NPB),RHOB(NPB),
     1               GRHOB(NPB)
C
      END IF
C
      IF(J.EQ.1)   THEN
      IF(RANG(1).LT.1.0E-6)   THEN
      RANG(1)=1.0E-6
      WRITE(9,430)
  430 FORMAT(1X,/,' WARNING : RANGE TO END OF FIRST REGION HAS BEEN',
     & ' INCREASED TO 0.001 m ')
      END IF
      ELSE
       IF(RANG(J).LT.RANG(J-1))   THEN
       WRITE(9,*) ' ERROR : REVISE END OF REGION ',J
       STOP
      END IF
      END IF
C
      IF(DPTH(J).EQ.0.0)   THEN
      DPTH(J)=1.0E-6
      WRITE(9,*) ' WARNING : '
      WRITE(9,*)' WATER DEPTH IS INCREASED TO 1.E-6 M IN SECTOR ',J
      END IF
C
      WRITE(6,450) RANG(J),DPTH(J),IRLIN(J),IREIG(J)
      WRITE(9,450) RANG(J),DPTH(J),IRLIN(J),IREIG(J)
  450 FORMAT(1X,/,' ****** ',/,
     & ' RANGE, DEPTH OF CURRENT REGION, NUMBER OF',
     & ' SUBDIVISIONS FOR NEXT REGION AND SEQUENCE NUMBER',
     & ' FOR STORAGE OR RETRIEVAL OF EIGENVALUES: ',/,
     & 1X,F10.2,3X,F10.2,5X,I5,5X,I5,/,' ****** ',/)
C     
C     
  500 CONTINUE
C
      ENDFILE LUSVP
C
      WRITE(9,125)
C
C     GENERATE REPRESENTATION OF A SLOPING BOTTOM
C
      CALL BATHY(N,RANG,DPTH,IRLIN,RANGE,DEPTH,NREG,NRX,
     &            IMAT,NEWSVP)
C
C     EXTEND LAST REGION IF NECESSARY
C
      IF(RMAX .GT. RANGE(NREG)) RANGE(NREG)=RMAX
C
C     FIND THE COMPLEX WAVE NUMBER IN THE BOTTOM IN THE TWO
C     ISOSPEED LAYERS CASE
C
      IF(IMAT .EQ. 0) CKB=FKB*CDSRT(ONE+ATEN*CI)
C
C     PRINT RANGE,DEPTH AND THE STEEPEST DESCENT ESTIMATE OF THE
C     REFLECTED FIELD RESULTING FROM THE PRESSURE RELEASE SURFACE AT HB
C
      WRITE(6,510)
      WRITE(9,510)
  510 FORMAT(1X,'THE RANGE DEPTH PAIRS AND A STEEPEST DESCENT',
     1         ' ESTIMATE OF THE SUB-BOTTOM REFLECTED FIELD',
     2         ' (TWO ISOSPEED LAYERS CASE ONLY) ARE AS FOLLOWS:'/)
C
      NREG=MAX0(N,NREG)
      DO 600 J=1,NREG
C
      IF(IMAT .EQ. 0) THEN
C
C     COMPUTE THE SUB-BOTTOM REFLECTED FIELD IN THE TWO ISOSPEED
C     LAYER CASE. FIRST FIND COVERSION DIVISOR: CYLINDRICAL TO 
C     PLANE GEOMETRY
C
      IF( (IGEOM .EQ. 1) .AND. (J .EQ. 1) ) THEN
      CPG=CDSRT(CI*PI*CKB)*DCMPLX(BESSJ0(FKW),BESSY0(FKW))
      END IF
C
      H=DEPTH(J)
      RNG=1000.*RANGE(J)
      R=SQRT(RNG**2+4.*(HB-H)**2)
      FKH=CKB*RNG/R
      FKVS=CKB*2.*(HB-H)/R
      FKVW=CDSRT(FKW**2-FKH**2)
      IF(DIMAG(-CKB*R) .LT. -88.) GO TO 520
      CXP=CDEXP(CI*CKB*R)
      CDEM=FKVW*ROHB*CDCOS(FKVW*H)-CI*FKVS*ROHW*CDSIN(FKVW*H)
      PREFL=CXP/R
      PREFL=PREFL*4.0*ROHB*ROHW*(FKVS*CDSIN(FKVW*H)/CDEM)**2
C
C     ADJUST FOR PLANE GEOMETRY
C
      IF(IGEOM .EQ. 1) PREFL=SQRT(2.0*R)*PREFL/CPG
C
      IF(CDABS(PREFL)**2 .EQ. 0.0) GO TO 520
      TLREFL=-20.*LOG10(CDABS(PREFL))
C
      GO TO 530
  520 CONTINUE
      TLREFL=999.99D0
  530 CONTINUE
      ELSE
C
C     THE ESTIMATE OF THE SUBOTTOM REFLECTED FIELD IS ONLY
C     VALID FOR TWO ISOSPEED LAYERS. IT IS SET TO ZERO
C     IN ALL OTHER CASES.
C
      TLREFL=0.0D0
      END IF
C
      WRITE(6,550) J,RANGE(J),DEPTH(J),TLREFL
      WRITE(9,550) J,RANGE(J),DEPTH(J),TLREFL
  550 FORMAT(1X,I5,5X,F10.3,5X,F10.2,5X,F10.2)
C
  600 CONTINUE
C
C
      RETURN
      END

      SUBROUTINE CPTURB(H,M,EGV,DATEN,MX)
C
C     THIS SUBROUTINE COMPUTES AN ESTIMATE OF THE EIGEN VALUES (EGV ON
C     OUTPUT) OF THE PROBLEM WITH ATENUATION ATEN+DATEN BASED ON THE
C     EIGEN VALUES (EGV ON INPUT) OF THE PROBLEM WITH ATENUATION ATEN.
C
C     IT USES THE PERTURBATION METHOD ON PG. 228 IN PRINC. AND TECH.
C     OF APPLIED MATH BY B. FRIEDMAN
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 EGV(MX)
      COMPLEX*16 CDSRT,ONE,CI,CDTAN
      COMPLEX*16 ALPHA,BETA,A,B,X,Y,U,V
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      ONE=DCMPLX(1.0D0,0.0D0)
      CI=DCMPLX(0.0D0,1.0D0)
C
      DO 500 I=1,M
C
      ALPHA=CDSRT(FKW**2+FKB**2*(EGV(I)-ONE))
      BETA=CDSRT(FKB**2*(EGV(I)+CI*ATEN))
      A=ALPHA*H
      B=BETA*(H-HB)
      X=A-CDCOS(A)*CDSIN(A)
      IF(DIMAG(B) .LT. -44.0D0) GO TO 100
      Y=B/(CDSIN(B)**2)-1.0D0/CDTAN(B)
      GO TO 200
  100 CONTINUE               
      Y=-1.0D0/CDTAN(B)
  200 CONTINUE
C
      U=ROHW*ALPHA*CDSIN(A)**2*Y
      V=ROHB*BETA*X-ROHW*ALPHA*CDSIN(A)**2*Y
C
      EGV(I)=CI*DATEN*U/V+EGV(I)
C
  500 CONTINUE
C
      ATEN=ATEN+DATEN
C
C
      RETURN
      END

      SUBROUTINE PTURB(H,M,ZZ,EGV,MX)
C
C     THIS SUBROUTINE COMPUTES AN ESTIMATE OF THE EIGEN VALUES EGV OF
C     THE PROBLEM WITH ATEN .NE. ZERO BASED ON THE EIGEN VALUES ZZ OF
C     THE PROBLEM WITH ATEN=0.
C     IT USES THE PERTURBATION METHOD ON PG. 228 IN PRINC. AND TECH.
C     OF APPLIED MATH BY B. FRIEDMAN
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 ZZ(MX),ZERO
      REAL*8 ALPHA,BETA,A,B,X,Y,U,V,DELTA
      COMPLEX*16 EGV(MX)
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
C
      ZERO=DBLE(0.0)
      FKW2=FKW**2
      FKB2=FKB**2
      IF(ATEN .EQ. 0.0) GO TO 600
C
      DO 500 I=1,M
C
      ALPHA=DSQRT(FKW2+FKB2*(ZZ(I)-1.0))
      BETA=DSQRT(DABS(FKB2*ZZ(I)))
      A=ALPHA*H
      B=BETA*(H-HB)
C
      IF(ZZ(I) .LT. ZERO) GO TO 100
      IF(ZZ(I) .EQ. ZERO) GO TO 200
      IF(ZZ(I) .GT. ZERO) GO TO 300
C
  100 CONTINUE
C
C
      X=A-DCOS(A)*DSIN(A)
C
C     THE MAXIMUM ARGUMENT(88) FOR EXP IS MACHINE DEPENDENT
C
      IF(DABS(B) .GT. 44.) GO TO 120
      Y=B/(DSINH(B)**2)-1./DTANH(B)
      GO TO 150
  120 CONTINUE
      Y=-1./DTANH(B)
  150 CONTINUE
      U=ROHW*ALPHA*DSIN(A)**2*Y
      V=-ROHB*BETA*X-ROHW*ALPHA*DSIN(A)**2*Y
      DELTA=ATEN*U/V
C
      EGV(I)=DCMPLX(ZZ(I),DELTA)
C
      GO TO 500
C
  200 CONTINUE
C
      DELTA=DBLE(-ATEN)
C
      EGV(I)=DCMPLX(ZZ(I),DELTA)
C
      GO TO 500
C
  300 CONTINUE
C
C
      X=A-DCOS(A)*DSIN(A)
      Y=B-DCOS(B)*DSIN(B)
      U=ROHW*ALPHA*DSIN(A)**2*Y
      V=ROHB*BETA*DSIN(B)**2*X-ROHW*ALPHA*DSIN(A)**2*Y
      DELTA=ATEN*U/V
C
      EGV(I)=DCMPLX(ZZ(I),DELTA)
C
  500 CONTINUE
C
      GO TO 800
  600 CONTINUE
C
      DO 700 I=1,M
      EGV(I)=DCMPLX(ZZ(I),ZERO)
  700 CONTINUE
C
  800 CONTINUE
C
C
      RETURN
      END

      SUBROUTINE BATHY(N,RANG,DPTH,IRLIN,RANGE,DEPTH,NREG,NRX,
     &                  IMAT,NEWSVP)
C
C     THIS SUBROUTINE GENERATES A STEPWISE REPRESENTATION OF A SLOPING
C     BOTTOM. THE LOGIC DEPENDS ON IRLIN (IRLIN(N) IS NOT USED).
C
C     IRLIN(J) .LE. 0 - THE DEPTH CHANGES FROM DPTH(J) TO DPTH(J+1) AT 
C                       RANG(J).
C
C     IRLIN(J) .GE. 1 - IRLIN(J) STEPS ARE INTRODUCED IN THE INTERVAL 
C                       BETWEEN RANG(J) AND RANG(J+1). EACH STEP IS
C                       (RANG(J+1)-RANG(J))/IRLIN(J) LONG. THE MID-
C                       POINTS OF THE TOPS OF THE STEPS LIE ON THE 
C                       LINE BETWEEN (DPTH(J),RANG(J)) AND (DPTH(J+1),
C                       RANG(J+1)).
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION RANG(NRX),DPTH(NRX),IRLIN(NRX)
      DIMENSION RANGE(NRX),DEPTH(NRX)
      CHARACTER*3 NEWSVP(NRX)
C
      IF(IMAT .NE. 0) THEN
      DO 50 NR=1,NRX
      NEWSVP(NR)='OLD'
   50 CONTINUE
      END IF      
C
      IF(RANG(1) .LE. 0.0) RANG(1)=RANG(2)/2.0
      JJ=1
      RANGE(JJ)=RANG(1)
      DEPTH(JJ)=DPTH(1)
      IF(IMAT .NE. 0) NEWSVP(JJ)='NEW'
C
      DO 150 J=1,N-1
C
      IF(IMAT .NE. 0) NEWSVP(JJ+1)='NEW'
C
      IF(IRLIN(J) .GT. 0 )   THEN
C
C     GENERATE REPRESENTATION OF THE SLOPE
C
      DRNG=(RANG(J+1)-RANG(J))/IRLIN(J)
      DDEP=(DPTH(J+1)-DPTH(J))/IRLIN(J)
C
      DO 100 I=1,IRLIN(J)
      JJ=JJ+1
      RANGE(JJ)=RANG(J)+I*DRNG
      DEPTH(JJ)=DPTH(J)+(FLOAT(I-1)+0.5)*DDEP
  100 CONTINUE
      GO TO 150
C
      END IF
C
      JJ=JJ+1
      RANGE(JJ)=RANG(J+1)
      DEPTH(JJ)=DPTH(J+1)
C
  150 CONTINUE
C
      IF(IRLIN(N-1) .GT. 0)   THEN
      JJ=JJ+1
      DEPTH(JJ)=DPTH(N)
      RANGE(JJ)=RANG(N)+DRNG
      END IF
C
      NREG=JJ
C
      RETURN
      END

      SUBROUTINE CMMULT(M,R1,R2,R3,R4,S1,S2,S3,S4,MX,W1,W2,W3,W4)
C
C     THIS SUBROUTINE ACCUMULATES THE PRODUCT OF THE TRANSITION
C     MATRICES R (CONSISTING OF R1,R2,R3 AND R4) IN THE MATRIX S
C     (CONSISTING OF S1,S2,S3 AND S4).
C
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 R1(MX,MX),R2(MX,MX),R3(MX,MX),R4(MX,MX)
      COMPLEX*16 S1(MX,MX),S2(MX,MX),S3(MX,MX),S4(MX,MX)
      COMPLEX*16 W1(MX,MX),W2(MX,MX),W3(MX,MX),W4(MX,MX)
      COMPLEX*16 SUM1,SUM2,SUM3,SUM4,ZERO
C
C
      ZERO=DCMPLX(0.0,0.0)
C
      DO 300 II=1,M
      DO 200 I=1,M
C
      SUM1=ZERO
      SUM2=ZERO
      SUM3=ZERO
      SUM4=ZERO
C
      DO 100 K=1,M
C
      SUM1=SUM1+R1(II,K)*S1(K,I)+R2(II,K)*S3(K,I)
      SUM2=SUM2+R1(II,K)*S2(K,I)+R2(II,K)*S4(K,I)
      SUM3=SUM3+R3(II,K)*S1(K,I)+R4(II,K)*S3(K,I)
      SUM4=SUM4+R3(II,K)*S2(K,I)+R4(II,K)*S4(K,I)
C
  100 CONTINUE
C
      W1(II,I)=SUM1
      W2(II,I)=SUM2
      W3(II,I)=SUM3
      W4(II,I)=SUM4
C
  200 CONTINUE
  300 CONTINUE
C
      DO 600 II=1,M
      DO 500 I=1,M
C
      S1(II,I)=W1(II,I)
      S2(II,I)=W2(II,I)
      S3(II,I)=W3(II,I)
      S4(II,I)=W4(II,I)
C
  500 CONTINUE
  600 CONTINUE
C
      RETURN
      END

      SUBROUTINE CRSCUPB(H1,H2,M,EGVL,EGVR,CLR,CRL,MX,
     1                  BMATL,BMATR,W4,ALPHAR,BETAR,FNORMR,
     2                  ALPHAL,BETAL,FNORML,FKWL,FKWR,
     3                  ROHWL,NPWL,DEPWL,RHOWL,GRHOWL,LHWL,
     4                  ROHWR,NPWR,DEPWR,RHOWR,GRHOWR,LHWR,
     5                  ROHBL,NPBL,DEPBL,RHOBL,GRHOBL,LHBL,
     6                  ROHBR,NPBR,DEPBR,RHOBR,GRHOBR,LHBR)
C
C     THE FOLLOWING SUBROUTINE COMPUTES THE CROSS COUPLING BETWEEN THE
C     EIGEN FUNCTIONS CORRESPONDING TO EGVL AND THE EIGENFUNCTIONS
C     CORRESPONDING TO EGVR. THIS VERSION INCORPORATES A DENSITY 
C     PROFILE ON EACH SIDE OF THE VERTICAL INTERFACE THAT EXIBITS 
C     PIECEWISE EXPONENTIAL VARIATION IN BOTH THE WATER AND BOTTOM 
C     SEDIMENT LAYERS. 
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION DEPWL(MX),RHOWL(MX),GRHOWL(MX)
      DIMENSION DEPWR(MX),RHOWR(MX),GRHOWR(MX)
      DIMENSION DEPBL(MX),RHOBL(MX),GRHOBL(MX)
      DIMENSION DEPBR(MX),RHOBR(MX),GRHOBR(MX)
      COMPLEX*16  CI,ONE
      COMPLEX*16  CDSRT,CUPW,CUPB,CUPWB,CUPBW
      COMPLEX*16  BMATL(MX,MX),BMATR(MX,MX),W4(MX,MX)
      COMPLEX*16  EGVL(MX),EGVR(MX),CLR(MX,MX),CRL(MX,MX)
      COMPLEX*16  GAMA00,V
      COMPLEX*16  ALPHAR(MX), BETAR(MX), FNORMR(MX)
      COMPLEX*16  ALPHAL(MX), BETAL(MX), FNORML(MX)
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      ONE=DCMPLX(1.0,0.0)
      CI=DCMPLX(0.0,1.0)
      FKWL2=FKWL**2
      FKWR2=FKWR**2
      FKB2=FKB**2
C
      DO 50 I=1,M
C
      ALPHAL(I)=CDSRT(FKWL2+FKB2*(EGVL(I)-ONE))
      BETAL(I)=CDSRT(FKB2*EGVL(I))
      FNORML(I)=GAMA00(H1,ALPHAL(I),BETAL(I),HB,FKB,ROHWL,ROHBL)
C
      ALPHAR(I)=CDSRT(FKWR2+FKB2*(EGVR(I)-ONE))
      BETAR(I)=CDSRT(FKB2*EGVR(I))
      FNORMR(I)=GAMA00(H2,ALPHAR(I),BETAR(I),HB,FKB,ROHWR,ROHBR)
C
   50 CONTINUE
C     
      IF(H1 .GT. H2) THEN
C
C     THIS IS THE UPSLOPE CASE
C
C     FIND THE INDEX LLWH2 SUCH THAT H2 IS BETWEEN DEPWL(LLWH2)
C     AND DEPWL(LLWH2+1)
C
      LLWH2=INDEP(H2,DEPWL,NPWL,MX)
C
C     FIND THE INDEX LRBH1 SUCH THAT H1 IS BETWEEN DEPBR(LRBH1)
C     AND DEPBR(LRBH1+1)
C
      LRBH1=INDEP(H1,DEPBR,NPBR,MX)
C
      DO 550 I=1,M
      DO 500 II=1,M
C
C     UPSLOPE CASE
C
      CLR(II,I)=CUPWB(H1,H2,ALPHAL(I),ALPHAR(II),BETAL(I),BETAR(II),
     1          DEPWL,RHOWL,GRHOWL,LHWL,LLWH2,MX)
      CLR(II,I)=CLR(II,I)+CUPB(H1,H2,ALPHAL(I),ALPHAR(II),
     1          BETAL(I),BETAR(II),DEPBL,RHOBL,GRHOBL,LHBL,MX)
C
      CRL(II,I)=CUPW(H2,ALPHAL(I),ALPHAR(II),
     1               DEPWR,RHOWR,GRHOWR,LHWR,MX)
      CRL(II,I)=CRL(II,I)+CUPBW(H1,H2,ALPHAL(I),ALPHAR(II),
     1          BETAL(I),BETAR(II),DEPBR,RHOBR,GRHOBR,LHBR,LRBH1,MX)
C
C     CHANGED ORDER SQUARE ROOT AND MULTIPLICATION 6/8/96
C     FROM V=CDSRT(FNORML(I)*FNORMR(II)) TO:
C
      V=CDSRT(FNORML(I))*CDSRT(FNORMR(II))
      CLR(II,I)=CLR(II,I)/V
      CRL(II,I)=CRL(II,I)/V
C
  500 CONTINUE
  550 CONTINUE
C
      ELSE IF(H1 .LT. H2) THEN
C
C     THIS IS THE DOWNSLOPE CASE (H1 .LT. H2).
C
C     FIND THE INDEX LRWH1 SUCH THAT H1 IS BETWEEN DEPWR(LRWH1)
C     AND DEPWR(LRWH1+1)
C
      LRWH1=INDEP(H1,DEPWR,NPWR,MX)
C
C     FIND THE INDEX LLBH2 SUCH THAT H2 IS BETWEEN DEPBL(LLBH2)
C     AND DEPBL(LLBH2+1)
C
      LLBH2=INDEP(H2,DEPBL,NPBL,MX)
C
      DO 1050 I=1,M
      DO 1000 II=1,M
C
C     DOWN SLOPE CASE
C
      CLR(II,I)=CUPW(H1,ALPHAL(I),ALPHAR(II),
     1               DEPWL,RHOWL,GRHOWL,LHWL,MX)
      CLR(II,I)=CLR(II,I)+CUPBW(H2,H1,ALPHAR(II),ALPHAL(I),
     1          BETAR(II),BETAL(I),DEPBL,RHOBL,GRHOBL,LHBL,LLBH2,MX)
C
      CRL(II,I)=CUPWB(H2,H1,ALPHAR(II),ALPHAL(I),BETAR(II),BETAL(I),
     1          DEPWR,RHOWR,GRHOWR,LHWR,LRWH1,MX)
      CRL(II,I)=CRL(II,I)+CUPB(H1,H2,ALPHAL(I),ALPHAR(II),
     1          BETAL(I),BETAR(II),DEPBR,RHOBR,GRHOBR,LHBR,MX)
C
      V=CDSRT(FNORML(I))*CDSRT(FNORMR(II))
      CLR(II,I)=CLR(II,I)/V
      CRL(II,I)=CRL(II,I)/V
C
 1000 CONTINUE
 1050 CONTINUE
C
      ELSE
C
C     THIS IS THE NO SLOPE CASE (H1 .EQ. H2)
C
      DO 1550 I=1,M
      DO 1500 II=1,M
C
C     NO SLOPE CASE
C
      CLR(II,I)=CUPW(H1,ALPHAL(I),ALPHAR(II),
     1               DEPWL,RHOWL,GRHOWL,LHWL,MX)
      CLR(II,I)=CLR(II,I)+CUPB(H1,H1,ALPHAL(I),ALPHAR(II),
     1          BETAL(I),BETAR(II),DEPBL,RHOBL,GRHOBL,LHBL,MX)
      CRL(II,I)=CUPW(H1,ALPHAL(I),ALPHAR(II),
     1               DEPWR,RHOWR,GRHOWR,LHWR,MX)
      CRL(II,I)=CRL(II,I)+CUPB(H1,H1,ALPHAL(I),ALPHAR(II),
     1          BETAL(I),BETAR(II),DEPBR,RHOBR,GRHOBR,LHBR,MX)
C
      V=CDSRT(FNORML(I))*CDSRT(FNORMR(II))
      CLR(II,I)=CLR(II,I)/V
      CRL(II,I)=CRL(II,I)/V
C
 1500 CONTINUE
 1550 CONTINUE
C
      END IF
C
C     THIS IS THE MAIN ADVANTAGE OF THE GALERKIN PROCEDURE IN
C     A COUPLED MODE CALCULATION. THE COUPLING CAN BE DONE 
C     BETWEEN THE BASIC EIGENFUNCTIONS WHERE THE INTEGRALS 
C     ARE DONE EXACTLY, THEN THE TRUE COUPLING MATRIX IS 
C     OBTAINED BY MATRIX MULTIPLICATON
C
      CALL TMMULT(M,BMATR,CLR,BMATL,MX,W4)
      CALL TMMULT(M,BMATR,CRL,BMATL,MX,W4)
C
C
      RETURN
      END

      COMPLEX*16 FUNCTION CIW0(H1,H2,ALPHA1,ALPHA2)
C
C     THIS FUNCTION EVALUATES THE PART OF THE CROSS COUPLING INTEGRAL
C     IN THE WATER. THIS VERSION OMITS DIVISION BY ROHW.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 ALPHA1,ALPHA2,CISP,U,V
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      HMIN=DMIN1(H1,H2)
      U=FKB**4/(ALPHA1*ALPHA2)
      V=CISP(ALPHA1,HMIN,ALPHA2,HMIN)
      CIW0=U*V
C
      RETURN
      END

      COMPLEX*16 FUNCTION CEXIWD(Z1,Z2,DEPW,RHOW,GRHOW,
     1                          ALPHA1,ALPHA2)
C
C     THIS FUNCTION EVALUATES THE INTEGRAL OF THE PRODUCT OF THE
C     DERIVATIVES OF TWO BASIC DEPTH FUNCTIONS OVER THE INTERVAL 
C     Z1 TO Z2 IN THE WATER, WEIGHTED BY AN EXPONENTIAL DENSITY 
C     PROFILE.
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      COMPLEX*16 ALPHA1,ALPHA2
      COMPLEX*16 CFAC,CGRHOW,CI
      COMPLEX*16 U,V,W,X
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      CI=DCMPLX(0.0D0,1.0D0)
      CGRHOW=DCMPLX(GRHOW,0.0D0)
C
C     THE FOLLOWING INCLUDES A FACTOR OF 1/FKB**2 TO MAKE THE 
C     INTEGRAL NONDIMENSIONAL
C
      CFAC=FKB**2/(4.0D0*RHOW)
C
      CEXIWD=DCMPLX(0.0D0,0.0D0)
C
      W=CI*(ALPHA1+ALPHA2)-CGRHOW
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(CI*(ALPHA1+ALPHA2)*Z2-CGRHOW*(Z2-DEPW))
      V=CDEXP(CI*(ALPHA1+ALPHA2)*Z1-CGRHOW*(Z1-DEPW))
      CEXIWD=CEXIWD+(U-V)/W
      ELSE 
      X=CDEXP(CGRHOW*DEPW)
      CEXIWD=CEXIWD+X*(Z2-Z1)
      END IF
C
      W=CI*(ALPHA1-ALPHA2)-CGRHOW
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(CI*(ALPHA1-ALPHA2)*Z2-CGRHOW*(Z2-DEPW))
      V=CDEXP(CI*(ALPHA1-ALPHA2)*Z1-CGRHOW*(Z1-DEPW))
      CEXIWD=CEXIWD+(U-V)/W
      ELSE 
      X=CDEXP(CGRHOW*DEPW)
      CEXIWD=CEXIWD+X*(Z2-Z1)
      END IF
C
      W=CI*(ALPHA2-ALPHA1)-CGRHOW
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(CI*(ALPHA2-ALPHA1)*Z2-CGRHOW*(Z2-DEPW))
      V=CDEXP(CI*(ALPHA2-ALPHA1)*Z1-CGRHOW*(Z1-DEPW))
      CEXIWD=CEXIWD+(U-V)/W
      ELSE 
      X=CDEXP(CGRHOW*DEPW)
      CEXIWD=CEXIWD+X*(Z2-Z1)
      END IF
C
      W=-CI*(ALPHA1+ALPHA2)-CGRHOW
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(-CI*(ALPHA1+ALPHA2)*Z2-CGRHOW*(Z2-DEPW))
      V=CDEXP(-CI*(ALPHA1+ALPHA2)*Z1-CGRHOW*(Z1-DEPW))
      CEXIWD=CEXIWD+(U-V)/W
      ELSE 
      X=CDEXP(CGRHOW*DEPW)
      CEXIWD=CEXIWD+X*(Z2-Z1)
      END IF
C
      CEXIWD=CFAC*CEXIWD
      RETURN
      END

      COMPLEX*16 FUNCTION GAMA0(H,ALPHA,BETA)
C
C     THIS FUNCTION COMPUTES THE NORMALIZATION FACTOR FOR THE EIGEN-
C     FUNCTION CORRESPONDING TO THE VERTICAL WAVE NUMBERS ALPHA AND
C     BETA.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 ALPHA,BETA,U,V,W,Z,B
      COMPLEX*16 CI,ONE
      COMPLEX*16 CDSRT,CDTAN
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      ONE=DCMPLX(1.0D0,0.0D0)
      CI=DCMPLX(0.0D0,1.0D0)
C
      B=BETA*(H-HB)
      Z=FKB**2/ALPHA
      IF(DIMAG(B) .LT. -44.0D0) GO TO 100
      V=(B/(CDSIN(B)**2)-1./CDTAN(B))/(2.0*BETA*ROHB)
      GO TO 200
  100 CONTINUE
      V=(-1./CDTAN(B))/(2.0*BETA*ROHB)
  200 CONTINUE
      U=(ALPHA*H-CDCOS(ALPHA*H)*CDSIN(ALPHA*H))/(2.0*ALPHA*ROHW)
      W= CDSIN(ALPHA*H)
      GAMA0=Z**2*(U-W**2*V)
C
      RETURN
      END

      COMPLEX*16 FUNCTION CEXIB(H1,H2,Z1,Z2,DEPB,RHOB,GRHOB,
     1                          ALPHA1,ALPHA2,BETA1,BETA2)
C
C     THIS FUNCTION EVALUATES THE INTEGRAL OF TWO BASIC DEPTH 
C     FUNCTIONS OVER THE INTERVAL Z1 TO Z2 IN THE BOTTOM, 
C     WEIGHTED BY AN EXPONENTIAL DENSITY PROFILE. IT CAN BE 
C     USED WITHIN ONE SET OF BASIC DEPTH FUNCTIONS OR IN THE
C     COMPUTATION OF CROSS COUPLING INTEGRALS BETWEEN DIFFERENT
C     SETS OF BASIC DEPTH FUNCTIONS.
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      COMPLEX*16 ALPHA1,ALPHA2,BETA1,BETA2
      COMPLEX*16 B1,B2,CFAC,CGRHOB,CI
      COMPLEX*16 U,V,W,X
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      CI=DCMPLX(0.0D0,1.0D0)
      CGRHOB=DCMPLX(GRHOB,0.0D0)
      THBMH1=2.0D0*HB-H1
      THBMH2=2.0D0*HB-H2
C
      CEXIB=CMPLX(0.0D0,0.0D0)
      IF(Z2 .LE. Z1) GO TO 200
C
      CFAC=FKB**4*CDSIN(ALPHA1*H1)*CDSIN(ALPHA2*H2)/
     1            (RHOB*ALPHA1*ALPHA2)
C
      B1=2.0D0*BETA1*(HB-H1)
      IF(DIMAG(B1) .LT. 88.0D0) THEN
      CFAC=CFAC/(1.0D0-CDEXP(CI*B1))
      END IF
C
      B2=2.0D0*BETA2*(HB-H2)
      IF(DIMAG(B2) .LT. 88.0D0) THEN
      CFAC=CFAC/(1.0D0-CDEXP(CI*B2))
      END IF
C
      W=CI*(BETA1+BETA2)-CGRHOB
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(CI*(BETA1*(Z2-H1)+BETA2*(Z2-H2))-CGRHOB*(Z2-DEPB))
      V=CDEXP(CI*(BETA1*(Z1-H1)+BETA2*(Z1-H2))-CGRHOB*(Z1-DEPB))
      CEXIB=CEXIB+(U-V)/W
      ELSE 
      X=CDEXP(CI*(BETA1*(DEPB-H1)+BETA2*(DEPB-H2)))
      CEXIB=CEXIB+X*(Z2-Z1)
      END IF
C
      W=CI*(BETA1-BETA2)-CGRHOB
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(CI*(BETA1*(Z2-H1)+BETA2*(THBMH2-Z2))-CGRHOB*(Z2-DEPB))
      V=CDEXP(CI*(BETA1*(Z1-H1)+BETA2*(THBMH2-Z1))-CGRHOB*(Z1-DEPB))
      CEXIB=CEXIB-(U-V)/W
      ELSE 
      X=CDEXP(CI*(BETA1*(DEPB-H1)+BETA2*(THBMH2-DEPB)))
      CEXIB=CEXIB-X*(Z2-Z1)
      END IF
C
      W=CI*(BETA2-BETA1)-CGRHOB
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(CI*(BETA2*(Z2-H2)+BETA1*(THBMH1-Z2))-CGRHOB*(Z2-DEPB))
      V=CDEXP(CI*(BETA2*(Z1-H2)+BETA1*(THBMH1-Z1))-CGRHOB*(Z1-DEPB))
      CEXIB=CEXIB-(U-V)/W
      ELSE 
      X=CDEXP(CI*(BETA2*(DEPB-H2)+BETA1*(THBMH1-DEPB)))
      CEXIB=CEXIB-X*(Z2-Z1)
      END IF
C
      W=-CI*(BETA1+BETA2)-CGRHOB
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(CI*(BETA1*(THBMH1-Z2)+BETA2*(THBMH2-Z2))-CGRHOB*(Z2-DEPB))
      V=CDEXP(CI*(BETA1*(THBMH1-Z1)+BETA2*(THBMH2-Z1))-CGRHOB*(Z1-DEPB))
      CEXIB=CEXIB+(U-V)/W
      ELSE 
      X=CDEXP(CI*(BETA1*(THBMH1-DEPB)+BETA2*(THBMH2-DEPB)))
      CEXIB=CEXIB+X*(Z2-Z1)
      END IF
C
      CEXIB=CFAC*CEXIB
C
  200 CONTINUE
C
      RETURN
      END

      SUBROUTINE CHOLDC(A,G,M,MX)
C
C     CHOLESKY DECOMPOSITON OF A REAL SYMETRIC POSITIVE DEFINITE
C     MATRIX A IN THE FORM:
C                                    T
C                         A =  G   G
C
C     WHERE G IS LOWER TRIANGULAR. TAKEN FROM "FUNDEMENTALS OF 
C     MATRIX COMPUTATIONS" BY D. S. WATKINS, PG. 21 (JOHN WILEY,
C     NEW YORK, 1991)
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 A(MX,MX),G(MX,MX)
      REAL*8 SUM,ZERO
C
      ZERO=0.0D0
C
      DO 100 J=1,M
      JM1=J-1
      JP1=J+1
      SUM=0.0D0
      IF(J .EQ. 1) GO TO 30
      DO 20 K=1,JM1
      SUM=SUM+G(J,K)**2
   20 CONTINUE
   30 CONTINUE
      IF(A(J,J) .LE. SUM) THEN
      WRITE(6,*) '*** NOT POSITIVE DEFINITE IN CHOLDC ***'
      WRITE(9,*) '*** NOT POSITIVE DEFINITE IN CHOLDC ***'
      STOP 'FAILURE: NOT POSITIVE DEFINITE IN CHOLDC'
      END IF
      G(J,J)=DSQRT(A(J,J)-SUM)
C
      IF(J .EQ. M) GO TO 100
C
      DO 60 I=JP1,M
      SUM=0.0D0
      IF(J .EQ. 1) GO TO 50
      DO 40 K=1,JM1
      SUM=SUM+G(I,K)*G(J,K)
   40 CONTINUE
   50 CONTINUE
      G(I,J)=(A(I,J)-SUM)/G(J,J)
      G(J,I)=ZERO
   60 CONTINUE
C
  100 CONTINUE
C
      RETURN
      END

      SUBROUTINE CSYMEIG(a,b,u,v,cs,z1,z2,d,e,n,eivec,nx,nxsd2)
c
c From ALGOL program in Handbook Series Linear Algebra: "A Jacobi type
c method for complex symmetric matrices" by P. J. Anderson and G. Loizou,
c Numer. Math. 25, 347-363 (1976). Converted to FORTRAN by K. Santinello
c and R. B. Evans, ODSI, North Stonington, CT (1987).  
c
c Solves by a Jacobi-like method the eigenproblem for the n x n complex
c symmetric matrix A + Bi, whose diagonal and super-diagonal elements
c are stored by column in arrays a,b[1:n(n+1)/2]. If eivec is TRUE then
c the eigenvectors are generated and the arrays u,v[1:n,1:n] must be
c provided to receive them. If eivec is FALSE then u,v are not required
c and can be trival in the procedure call. Iterations are limited to
c 15. Eps is set to 10**-16 in the program. It is used to test for 
c convergence and should be no smaller than the machine accurracy.
c The arrays are dimensioned for nx, which should be greater than or 
c equal to n, and nxsd2=nx*(nx+1)/2.
c
c The calling sequence to find the n complex eigenvalues CEIG (and 
c eigenvectors) of the symmetric complex matric C is as follows:
c
c      DO 30 j=1,n
c         DO 20 i=1,j
c            jji = (j*(j-1)/2)+i
c            a(jji) = DREAL(C(i,j))
c            b(jji) = DIMAG(C(i,j))
c   20    CONTINUE
c   30 CONTINUE
c
c      eivec = .TRUE.
c      CALL CSYMEIG(a,b,u,v,cs,z1,z2,d,e,n,eivec,nx,nxsd2) 
C
c      DO 50 i=1,n
c         ii=i*(i+1)/2
c         CEIG(i)=DCMPLX(a(ii),b(ii))
c   50 CONTINUE
c
      INTEGER n,nx,nxsd2
      INTEGER i,j,k,p,q,r,it,pq,pp,qq,ip,iq,ij,ii,jj,n1,ip1
      LOGICAL eivec
      LOGICAL notrans,wlarge,wsmall
      REAL*8 a(nxsd2),b(nxsd2),u(nx,nx),v(nx,nx)
      REAL*8 cs(nx),z1(nx),z2(nx),d(nx),e(nx)
      REAL*8 eps,sqrt3,cos45,sk,t1,max,trhold,app,bpp,aqq,bqq,apq,bpq,
     >       a1,a2,a3,a4,a5,aip,bip,aiq,biq,d1,d2,b1,b2,w,delta,fx,den,
     >       xr1,xr2,cy,sy,c2y,s2y,cx,sx,c2x,s2x,cot4x,cot2x,csec2x,
     >       cotx,t2,t3,uip,vip,uiq,viq
c
c
      eps = 1.0D-16
      n1 = n*(n-1)/2
      sqrt3 = DSQRT(3.0D0)
      cos45 = 1.0D0/DSQRT(2.0D0)
c
c Initialize u and v
c
      IF (eivec) THEN
	DO 10 i=1,n
	   u(i,i) = 1.0D0
	   v(i,i) = 0.0D0
	   ip1=i+1
	   DO 20 j=ip1,n
	      u(i,j) = 0.0D0
	      u(j,i) = 0.0D0
	      v(i,j) = 0.0D0
	      v(j,i) = 0.0D0
20         CONTINUE 
10      CONTINUE
      END IF
      notrans = .FALSE.
c 
c Iteration loop
c
      DO 500 it=1,15
	 IF (notrans) GOTO 900
	 sk = 0.0D0
	 DO 40 i=1,n
	    t1 = 0.0D0
	    DO 50 j=1,n
	       IF (i .NE. j) THEN 
		  IF (i .LT. j) THEN 
		     ij = j*(j-1)/2+i
		  ELSE 
		     ij = i*(i-1)/2+j
		  END IF
		  t1 = DABS(a(ij)) + DABS(b(ij)) + t1
	       END IF
50          CONTINUE               
	       sk = sk + t1
	       ii = i*(i+1)/2
	       cs(i) = t1 + DABS(a(ii)) + DABS(b(ii))
40       CONTINUE
c
c Interchange rows and columns
c
	 nm1 = n-1
	 DO 60 p=1,nm1
	    max = cs(p)
	    j = p
	    ip1 = p+1
	    DO 70 i=ip1,n
	       IF (cs(i) .GT. max) THEN
		  max = cs(i)
		  j = i
	       END IF
70          CONTINUE
	    IF (j .NE. p) THEN
	       cs(j) = cs(p)
	       DO 80 i=1,n
		  IF ((i .NE. j) .AND. (i .NE. p)) THEN
		     IF (i .LT. p) THEN
			ip=p*(p-1)/2+i
		     ELSE 
			ip=i*(i-1)/2+p
		     END IF  
		     IF (i .LT. j) THEN 
			ij=j*(j-1)/2+i
		     ELSE 
			ij=i*(i-1)/2+j
		     END IF
		     t1 = a(ip)
		     a(ip) = a(ij)
		     a(ij) = t1
		     t1 = b(ip)
		     b(ip) = b(ij)
		     b(ij) = t1
		  END IF
		  IF (eivec) THEN
		     t1 = u(i,p)
		     u(i,p) = u(i,j)
		     u(i,j) = t1
		     t1 = v(i,p)
		     v(i,p) = v(i,j)
		     v(i,j) = t1
		  END IF
80             CONTINUE
	       pp = p*(p+1)/2
	       jj = j*(j+1)/2
	       t1 = a(pp)
	       a(pp) = a(jj)
	       a(jj) = t1
	       t1 = b(pp)
	       b(pp) = b(jj)
	       b(jj) = t1                  
	    END IF
60       CONTINUE
C
c
c Decide whether off-diagonal elements sufficiently small
c
	 IF (sk .LT. (10000.0D0*eps)) GO TO 900
c
c Diagonal elements are in d,e
c
	 DO 90 i=1,n
	    ii = i*(i+1)/2
	    d(i) = a(ii)
	    e(i) = b(ii)
	    z1(i) = 0.0D0
	    z2(i) = 0.0D0
90       CONTINUE
c
c Sweep starts
c
	 notrans = .TRUE.        
	 k = 0
	 r = 0
	 trhold = sk/(1.0D1*n1)
	 IF (it .GT. 5) trhold = 1.0D-2*trhold
	 p = 1
	 q = 2
c
c (r < n1) loop
c
100       CONTINUE
	    pq = q*(q-1)/2+p
	    IF (it .LT. 6) k=k+1
	    IF ((DABS(a(pq)) + DABS(b(pq))) .GE. trhold) THEN
c 
c Pivoting on (p,q)
c       
	       r = r + 1
	       pp = p*(p+1)/2
	       qq = q*(q+1)/2
	       pq = q*(q-1)/2+p
	       app = a(pp)
	       bpp = b(pp)
	       aqq = a(qq)
	       bqq = b(qq)
	       apq = a(pq)
	       bpq = b(pq)
	       d1 = app-aqq
	       d2 = bpp-bqq
	       b1 = 2.0D0*apq
	       b2 = 2.0D0*bpq
	       a2 = 0.0D0
	       a4 = 0.0D0
	       DO 105 i=1,n
		  IF ((i .NE. p) .AND. (i .NE. q)) THEN
		     IF (i .LT. p) THEN 
			ip = p*(p-1)/2+i
		     ELSE 
			ip = i*(i-1)/2+p
		     END IF
		     IF (i .LT. q) THEN
			iq = q*(q-1)/2+i
		     ELSE 
			iq = i*(i-1)/2+q
		     END IF
		     aip = a(ip)
		     bip = b(ip)
		     aiq = a(iq)
		     biq = b(iq)
		     a2 = a2 + (aip-biq)**2 + (bip+aiq)**2
		     a4 = a4 + bip*aiq-aip*biq
		  END IF
105            CONTINUE
		  a1 = (d1-b2)**2 + (d2+b1)**2
		  a5 = 4.0D0*(d2*b1-d1*b2) + 8.0D0*a4
		  a3 = 6.0D0*(a1+a2)
		  a4 = 4.0D0*(a1+a2) + 8.0D0*a4
		  a2 = 4.0D0*a1+2.0D0*a2
		  t3 = a1*16.0D0+a2*8.0D0+a3*4.0D0+a4*2.0D0+a5
		  wlarge = .TRUE.
		  IF (t3 .GT. 0.0D0) wlarge =  .FALSE.
		  t3 = a1*16.0D0-a2*24.0D0+a3*36.0D0-a4*54.0D0+a5*81.0D0
		  wsmall = .TRUE.
		  IF (t3 .LT. 0.0D0) wsmall = .FALSE.
		  IF (wlarge .or. wsmall) THEN
		     cy = 2.0D0/sqrt3
		     sy = -cy/2.0D0
		     c2y = 5.0D0/3.0D0
		     s2y = -4.0D0/3.0D0
		     IF (wlarge) THEN 
			sy = -sy
			s2y = -s2y
		     END IF
		  ELSE
c
c Solve for w by Newton-Raphson
c
		     i = 0
		     w = 2.0D0
		     delta = 1.0D0
115                     CONTINUE
			i = i + 1
			fx = (((a1*w+a2)*w+a3)*w+a4)*w+a5
			den = ((4.0D0*a1*w+3.0D0*a2)*w+2.0D0*a3)*w+a4
			delta = -fx/den
			w = w + delta
			IF ((DABS(delta) .GT. (1.0D1*eps*DABS(w)))
     >                        .AND.  (i .LT. 30)) GO TO 115
		     IF (DABS(w) .LT. eps) THEN
			sy = 0.0D0
			s2y = 0.0D0
			cy = 1.0D0
			c2y = 1.0D0
		     ELSE
			t1 = 2.0D0*DSQRT(1.0D0+W)
			sy = w/t1
			cy = (2.0D0+w)/t1
			t1 = 2.0D0*w+w*w
			t2 = 2.0D0*(1.0D0+w)
			s2y = t1/t2 
			c2y = (2.0D0+t1)/t2
		     END IF
		  END IF
		  xr1 = 2.0D0*(b1*d1+b2*d2)
		  xr2 = d1*d1+d2*d2-b1*b1-b2*b2
		  IF (DABS(xr1) .LE. eps*DABS(xr2)) THEN
		     IF (xr2 .GE. 0.0D0) THEN
c 
c x is small
c
			IF (sy .EQ. 0.0D0) THEN
			   GO TO 121
			ELSE
			   sx = 0.0D0
			   s2x = 0.0D0
			   cx = 1.0D0
			   c2x = 1.0D0
			END IF
		     ELSE
c
c x is near pi/4 or -pi/4
c
			c2x = 0.0D0
			IF (xr1 .GE. 0.0D0) THEN 
			   s2x = 1.0D0
			ELSE 
			   s2x = -1.0D0
			END IF
			cx = cos45
			sx = s2x*cos45
		     END IF
		  ELSE
		     cot4x = xr2/xr1
		     cot2x = DABS(cot4x) + DSQRT(1.0D0+cot4x*cot4x)
		     IF (xr2 .LT. 0.0D0) cot2x = 1.0D0/cot2x
		     csec2x = DSQRT(1.0D0+cot2x*cot2x)
		     s2x = 1.0D0/csec2x
		     c2x = s2x*cot2x
		     cotx = cot2x+csec2x
		     sx = 1.0D0/DSQRT(1.0D0+cotx*cotx)
		     cx = sx*cotx
		     IF (xr1 .LT. 0.0D0) THEN
			s2x = -s2x
			sx = -sx
		     END IF
		  END IF  
c
c transformation section
c
		  notrans = .FALSE.
		  k = 0
		  DO 110 i=1,n
		     IF ((i .NE. p) .AND. (i .NE. q)) THEN
			IF (i .LT. p) THEN
			   ip = p*(p-1)/2+i
			ELSE 
			   ip = i*(i-1)/2+p
			END IF
			IF (i .LT. q) THEN
			   iq = q*(q-1)/2+i
			ELSE 
			   iq = i*(i-1)/2+q
			END IF
			aip = a(ip)
			bip = b(ip)
			aiq = a(iq)
			biq = b(iq)
			a(ip) = (aip*cy-biq*sy)*cx+(aiq*cy+bip*sy)*sx
			b(ip) = (bip*cy+aiq*sy)*cx+(biq*cy-aip*sy)*sx
			a(iq) = (aiq*cy+bip*sy)*cx-(aip*cy-biq*sy)*sx
			b(iq) = (biq*cy-aip*sy)*cx-(bip*cy+aiq*sy)*sx
		     END IF
110               CONTINUE
		     a(pq) =((b1*c2y+d2*s2y)*c2x-(d1*c2y-b2*s2y)*s2x)/2.0D0
		     b(pq) =((b2*c2y-d1*s2y)*c2x-(d2*c2y+b1*s2y)*s2x)/2.0D0
		     t1 =(-2.0D0*d1*sx*sx+(d1*2.0D0*sy*sy-b2*s2y)*c2x+
     >                   (b1*c2y+d2*s2y)*s2x)/2.0D0
		     t2 =(-2.0D0*d2*sx*sx+(d2*2.0D0*sy*sy+b1*s2y)*c2x+
     >                   (b2*c2y-d1*s2y)*s2x)/2.0D0
		     a(pp) = app + t1
		     b(pp) = bpp + t2
		     a(qq) = aqq - t1
		     b(qq) = bqq - t2
		     z1(p) = z1(p) + t1
		     z1(q) = z1(q) - t1
		     z2(p) = z2(p) + t2
		     z2(q) = z2(q) - t2
		     IF (eivec) GO TO 119
		     GO TO 121
119                  CONTINUE
		     DO 120 i=1,n
			uip = u(i,p)
			uiq = u(i,q)
			vip = v(i,p)
			viq = v(i,q)
			u(i,p)=(uip*cy-viq*sy)*cx+(uiq*cy+vip*sy)*sx
			v(i,p)=(vip*cy+uiq*sy)*cx+(viq*cy-uip*sy)*sx
			u(i,q)=(uiq*cy+vip*sy)*cx-(uip*cy-viq*sy)*sx
			v(i,q)=(viq*cy-uip*sy)*cx-(vip*cy+uiq*sy)*sx
120                  CONTINUE
121         CONTINUE
	    END IF
	    IF (k .eq. n1) THEN  
	       trhold = 1.0D-2*trhold
	       k = 0
	    END IF
	    IF (q .LT. n) THEN
		q = q + 1
	    ELSE 
	       IF (p .LT. (n-1)) THEN
		  p = p + 1
		  q = p + 1
	       ELSE
		  p = 1
		  q = 2
		  IF (it .GT. 5) trhold = 1.0D-4*trhold
	       END IF
	    END IF
	 IF (r .LT. n1) GO TO 100     
c
c diagonal elements are corrected
c
	 DO 130 i=1,n
	    ii = i*(i+1)/2
	    a(ii) = d(i) + z1(i)
	    b(ii) = e(i) + z2(i)
130      CONTINUE
C
C
500   CONTINUE         
900   CONTINUE
      RETURN
      END

      COMPLEX*16 FUNCTION CJDJ(EGV,RNG1,RNG2)
C
C     SAME AS CHDH BUT FOR HANKEL FUNCTIONS OF ORDER ZERO TYPE TWO.
C     THE NAME IS CARRIED OVER FROM A VERSION WHICH USED BESSEL
C     FUNCTIONS.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
      COMMON /FLAGS/ IGEOM,NEWSBC
      COMPLEX*16 CDSRT,FKH,ONE,CI,EGV
C
      ONE=DCMPLX(1.0,0.0)
      CI=DCMPLX(0.0,1.0)
C
      FKH=FKB*CDSRT(ONE-EGV)
      IF(IGEOM .EQ. 1) THEN
      CJDJ=CDEXP(CI*FKH*(RNG1-RNG2))
      ELSE
      CJDJ=SQRT(RNG1/RNG2)*CDEXP(CI*FKH*(RNG1-RNG2))
      END IF
C
      RETURN
      END

      COMPLEX*16 FUNCTION CUPWB(H1,H2,ALPHA1,ALPHA2,BETA1,BETA2,
     1                           DEPW,RHOW,GRHOW,LH1,LH2,MX)
C
C     THIS FUNCTION COMPUTES THE INTEGRAL OF TWO BASIC DEPTH
C     FUNCTIONS OVER THE WATER FROM DEPW(1)=0 TO H1, WEIGHTED
C     BY THE WATER DENSITY PROFILE RHOW. THIS INTEVAL STRADDLES
C     THE DEPTH H2, WHICH IS THE WATER BOTTOM INTERFACE FOR THE 
C     SECOND DEPTH FUNCITON. THE LOGIC IS DESIGNED TO ACCOMODATE
C     THIS CHANGE AT H2, WHICH IS IN THE INTERVAL BETWEEN DEPW(LH2) 
C     AND DEPW(LH2). NOTE THAT H2 IS .LT. H1.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION DEPW(MX),RHOW(MX),GRHOW(MX)
      COMPLEX*16  CEXIW,CEXIWB
      COMPLEX*16  ALPHA1,ALPHA2,BETA1,BETA2
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      LH2M1=LH2-1
      LH2P1=LH2+1
      LH1M1=LH1-1
C
      CUPWB=DCMPLX(0.0,0.0)
C
      IF(LH2M1 .LT. 1 ) GO TO 200
      DO 100 L=1,LH2M1
      Z1=DEPW(L)
      Z2=DEPW(L+1)
      CUPWB=CUPWB+CEXIW(Z1,Z2,DEPW(L),RHOW(L),GRHOW(L),
     1                  ALPHA1,ALPHA2)
  100 CONTINUE
  200 CONTINUE
C
      Z1=DEPW(LH2)
      CUPWB=CUPWB+CEXIW(Z1,H2,DEPW(LH2),RHOW(LH2),GRHOW(LH2),
     1                  ALPHA1,ALPHA2)
C
      IF(LH2 .EQ. LH1) THEN
C
C     H2 IS IN THE LAYER WITH H1
C
      CUPWB=CUPWB+CEXIWB(H2,H2,H1,DEPW(LH1),RHOW(LH1),GRHOW(LH1),
     1          ALPHA1,ALPHA2,BETA1,BETA2)
C
      ELSE
C      
      Z2=DEPW(LH2P1)
      CUPWB=CUPWB+CEXIWB(H2,H2,Z2,DEPW(LH2),RHOW(LH2),GRHOW(LH2),
     1          ALPHA1,ALPHA2,BETA1,BETA2)
C
      IF(LH1M1 .LT. LH2P1) GO TO 400
      DO 300 L=LH2P1,LH1M1
      Z1=DEPW(L)
      Z2=DEPW(L+1)
      CUPWB=CUPWB+CEXIWB(H2,Z1,Z2,DEPW(L),RHOW(L),GRHOW(L),
     1          ALPHA1,ALPHA2,BETA1,BETA2)
  300 CONTINUE
  400 CONTINUE
C
      Z1=DEPW(LH1)
      CUPWB=CUPWB+CEXIWB(H2,Z1,H1,DEPW(LH1),RHOW(LH1),GRHOW(LH1),
     1          ALPHA1,ALPHA2,BETA1,BETA2)
C
      END IF
C
      RETURN
      END

      SUBROUTINE CHECK(M,EGVR,IABRT,MX)
C
C     THIS SUBROUTINE CHECKS FOR MULTIPLE EIGEN VALUES
C     AND RETURNS THE NUMBER OF THESE IN IABRT
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 EGVR(MX)
C
      MM1=M-1
      IABRT=0
C
      DO 200 I=1,MM1
      IP1=I+1
      DO 100 II=IP1,M
C
      IF(CDABS(EGVR(I)-EGVR(II)) .LT. .1D-12) IABRT=IABRT+1
C
  100 CONTINUE
  200 CONTINUE
C
      RETURN
      END

      SUBROUTINE CRSCUP(H1,H2,M,EGVL,EGVR,CLR,CRL,MX,
     1                  IMAT,BMATL,BMATR,W4,ALPHAR,BETAR,FNORMR,
     2                  ALPHAL,BETAL,FNORML,FKWL,FKWR,ROHBL,ROHBR)
C
C     THE FOLLOWING SUBROUTINE COMPUTES THE CROSS COUPLING BETWEEN THE
C     EIGEN FUNCTIONS CORRESPONDING TO EGVL AND THE EIGENFUNCTIONS
C     CORRESPONDING TO EGVR. THIS VERSION IS GENERALIZED TO ALLOW
C     THE BOTTOM DENSITY TO BE DIFFERENT ON EACH SIDE OF THE VERTICAL
C     INTERFACE. THE FUNCTIONS CIW0 AND CIB0 USED HERE HAVE NOT BEEN 
C     DIVIDED BY THE CORESPONDING DENSITIES ROHW, ROHBL AND ROHBR.
C
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16  CI,ONE
      COMPLEX*16  CDSRT,CIW0,CIB0,CIWB
      COMPLEX*16  BMATL(MX,MX),BMATR(MX,MX),W4(MX,MX)
      COMPLEX*16  EGVL(MX),EGVR(MX),CLR(MX,MX),CRL(MX,MX)
      COMPLEX*16  CHW0,CHWB,CHB0,GAMA00,V
      COMPLEX*16  ALPHAR(MX), BETAR(MX), FNORMR(MX)
      COMPLEX*16  ALPHAL(MX), BETAL(MX), FNORML(MX)
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      ONE=DCMPLX(1.0,0.0)
      CI=DCMPLX(0.0,1.0)
      FKWL2=FKWL**2
      FKWR2=FKWR**2
      FKB2=FKB**2
C
      DO   400   I=1,M
      ALPHAR(I)=CDSRT(FKWR2+FKB2*(EGVR(I)-ONE))
C
      IF(IMAT .GE. 1) THEN
      BETAR(I)=CDSRT(FKB2*EGVR(I))
      ELSE
      BETAR(I)=CDSRT(FKB2*(EGVR(I)+CI*ATEN))
      END IF
C
      FNORMR(I)=GAMA00(H2,ALPHAR(I),BETAR(I),HB,FKB,ROHW,ROHBR)
      ALPHAL(I)=CDSRT(FKWL2+FKB2*(EGVL(I)-ONE))
C
      IF(IMAT .GE. 1) THEN
      BETAL(I)=CDSRT(FKB2*EGVL(I))
      ELSE
      BETAL(I)=CDSRT(FKB2*(EGVL(I)+CI*ATEN))
      END IF
C
      FNORML(I)=GAMA00(H1,ALPHAL(I),BETAL(I),HB,FKB,ROHW,ROHBL)
  400 CONTINUE
C
      DO 700 II=1,M
C
      DO 600 I=1,M
C
      CHW0=CIW0(H1,H2,ALPHAL(I),ALPHAR(II))
      CHB0=CIB0(H1,H2,ALPHAL(I),ALPHAR(II),BETAL(I),BETAR(II))
C
C     GHANGED ORDER OF THE SQUARE ROOT AND PRODUCT 6/8/96
C     FROM V=CDSRT(FNORML(I))*FNORMR(II)) TO:
C
      V=CDSRT(FNORML(I))*CDSRT(FNORMR(II))
C
      IF(H2 .GE. H1) GO TO 550
C
C     THIS IS THE UPSLOPE CASE.
C
      CHWB=CIWB(H1,H2,ALPHAL(I),ALPHAR(II),BETAL(I),BETAR(II))
      CLR(II,I)=(CHW0/ROHW+CHWB/ROHW +CHB0/ROHBL)/V
      CRL(II,I)=(CHW0/ROHW+CHWB/ROHBR+CHB0/ROHBR)/V
C
      GO TO 600
C
  550 CONTINUE
C
C     THIS IS THE DOWNSLOPE CASE.
C
      CHWB=CIWB(H2,H1,ALPHAR(II),ALPHAL(I),BETAR(II),BETAL(I))
      CLR(II,I)=(CHW0/ROHW+CHWB/ROHBL+CHB0/ROHBL)/V
      CRL(II,I)=(CHW0/ROHW+CHWB/ROHW +CHB0/ROHBR)/V
C
  600 CONTINUE
  700 CONTINUE
C
      IF(IMAT .LT. 1) GO TO 1000
C
C     THIS IS THE MAIN ADVANTAGE OF THE GALERKIN PROCEDURE IN
C     A COUPLED MODE CALCULATION. THE COUPLING CAN BE DONE 
C     BETWEEN THE BASIC EIGENFUNCTIONS WHERE THE INTEGRALS 
C     ARE DONE EXACTLY, THEN THE TRUE COUPLING MATRIX IS 
C     OBTAINED BY MATRIX MULTIPLICATON
C
      CALL TMMULT(M,BMATR,CLR,BMATL,MX,W4)
      CALL TMMULT(M,BMATR,CRL,BMATL,MX,W4)
C
C
 1000 CONTINUE
C
      RETURN
      END

      COMPLEX*16 FUNCTION CEXIW(Z1,Z2,DEPW,RHOW,GRHOW,
     1                          ALPHA1,ALPHA2)
C
C     THIS FUNCTION EVALUATES THE INTEGRAL OF THE PRODUCT OF
C     TWO BASIC DEPTH FUNCTIONS OVER THE INTERVAL Z1 TO Z2 IN THE
C     WATER, WEIGHTED BY AN EXPONENTIAL DENSITY PROFILE.
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      COMPLEX*16 ALPHA1,ALPHA2
      COMPLEX*16 CFAC,CGRHOW,CI
      COMPLEX*16 U,V,W,X
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      CI=DCMPLX(0.0D0,1.0D0)
      CGRHOW=DCMPLX(GRHOW,0.0D0)
C
      CFAC=-FKB**4/(4.0D0*RHOW*ALPHA1*ALPHA2)
C
      CEXIW=DCMPLX(0.0D0,0.0D0)
C
      W=CI*(ALPHA1+ALPHA2)-CGRHOW
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(CI*(ALPHA1+ALPHA2)*Z2-CGRHOW*(Z2-DEPW))
      V=CDEXP(CI*(ALPHA1+ALPHA2)*Z1-CGRHOW*(Z1-DEPW))
      CEXIW=CEXIW+(U-V)/W
      ELSE 
      X=CDEXP(CGRHOW*DEPW)
      CEXIW=CEXIW+X*(Z2-Z1)
      END IF
C
      W=CI*(ALPHA1-ALPHA2)-CGRHOW
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(CI*(ALPHA1-ALPHA2)*Z2-CGRHOW*(Z2-DEPW))
      V=CDEXP(CI*(ALPHA1-ALPHA2)*Z1-CGRHOW*(Z1-DEPW))
      CEXIW=CEXIW-(U-V)/W
      ELSE 
      X=CDEXP(CGRHOW*DEPW)
      CEXIW=CEXIW-X*(Z2-Z1)
      END IF
C
      W=CI*(ALPHA2-ALPHA1)-CGRHOW
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(CI*(ALPHA2-ALPHA1)*Z2-CGRHOW*(Z2-DEPW))
      V=CDEXP(CI*(ALPHA2-ALPHA1)*Z1-CGRHOW*(Z1-DEPW))
      CEXIW=CEXIW-(U-V)/W
      ELSE 
      X=CDEXP(CGRHOW*DEPW)
      CEXIW=CEXIW-X*(Z2-Z1)
      END IF
C
      W=-CI*(ALPHA1+ALPHA2)-CGRHOW
      IF(CDABS(W) .GT. 1.0D-12) THEN
      U=CDEXP(-CI*(ALPHA1+ALPHA2)*Z2-CGRHOW*(Z2-DEPW))
      V=CDEXP(-CI*(ALPHA1+ALPHA2)*Z1-CGRHOW*(Z1-DEPW))
      CEXIW=CEXIW+(U-V)/W
      ELSE 
      X=CDEXP(CGRHOW*DEPW)
      CEXIW=CEXIW+X*(Z2-Z1)
      END IF
C
      CEXIW=CFAC*CEXIW
      RETURN
      END

      SUBROUTINE EGNVAL(H,M,ZZ,MX)
C
C     THE FOLLOWING SUBROUTINE FINDS THE FIRST M ZEROES (EIGENVALUES)
C     OF THE REAL CHARAC. FUNCT. RCF(H,Z) USING THE HALF INTERVAL
C     METHOD. IT IS TAKEN FROM CARNAHAN,LUTHER AND WILKES PAGE 185.
C     IT IS ASSUMED THAT HB IS .GT. H.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 ZZ(MX),ZERO,TWO,PROD
      REAL*8 ESP,DZP,DZ,ZR,ZL,RCF,FZHALF,ZHALF,FZL
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
      DATA ESP /.1D-14/
      PI=2.*ACOS(0.0)
      ZERO=DBLE(0.0)
      TWO=DBLE(2.0)
C
C     THE SEARCH INCREMENT IS CHOSEN BASED ON THE MINIMUM SPACING OF
C     ASYMPTOTES IN THE TANGENT FORM OF THE REAL CHARACTERISTIC
C     FUNCTION
C
      DZP=(PI/(2.*H*FKB))**2
      DZ=(PI/(2.*(HB-H)*FKB))**2
      DZ=DMIN1(DZP,DZ)
      ITER=DLOG(DZ/ESP)/DLOG(TWO) +1.0
C
C     ESTABLISH INTERVAL WITHIN WHICH ROOT LIES
C
      ZR=1.-(FKW/FKB)**2+ESP**2
C
      DO 700 I=1,M
      ZL=ZR
C
  100 CONTINUE
      PROD=RCF(H,ZL)*RCF(H,ZL+DZ)
      IF(PROD .LT. ZERO) GO TO 300
      ZL=ZL+DZ
      GO TO 100
C
  300 CONTINUE
      ZR=ZL+DZ
      FZL=RCF(H,ZL)
C
C     BEGIN HALF INTERVAL ITERATION
C
      DO 600 J=1,ITER
      ZHALF=(ZL+ZR)/2.0
      FZHALF=RCF(H,ZHALF)
C
C     CHOOSE THE SUB INTERVAL CONTAINING THE ROOT
C
      IF(FZHALF*FZL .LE. ZERO) GO TO 500
      ZL=ZHALF
      FZL=FZHALF
      GO TO 600
C
  500 CONTINUE
      ZR=ZHALF
C
  600 CONTINUE
C
      ZZ(I)=(ZR+ZL)/2.0
  700 CONTINUE
C
      RETURN
      END

      SUBROUTINE CPRES(M,RINC,RMAX,R1KM,R2KM,RKM,EGVL,
     1                  A,B,NDEP,NDINC,CDF,JBOT,MX,MD,P,P0,P1,P2,
     2                  TL,TL0,TL1,TL2,IOUT,MAMP)
C
C     THIS SUBROUTINE COMPUTES THE COMPLEX PRESSURE,INTENSITY AND 
C     TRANSMISSION LOSS AT EACH RANGE RKM IN THE INTERVAL R1KM
C     .LT. RKM .LE. R2KM AT EACH OF THE NDEP OUTPUT DEPTHS ZR. THE 
C     PRESSURE (REAL,AIMAG), TL AND MODE AMPLITUDES ARE WRITTEN ON
C     UNIT7,UNIT10, AND UNIT11 RESPECTIVELY. IF IOUT .NE. 1, THE 
C     OUTGOING, INGOING AND SCATTERED COMPONENTS OF THE TL ARE 
C     WRITTEN ON UNIT12, UNIT13 AND UNIT17 RESPECTIVELY. IF IOUT 
C     .NE. 1, THE OUTGOING,INGOING AND SCATTERED COMPONENTS OF THE
C     COMPLEX PRESSURE ARE WRITTEN ON UNIT14 UNIT15 AND UNIT16
C     RESPECTIVELY.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION TL(MD),TL0(MD),TL1(MD),TL2(MD)
C
      REAL*8 PI
C
      COMPLEX*16 P(MD),P0(MD),P1(MD),P2(MD)
      COMPLEX*16 EGVL(MX)
      COMPLEX*16 A(MX),B(MX),CDF(MX,MD)
      COMPLEX*16 CHDH,CJDJ,CRH,CRJ
      COMPLEX*16 CDJ0,HK02,CDSRT,FKH
      COMPLEX*16 CARG,CARG1,CARGP,CARGM
      COMPLEX*16 CI,ZERO,ONE,EGV,SCALE
      COMPLEX*16 RCOEF,RCOEF0,RCOEF1,RCOEF2
      COMPLEX*16 CMODE,CMODE0,CMODE1,CMODE2
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
      COMMON/FLAGS/IGEOM,NEWSBC
C
      PI=2.*DACOS(DBLE(0.0))
      ZERO=DCMPLX(0.0,0.0)
      ONE=DCMPLX(1.0,0.0)
      CI=DCMPLX(0.0,1.0)
C
C     FIND NORMALIZATION FOR CYLINDRICAL GEOMETRY
C
      SCALE=DCMPLX(4.0D0*PI,0.0D0)
C
      IF(IGEOM.EQ.1) THEN
C
C     THE NORMALIZATION IN PLANE GEOMETRY DEPENDS ON FKW
C
      SCALE=4.0D0/DCMPLX(BESSJ0(FKW),BESSY0(FKW))
      END IF
C
      RNG1=R1KM*1000.
C
  100 CONTINUE
C
      RNG=RKM*1000.
C
      IF(MAMP .LE. 0) GO TO 130
      IMWRT=INT(RKM/RINC)
      IF(MOD(IMWRT,MAMP) .EQ. 0) WRITE(11,120) RKM
  120 FORMAT(F10.3)
  130 CONTINUE
C
      DO 150 J=1,NDEP
      P(J)=ZERO
      IF(IOUT .EQ. 1) GO TO 150
      P0(J)=ZERO
      P1(J)=ZERO
      P2(J)=ZERO
  150 CONTINUE
C
      DO 300 I=1,M
C
      EGV=EGVL(I)
      CRH=CHDH(EGV,RNG1,DMAX1(RNG,1.0D-6))
C
      IF(IOUT .EQ. 1)   THEN
      RCOEF=A(I)*CRH
      ELSE
C
      IF(CDABS(B(I)) .GT. 1.0D-30) THEN
      CRJ=CJDJ(EGV,RNG1,DMAX1(RNG,1.0D-6))
      RCOEF=A(I)*CRH+B(I)*CRJ
      ELSE
      RCOEF=A(I)*CRH
      END IF
C
      IF((RNG .LE. RNG1) .AND. (IGEOM .NE. 1)) THEN
C
C     IN CYLINDRICAL GEOMTERY THE SCATTERED FIELD IN THE
C     FIRST REGION IS IN TERMS OF THE BESSEL FUNCTION J0
C     DIVIDED BY THE HANKEL FUNCTIONS OF ORDER ZERO TYPE
C     TWO EVALUATED AT RNG1
C
      FKH=FKB*CDSRT(ONE-EGV)
      CARG=FKH*RNG
      CARG1=FKH*RNG1
C
      IF(CDABS(CARG) .LT. 2.0D0) THEN
C
C     THE POWER SERIES IS USED FOR J0 WHEN CARG IS SMALL
C
      RCOEF0=B(I)*(2.0D0*CDJ0(CARG))/HK02(CARG1)
      ELSE
C
C     OTHERWISE J0 IS WRITTEN IN TERMS OF HANKEL FUNCTIONS
C     AND THE LARGE ARGUMENT APPROXIMATIONS ARE USED
C
      CARGP=CI*FKH*(RNG1+RNG)
      CARGM=CI*FKH*(RNG1-RNG)
      RCOEF0=B(I)*(CDEXP(CARGP)+CDEXP(CARGM))*DSQRT(RNG1/RNG)
C
      END IF
C
      END IF
C
      RCOEF1=A(I)*CRH
      RCOEF2=B(I)*CRJ
C
      IF((RNG .LE. RNG1) .AND. (IGEOM .EQ. 1)) THEN
C
C     IN PLANE GEOMTERY THE SCATTERED FIELD IN THE
C     FIRST REGION IS JUST THE INGOING PLANE WAVE
C
      RCOEF0=RCOEF2
      END IF
C
      END IF
C
      DO 200 J=1,NDEP
C
C     THIS IS THE CRUX OF THE WHOLE CALCULATION.
C
      IF(IOUT .EQ. 1)   THEN
      CMODE=RCOEF*CDF(I,J)
      P(J)=P(J)+CMODE
      ELSE
      CMODE=RCOEF*CDF(I,J)
      CMODE1=RCOEF1*CDF(I,J)
      CMODE2=RCOEF2*CDF(I,J)
      P(J)=P(J)+CMODE
      P1(J)=P1(J)+CMODE1
      P2(J)=P2(J)+CMODE2
C
      IF(RNG .LE. RNG1) THEN
      CMODE0=RCOEF0*CDF(I,J)
      P0(J)=P0(J)+CMODE0
      END IF
C
      END IF
C
C     WRITE OUT MODE AMPLITUDES
C
      IF(MAMP .LE. 0) GO TO 200
      IF(MOD(IMWRT,MAMP) .NE. 0) GO TO 200
      XI=CDABS(SCALE*CMODE)**2
      TLI=200.
      IF(XI .LE. 1.0E-20) GO TO 175
      TLI=-10.*DLOG10(XI)
  175 CONTINUE
      WRITE(11,180) I,J,XI,TLI
  180 FORMAT(1X,I5,2X,I5,5X,F10.2,5X,1PE13.5)
C
  200 CONTINUE
C
  300 CONTINUE
C
C
      IF(IOUT .EQ. 1) THEN
C
      DO 400 J=1,NDEP
      P(J)=P(J)*SCALE
      XI=CDABS(P(J))
      IF( XI .LE. 1.0E-10)   THEN
      TL(J)=200.
      ELSE IF( XI .GE. 1.0E10 )   THEN
      TL(J)=-200.
      ELSE
      TL(J)=-20.*DLOG10(XI)
      END IF
  400 CONTINUE
C
      WRITE(7) SNGL(RKM),
     1         (SNGL(DREAL(P(J))),SNGL(DIMAG(P(J))),J=1,NDEP)
      WRITE(10,450) RKM,(TL(J),J=1,NDEP,NDINC)
  450 FORMAT(F13.7,20F13.7)
C
      ELSE
C
      DO 500 J=1,NDEP
C
      IF(RNG .LE. RNG1) THEN
      P0(J)=P0(J)*SCALE
      XI0=CDABS(P0(J))
      IF( XI0 .LE. 1.0E-10)   THEN
      TL0(J)=200.
      ELSE IF( XI0 .GE. 1.0E10 )   THEN
      TL0(J)=-200.
      ELSE
      TL0(J)=-20.*DLOG10(XI0)
      END IF
      END IF
C
      P(J)=P(J)*SCALE
      P1(J)=P1(J)*SCALE
      P2(J)=P2(J)*SCALE
      XI=CDABS(P(J))
      XI1=CDABS(P1(J))
      XI2=CDABS(P2(J))
C
      IF( XI .LE. 1.0E-10)   THEN
      TL(J)=200.
      ELSE IF( XI .GE. 1.0E10 )   THEN
      TL(J)=-200.
      ELSE
      TL(J)=-20.*DLOG10(XI)
      END IF
C
      IF( XI1 .LE. 1.0E-10)   THEN
      TL1(J)=200.
      ELSE IF( XI1 .GE. 1.0E10 )   THEN
      TL1(J)=-200.
      ELSE
      TL1(J)=-20.*DLOG10(XI1)
      END IF
C
      IF( XI2 .LE. 1.0E-10)   THEN
      TL2(J)=200.
      ELSE IF( XI2 .GE. 1.0E10 )   THEN
      TL2(J)=-200.
      ELSE
      TL2(J)=-20.*DLOG10(XI2)
      END IF
C
  500 CONTINUE
C
      WRITE(7) SNGL(RKM),
     1         (SNGL(DREAL(P(J))),SNGL(DIMAG(P(J))),J=1,NDEP)
      WRITE(14) SNGL(RKM),
     1         (SNGL(DREAL(P1(J))),SNGL(DIMAG(P1(J))),J=1,NDEP)
      WRITE(15) SNGL(RKM),
     1         (SNGL(DREAL(P2(J))),SNGL(DIMAG(P2(J))),J=1,NDEP)
C     
      WRITE(10,450) RKM,(TL(J),J=1,NDEP,NDINC)
      WRITE(12,450) RKM,(TL1(J),J=1,NDEP,NDINC)
      WRITE(13,450) RKM,(TL2(J),J=1,NDEP,NDINC)
C
      IF(RNG .LE. RNG1) THEN
      WRITE(17,450) RKM,(TL0(J),J=1,NDEP,NDINC)
      WRITE(16) SNGL(RKM),
     1         (SNGL(DREAL(P0(J))),SNGL(DIMAG(P0(J))),J=1,NDEP)
      END IF
C
      END IF
C
      RKM=RKM+RINC
      IF((RKM .GT.R2KM) .OR. (RKM .GT.RMAX)) GO TO 900
C
      GO TO 100
C
  900 CONTINUE
C
      RETURN
      END

      SUBROUTINE CFACIN(FREQ,DEPB,SVPB,DBPWLB,CGRADB,CINTB,NPB,MX)
C
C     THIS SUBROUTINE GENERATES THE COEFFICIENTS CGRADB AND CINTB 
C     IN A PIECEWISE LINEAR REPRESENTATION OF THE SQUARE OF THE 
C     COMPLEX INDEX OF REFRACTION IN THE BOTTOM.
C
C     N(Z)**2 = CGRADB(I)*Z + CINTB(I), I=1,NPB
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      DIMENSION DEPB(MX),SVPB(MX),DBPWLB(MX)
      COMPLEX*16 CGRADB(MX),CINTB(MX)
      COMPLEX*16 CI,CK,CKP1,CONSQ,CONSQP1
C
      CI=DCMPLX(0.0D0,1.0D0)
      PI=2.0D0*DACOS(0.0D0)
C
C     CONVERSION FACTOR OF DB/WAVELENGTH TO IMAG PART OF 
C     THE COMPLEX WAVE NUMBER 
C
      ETA=1.0D0/(40.0D0*PI*DLOG10(DEXP(1.0D0)))
C
      NPBM1=NPB-1
C
C     FIND THE SQUARE OF THE WAVE NUMBER AND INDEX OF REFARCTION
C     AT THE DEPB(1)
C
      CK=(2.0D0*PI*FREQ/SVPB(1))*(1.0D0+CI*ETA*DBPWLB(1))
      CONSQ=(CK/DCMPLX(FKB))**2
C
      DO 100 I=1,NPBM1
C
C     FIND THE SQUARE OF THE WAVE NUMBER AND INDEX OF REFARCTION
C     AT THE DEPB(I+1)
C
      CKP1=(2.0D0*PI*FREQ/SVPB(I+1))*(1.0D0+CI*ETA*DBPWLB(I+1))
      CONSQP1=(CKP1/DCMPLX(FKB))**2
C
C     COMPUTE THE GRADIENT AND INTERCEPT
C
      CGRADB(I)=(CONSQP1-CONSQ)/(DEPB(I+1)-DEPB(I))
      CINTB(I)=CONSQ-CGRADB(I)*DEPB(I)
C
      CONSQ=CONSQP1
C
  100 CONTINUE
C
C     THE GRADIENT IN THE LAST LAYER (NPBM1) WILL BE USED TO 
C     EXTRAPOLATE VALUES BELOW THE LAST POINT ON THE PROFILE
C
      CGRADB(NPB)=CGRADB(NPBM1)
      CINTB(NPB)=CONSQ-CGRADB(NPB)*DEPB(NPB)
C
      RETURN
      END

      PROGRAM COUPLE
C
C     THIS PROGRAM IS THE DRIVER FOR A COUPLED NORMAL MODE
C     CALCULATION BASED ON A MODEL CONSISTING OF A HOMOGENEOUS
C     WATER LAYER OVER A HOMOGENEOUS BOTTOM SEDIMENT LAYER. IT IS
C     EXTENDED, USING THE GALERKIN METHOD, TO ALLOW PIECEWISE 
C     LINEAR VARIATIONS OF THE INDEX OF REFRACTION SQUARED AND 
C     PIECEWISE EXPONENTIAL VARIATIONS OF THE DENSITY IN BOTH
C     THE WATER AND BOTTOM SEDIMENT LAYER. THE INDEX OF REFRACTION 
C     SQUARED IS COMPLEX IN BOTH LAYERS TO ALLOW FOR ATTENUATION.
C
C     A PRESSURE RELEASE BOUNDARY IS IMPOSED AT THE SURFACE OF THE
C     WATER AND AT THE GREATEST DEPTH IN THE BOTTOM. THE WATER DEPTH
C     MAY VARY WITH RANGE BUT THE TOTAL DEPTH OF WATER AND SEDIMENT 
C     IS FIXED.
C
C     A DECOUPLING ALGORITHM IS USED TO SOLVE THE MATRIX TWO-POINT
C     BOUNDARY VALUE PROBLEM THAT OCCURS IN THE STEPWISE COUPLED
C     MODE FORMULATION. THIS ELIMINATES THE NUMERICAL PROBLEM
C     INHERENT IN THE SHOOTING METHOD THAT WAS INITIALLY USED. 
C
C     THE LATEST MODIFICATION WAS TO REPLACE THE QR ALGORITHM
C     (CIGMAT) WITH A SLOW BUT RELIABLE JCAOBI TYPE ALGORITHM 
C     (CSYMEIG) DESIGNED TO FIND EIGENVALUES AND EIGENVECTORS 
C     OF A COMPLEX SYMMETRIC (NOT CONJUGATE SYMMETRIC) MATRIX. 
C     (R. B. EVANS, SAIC, WOODS HOLE, MA, 11/19/97)
C
C     THE MAIN VARIABLES ARE AS FOLLOWS.
C
C        INPUT-
C          HB=TOTAL DEPTH OF WATER AND BOTTOM LAYER (M)
C          FREQ=FREQUENCY (HZ)
C          ROHW=DENSITY IN THE WATER IN THE SEARCH MODE (G/CM**3)
C          ROHB=DENSITY IN THE BOTTOM IN THE SEARCH MODE (G/CM**3)
C          DBPWL=ATTENUATION IN THE BOTTOM (DB/WAVE LENGTH)
C                IN THE SEARCH MODE WHEN THE BOTTOM IS ISOSPEED.
C                IT IS IGNORED IN THE GALERKIN MODE.
C
C          CB=SOUND SPEED IN THE BOTTOM (M/SEC). CB IS USED
C             TO COMPUTE THE INDEX OF REFRACTION EVERY WHERE.
C             IT IS THE BOTTOM SOUND SPEED FOR THE BACKGROUND
C             TWO LAYER PROBLEM IN THE GALERKIN MODE.
C          CW=SOUND SPEED IN THE WATER (M/SEC) IN THE SEARCH
C             MODE WHEN THE WATER IS ISOSPEED. IT IS IGNORED
C             IN THE GALERKIN MODE. 
C
C          M=NUMBER OF CONTRIBUTING MODES (MAX.=MX=190)
C          NATEN=NUMBER OF PARTS OF ATEN TO USE IN INCREMENTAL (ON ATEN)
C                SEARCH FOR EIGEN VALUES (SEE SEARCH)
C          IEIG=FLAG TO INDICATE SOURCE OF ESTIMATES OF COMPLEX EIGEN
C               VALUES IN REGION 2 THROUGH N. IF IEIG=0 THE REAL PROB.
C               IS USED (SEE SEARCH)
C          NDPTH=NUMBER OF PARTS OF DEPTH STEP TO USE WITH IEIG=1 IN
C                INCREMENTAL (ON DEPTH) SEARCH FOR EIGEN VALUES. NDPTH
C                IS ONLY USED IF MULTIPLE EIGEN VALUES
C                ARE INCOUNTERED (SEE SEARCH)
C          IGEOM=FLAG WHICH WHEN SET TO ONE (1) CAUSES THE CODE TO DO 
C                THE CALCULATION IN PLANE GEOMETRY WITH A LINE SOURCE.
C          NEWSBC=FLAG WHICH WHEN SET TO ONE (1) INVOKES A RADIATION
C                 BOUNDARY CONDITON AT THE SOURCE THAT IS COMPATIBLE 
C                 WITH THE SINGLE SCATTER APPROXOMATION IN CYLINDRICAL
C                 GEOMETRY AND IS AWAYS USED WITH PLANE GEOMETRY.
C
C          NSDEP=NUMBER OF SOURCE DEPTHS (MAX.=MD=400)
C          ZSMIN=MIN. SOURCE DEPTH (M)
C          ZSINC=INC. IN SOURCE DEPTH (M)
C
C          NDEP=NUMBER OF RECEIVER DEPTHS FOR PRESS. CAL. 
C               (MAX.=MD=400)
C          ZMIN=MIN. RECEIVER DEPTH FOR PRESS. CAL.(M)
C          ZINC=INC. IN RECIEVER DEPTH FOP PRESS. CAL. (M)
C
C          RMIN=MIN. RANGE FOR PRESSURE CALCULATION (KM)
C          RMAX=MAX. RANGE FOR PRESSURE CALCULATION (KM)
C          RINC=INC. IN RANGE FOR PRESSURE CALCULATION (KM)
C
C          N=NUMBER OF INPUT RANGE DEPTH PAIRS (RANG,DPTH)
C          IPRT=PRINT FLAG FOR DETAILS OF CALCULATION SUCH AS EIGEN
C               VALUES AND COEFFICIENTS OF OUTGOING AND BACKSCATTERED
C               WAVES. IF IPRT .GE. 0 THE RESULTS ARE PRINTED OUT
C               FOR THE FIRST AND THE LAST REGION AND EVERY IPRT
C               REGION IN BETWEEN.
C          IOUT=FLAG FLAG WHICH WHEN SET TO ZERO (0) COMPUTES THE
C                FULLY ELLIPTIC TWO WAY SOLUTION THAT MATCHES BOTH 
C                PRESSURE AND RADIAL PARTICAL VELOCITY. IF IOUT IS 
C                SET TO ONE (1), THE ONE-WAY PRESSURE MATCHING 
C                SOLUTION IS FOUND. IF IOUT IS SET TO MINUS ONE (-1),
C                AN APPROXIMATION TO THE SINGLE SCATTER APPROXIMATION
C                DUE TO PORTER AND JENSEN IS USED (SEE PROPM).
C          MAMP=FLAG TO GENERATE A FILE OF MODE AMPLITUDES ON UNIT11.
C               IF MAMP .GT. 0 THEN THE MODE AMPLITUDES ARE WRITTEN 
C               OUT IN CPRES EVERY MAMP RANGE STEPS. THIS FILE CAN GET 
C               VERY BIG SO PICK MAMP CAREFULLY. 
C
C               ** ALL THE REMAINING INPUTS ARE REPEATED FOR J=1,N **
C
C          RANG=RANGE TO END OF J TH REGION (KM)
C          IRLIN=NUMBER OF ADDITIONAL REGIONS GENERATED TO REPRESENT
C                A LINEARLY SLOPING BOTTOM BETWEEN RANG(J) AND
C                RANG(J+1). SEE SUBROUTINE BATHY.
C          DPTH=DEPTH OF WATER IN J TH REGION (M)
C          NPW=NUMBER OF POINTS IN THE SOUND SPEED PROFILE IN THE J TH
C             REGION. IF NPW .LE. 1 (IMAT=0) THEN THE WATER IS ASSUMED
C             TO BE HOMOGENEOUS (CW). NO DEPTH SOUND SPEED PAIRS ARE 
C             INPUT. THE EIGENVALUES ARE FOUND IN SUBROUTINE SEARCH
C             BASED ON NATEN, NDPTH AND IEIG. THE ANALYTIC FORM OF 
C             THE DEPTH FUNCTIONS IS USED. IF NPW .GE. 2 (IMAT=1) THEN 
C             THE WATER COLUMN MAY BE NONHOMOGENEOUS. A SOUND SPEED
C             PROFILE MUST BE INPUT. THE EIGENVALUES ARE FOUND BY THE
C             GALERKIN MATRIX METHOD IN SUBROUTINE GALRKN (NATEN,NDPTH
C             AND IEIG ARE IGNORED). THE DEPTH FUNCTIONS ARE CONSTRUCTED
C             FROM THE MATRIX EIGENVECTORS.
C          NPB=NUMBER OF POINTS IN THE BOTTOM SOUND SPEED, ATTENUATION,
C             DENSITY PROFILE IN THE J TH REGION. IF NPW .GE. 2 THEN NPB 
C             MUST BE .GE. 2 AND A BOTTOM SOUND SPEED, ATTENUATION, 
C             DENSITY PROFILE MUST BE PROVIDED. IF NPW IS .LT. 2 THEN 
C             NO BOTTOM PROFILE MAY BE INPUT.
C          IREIG=SEQUENCE NUMBER FOR STORAGE OR RETRIEVAL OF
C                EIGENVALUES ON THE DIRECT ACCESS FILE UNIT=18.
C                IREIG(J) .EQ. 0 : OMIT STORAGE ON UNIT=18
C                IREIG(J) .GT. 0 : WRITE EIGENVALUES ON UNIT=18 AT
C                RECORD DETERMINED BY IREIG(J) 
C                IREIG(J) .LT. 0 : READ EIGENVALUES FROM UNIT=18 AT
C                RECORD DETERMINED BY ABS(IREIG(J))
C                THIS OPTION IS USED TO AVOID RECOMPUTATION OF
C                IDENTICAL EIGENVALUES USING SEARCH AND GALRKN.
C                IT IS NOT VALID WHEN IRLIN .NE. ZERO BECAUSE IT IS
C                TOO HARD TO ANTICIPATE THE SEQUENCE NUMBERS NEEDED.
C                IT IS NOT VALID WITH A MIXTURE OF SEARCH AND GALRKN
C                TO MAKE IT EASY TO KEEP TRACK OF THE NUMBER OF 
C                RECORDS WRITEN ON UNIT=18.
C
C          DEPW=DEPTH (M) OF SOUND SPEED IN THE WATER (DEPW(1)=0.0)
C          SVPW=SOUND SPEED IN THE WATER (M/SEC)
C          DBPWLW=ATTENUATION IN THE WATER (DB/WAVE LENGTH). 
C          RHOW=DENSITY IN THE WATER (GM/CM**3)
C
C
C          DEPB=DEPTH (M) OF SOUND SPEED IN THE BOTTOM (MEASURED FROM
C               THE WATER SURFACE AND DEPB(1)=DEPW(NPW))
C          SVPB=SOUND SPEED IN THE BOTTOM (M/SEC)
C          DBPWLB=ATTENUATION IN THE BOTTOM (DB/WAVE LENGTH). THIS
C                 INPUT OVERIDES THE DBPWL IN THE FIRST RECORD.
C          RHOB=DENSITY IN THE BOTTOM (G/CM**3)
C
C        INTERMEDIATE-
C
C          ATEN=IMAGINARY PART OF SQUARE OF INDEX OF REFRACTION IN
C                THE BOTTOM. SEE SUBROUTINE INPUT AND ESPI. USED
C                ONLY IN THE SEARCH MODE WHEN THE BOTOM IS ISOSPEED.
C          ZZ=REAL EIGENVALUES
C          CW=AVERAGE SOUND SPEED IN WATER
C          IMAT=FLAG WHICH CONTROLS THE METHOD FOR FINDING COMPLEX 
C               EIGENVALUES AND HOW THE DEPTH FUNCTIONS ARE CONSTRUCTED.
C               IMAT IS SET IN SUBROUTINE INPUT BASED ON NPW.
C          BSOUT=INTEGER FLAG WHICH IS SET TO ABS(IOUT) IN INPUT. IF 
C                SET TO ONE (1) IT TURNS OFF CALCULATION OF BACKSCATTER
C                AND YIELDS AN OUTGOING SOLUTION WHICH IS EITHER THE
C                THE ONE-WAY OR SINGLE SCATTER APPROXIMATION DEPENDING
C                ON IOUT. IF BSOUT IS EQUAL TO ZERO (0), THE TWO-WAY 
C                CALCULATION IS DONE. BSOUT IS CALLED IOUT IN ALL 
C                SUBROUTINES EXCEPT INPUT AND PROPM.
C          LHW=THE WATER DEPTH HW IS BETWEEN DEPW(LHW) AND DEPW(LHW+1).
C              IF LHW=NPW THEN EXTRAPOLATION IS DONE.
C          LHB=THE BOTTOM DEPTH HB IS BETWEEN DEPB(LHB) AND DEPB(LHB+1).
C              IF LHB=NPB THEN EXTRAPOLATION IS DONE.
C          CGRADW=GRADIENTS IN THE REPRESENTATION OF THE COMPLEX INDEX 
C               OF REFRACTION SQUARED IN THE WATER. COMPUTED IN SUB-
C               ROUTINE CFACIN AND STORED ON LUSVP.
C          CINTW=INTERCEPTS IN THE REPRESENTATION OF THE COMPLEX INDEX  
C               OF REFRACTION SQUARED IN THE WATER. COMPUTED IN SUB-
C               ROUTINE CFACIN AND STORED ON LUSVP.
C          AVG=AVERAGE OF THE SQUARE OF THE REAL PART OF THE INDEX OF 
C              REFRACTION IN THE WATER IN THE CURRENT DEPTH REGION. 
C              SEE SUBROUTINE AVGIN. 
C          AVGW=STORED VALUES OF AVG FOR USED IN FIELD CALUCULATION.
C          GRHOW=LOGARITHMIC GRADIENTS OF THE DENSITY IN THE WATER
C                (1/M). COMPUTED IN SUBROUTINE INPUT AND STORED ON
C                LUSVP.
C          CGRADB=GRADIENTS IN THE REPRESENTATION OF THE COMPLEX
C                 INDEX OF REFRACTION SQUARED IN THE BOTTOM. 
C                 COMPUTED IN CFACIN AND STORED ON LUSVP.
C          CINTB=INTERCEPTS IN THE REPRESENTATION OF THE COMPLEX 
C                INDEX OF REFRACTION SQUARED IN THE BOTTOM.
C                COMPUTED IN CFACIN AND STORED ON LUSVP.
C          AVGB=THE REAL PART OF THE SQUARE OF THE BACKGROUND INDEX
C               OF REFRACTION IN THE BOTTOM. THIS IS CURRENTLY SET TO
C               ONE FOR ALL REGIONS IN BOTDEPS AND ADDED TO THE 
C               NEGATIVE THE TRUE INDEX OF REFRACTION IN AMAT.
C          GRHOB=LOGARITHMIC GRADIENTS OF THE DENSITY IN THE BOTTOM
C                (1/M). COMPUTED IN SUBROUTINE INPUT AND STORED ON
C                LUSVP.
C          ROHWL=DENSITY OF WATER ON LEFT SIDE OF VERTICAL INTERFACE
C                IN CRSCUP THAT WAS USED TO FIND THE BASIC EIGENVALUES
C                AND EIGENFUNCTIONS (IMAT=1).
C          ROHWR=DENSITY OF WATER ON RIGHT SIDE OF VERTICAL INTERFACE
C                IN CRSCUP THAT WAS USED TO FIND THE BASIC EIGENVALUES
C                AND EIGENFUNCTIONS (IMAT=1).
C          ROHBL=DENSITY OF BOTTOM ON LEFT SIDE OF VERTICAL INTERFACE
C                IN CRSCUP THAT WAS USED TO FIND THE BASIC EIGENVALUES
C                AND EIGENFUNCTIONS (IMAT=1).
C          ROHBR=DENSITY OF BOTTOM ON RIGHT SIDE OF VERTICAL INTERFACE
C                IN CRSCUP THAT WAS USED TO FIND THE BASIC EIGENVALUES
C                AND EIGENFUNCTIONS (IMAT=1).
C          BEGVL=BASIC SET OF EIGENVALUES ON LEFT (IMAT=1)
C          BEGVR=BASIC SET OF EIGENVALUES ON RIGHT (IMAT=1)
C          BMATL=MATRIX OF NORMALIZED EIGENVECTORS CORRESPONDING
C                TO BEGVL (COEFFICIENTS FOR THE DEPTH FUNCTIONS)
C          BMATR=MATRIX OF NORMALIZED EIGENVECTORS CORRESPONDING
C                TO BEGVR (COEFFICIENTS FOR THE DEPTH FUNCTIONS)
C          EGVL=EIGEN VALUE ON THE LEFT
C          EGVR=EIGEN VALUE ON THE RIGHT
C          FNORM=NORMALIZATION FACTOR
C          CLR=CROSS COUPLING (USES DENSITY PROFILE ON RIGHT)
C          CRL=CROSS COUPLING (USES DENSITY PROFILE ON LEFT)
C          R=PROPAGATOR MATRIX   
C          T=UNITARY TRANSFORMATION MATRIX, R(J)*T(J)=T(J+1)*U(J)
C          U=UPPER TRIANGULAR MATRIX
C          Y1=DECOUPLED OUTGOING SOLUTION
C          Y3=DECOUPLED INGOING SOLUTION
C          C1=COEFFICIENT OF OUTGOING WAVE IN REGION 1
C          A=COEFICIENT OF OUTGOING WAVE
C          B=COEFICIENT OF INGOING WAVE
C          ZSD=SOURCE DEPTHS IN SOURCE ARRAY
C          ZS=MIDPOINT OF SOURCE ARRAY WRITTEN IN HEADER OF
C             OUTPUT FILES
C          ZR=RECIEVER DEPTHS
C          CDF=DEPTH FUNCTIONS AT OUTPUT DEPTHS
C          RANGE,DEPTH=SEQUENCE GENERATED IN SUBROUTINE BATHY  
C          NREG=NUMBER OF REGIONS
C
C        COMPUTED(IN CPRES)-
C
C          P=COMPLEX PRESSURE
C          P0=SCATTERED COMPLEX PRESSURE IN REGION 1
C             IF BSOUT .NE. 1
C          P1=OUTGOING COMPLEX PRESSURE IF BSOUT .NE. 1
C          P2=INGOING COMPLEX PRESSURE IF BSOUT .NE. 1
C          TL=TRANSMISION LOSS
C          TL0=SCATTERED TRANSMISION LOSS IN REGION 1
C              IF BSOUT .NE. 1
C          TL1=OUTGOING TRANSMISION LOSS IF BSOUT .NE. 1
C          TL2=INGOING TRANSMISION LOSS IF BSOUT .NE. 1
C
C     THE FILES USED ARE AS FOLLOWS.
C
C        INPUT-
C
C          UNIT5=INPUT
C
C        INTERMEDIATE-
C
C          UNIT21=DECOUPLED OUTGOING SOLUTION Y1
C          UNIT2=TOP TWO BLOCK MATRICES (UA & UB) IN UPPER 
C                TRIANGULAR MATRIX U
C          UNIT3=DECOUPLED INGOING SOLUTION Y3
C          UNIT4=UNITARY TRANSFORMATION MATRIX
C          UNIT8=EIGENVALUES AND NORMALIZATION FACTORS
C                ALSO BASIC EIGENVALUES AND NORMALIZED
C                EIGENVECTORS WHEN IMAT=1       
C          UNIT18=UNIQUE SEQUENCE OF EIGENVALUES, NORMALIZATION 
C                 FACTORS, BASIC EIGENVALUES AND NORMALIZED 
C                 EIGENVECTORS SPECIFIED BY IREIG (DIRECT ACCESS).
C          LUSVP=30,TABLES OF INDEX OF REFRACTION SQUARED IN THE WATER,
C               DENSITY AND LOGARITHMIC DENSITY GRADIENTS IN THE WATER, 
C               COMPLEX INDEX OF REFRACTION SQUARED IN THE BOTTOM, AND
C               DENSITY AND LOGARITHMIC DENSITY GRADIENTS IN THE BOTTOM.
C               (WRITTEN IN SUBROUTINE INPUT AND READ IN THE MAIN
C                PROGRAM COUPLE) 
C
C        OUTPUT-
C
C          UNIT6= LOG FILE
C          UNIT9= PRINTED OUTPUT
C          UNIT7= REAL AND IMAGINARY PARTS OF COMPLEX PRESSURE
C          UNIT10= TRANSMISION LOSS
C          UNIT11= MODE AMPLITUDES WHEN MAMP .GT. 0
C          UNIT12= OUTGOING TRANSMISION LOSS IF BSOUT .NE. 1
C          UNIT13= INGOING TRANSMISION LOSS IF BSOUT .NE. 1
C          UNIT14= OUTGOING COMPLEX PRESSUE IF BSOUT .NE. 1
C          UNIT15= INGOING COMPLEX PRESSURE IF BSOUT .NE. 1
C          UNIT16= SCATTERED COMPLEX PRESSURE IN REGION 1
C                  IF BSOUT .NE. 1
C          UNIT17= SCATTERED TRANSMISSION LOSS IN REGION 1
C                  BSOUT .NE. 1
C
      IMPLICIT REAL*8 (A-H,O-Z)
      PARAMETER(MX=190,MXT2=2*MX,MXMX=MX*MX,MD=400,NRX=2002,
     & MXT2Q=MXT2*MXT2,MXSD2=MX*(MX+1)/2)
C
      DIMENSION IPS(MX),INTH(MX)
      DIMENSION RANG(NRX),DPTH(NRX),RANGE(NRX),DEPTH(NRX)
      DIMENSION IRLIN(NRX),IREIG(NRX)
      DIMENSION DEPW(MX),SVPW(MX),DBPWLW(MX),RHOW(MX),GRHOW(MX)
      DIMENSION DEPB(MX),SVPB(MX),DBPWLB(MX),RHOB(MX),GRHOB(MX)
      DIMENSION DEPWL(MX),RHOWL(MX),GRHOWL(MX)
      DIMENSION DEPWR(MX),RHOWR(MX),GRHOWR(MX)
      DIMENSION DEPBL(MX),RHOBL(MX),GRHOBL(MX)
      DIMENSION DEPBR(MX),RHOBR(MX),GRHOBR(MX)
      DIMENSION AVGW(NRX),RHOWBOT(NRX),RHOBTOP(NRX)
      DIMENSION ZSD(MD),ZR(MD),TL(MD),TL0(MD),TL1(MD),TL2(MD)
C
      REAL*8 ZZ(MX)
      REAL*8 RSPD(MX,MX),VMAT(MX,MX)
      REAL*8 FA(MXSD2),FB(MXSD2),FU(MX,MX),FV(MX,MX)
      REAL*8 FCS(MX),FZ1(MX),FZ2(MX),FD(MX),FE(MX)
      COMPLEX*16 CINTW(NRX),CGRADW(NRX)
      COMPLEX*16 CINTB(NRX),CGRADB(NRX)
      COMPLEX*16 FNORM(MX)
      COMPLEX*16 EGVL(MX),EGVR(MX),BEGVL(MX),BEGVR(MX)
      COMPLEX*16 CDSRT,BDF,BDF1
      COMPLEX*16 CRL(MX,MX),CLR(MX,MX),BMATL(MX,MX),BMATR(MX,MX)
      COMPLEX*16 R(MXT2,MXT2),T(MXT2,MXT2),U(MXT2,MXT2)
      COMPLEX*16 WRK2(MXT2,MXT2),WRK1(MX,MX),BUFF2(MXT2Q)
      COMPLEX*16 Y1(MX,MX),Y3(MX,MX)
      COMPLEX*16 T3(MX,MX),T4(MX,MX)
      COMPLEX*16 UB(MX,MX),UC(MX,MX),UE(MX,MX)
      COMPLEX*16 C1(MX),A(MX),B(MX),WRK(MX)
      COMPLEX*16 CDF(MX,MD)
      COMPLEX*16 P(MD),P0(MD),P1(MD),P2(MD)
      COMPLEX*16 CI,ONE,FKH,FKVS,FKVW
      COMPLEX*16 CXP,ZERO
      COMPLEX*16 HK01,SUM
      COMPLEX*16 BUFF1(MXMX), ALPHA(MX), FAC(MX), RAT(MX),
     1           BETA(MX),ALPHAR(MX),BETAR(MX),FNORMR(MX),
     2           ALPHAL(MX),BETAL(MX),FNORML(MX),FKHA(MX)
C
      INTEGER BSOUT
      CHARACTER*3 NEWSVP(NRX)
      CHARACTER*10 TITLE(8)
C
      COMMON /ACCUR/ CONST1
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
      COMMON /BLKCON/ CI,ONE,ZERO
      COMMON /FLAGS/ IGEOM,NEWSBC
C
      EQUIVALENCE (WRK2(1,1),BUFF2(1))
C     EQUIVALENCE (IRLIN(1),IPS(1))
      EQUIVALENCE (CRL(1,1),UB(1,1)),(CLR(1,1),UC(1,1))
      EQUIVALENCE (CRL(1,1),T3(1,1)),(CLR(1,1),T4(1,1))
      EQUIVALENCE (BMATL(1,1),UE(1,1))
      EQUIVALENCE (R(1,1),U(1,1))
C     EQUIVALENCE (T(1,1),CDF(1,1))
      EQUIVALENCE (BUFF1(1),ALPHA(1)),       (BUFF1(MX+1),FAC(1)),
     1            (BUFF1(2*MX+1),RAT(1)),    (BUFF1(3*MX+1),BETA(1)),
     2            (BUFF1(1),ALPHAR(1)),      (BUFF1(MX+1),BETAR(1)),
     3            (BUFF1(2*MX+1),FNORMR(1)), (BUFF1(3*MX+1),ALPHAL(1)),
     4            (BUFF1(4*MX+1),BETAL(1)),  (BUFF1(5*MX+1),FNORML(1)),
     5            (BUFF1(6*MX+1),FKHA(1)) 
C
C     START UNIX TIMER
C
      ISTARTS=time()
C
C     START LAHEY TIMER
C
C      CALL TIMER(IHU)
C      STARTS=.01*IHU
C
      PI=2.*ACOS(0.0)
      CI=DCMPLX(0.0,1.0)
      ONE=DCMPLX(1.0,0.0)
      ZERO=DCMPLX(0.0,0.0)
C
C     OPEN INPUT AND PRINTED OUTPUT FILES
C
      OPEN(5,FILE='COUPLE.DAT',FORM='FORMATTED') 
      OPEN(6,FILE='COUPLE.LOG',FORM='FORMATTED') 
      OPEN(9,FILE='COUPLE.PRT',FORM='FORMATTED') 
      LUSVP=30
      OPEN(LUSVP,FILE='LUSVP.DAT',FORM='FORMATTED')
C
      WRITE(6,10)
      WRITE(9,10)
   10 FORMAT(1X,/,'  ********  ',/,
     & ' THIS PC VERSION OF COUPLE IS RANGE DEPENDENT ',/,
     & ' HAS PLANE OR CYLINDRICAL GEOMETRY OPTION ',/,
     & ' AND STANDARD OR NEW INITIAL SOURCE BOUNDARY CONDITIONS ',/,
     & '  ********  ',/)
C
C     GET INPUT DATA 
C
      CALL INPUT(TITLE,FREQ,M,N,IPRT,IOUT,BSOUT,NSDEP,NDEP,
     1           NATEN,NDPTH,IEIG,IMAT,RANGE,DEPTH,NREG,MAMP,
     2           ZS,ZSD,RMIN,RMAX,RINC,ZR,NDINC,MD,NRX,
     3           RANG,DPTH,IRLIN,IREIG,MX,
     4           DEPW,SVPW,DBPWLW,CGRADW,CINTW,RHOW,GRHOW,
     5           DEPB,SVPB,DBPWLB,CGRADB,CINTB,RHOB,GRHOB,
     6           NEWSVP,LUSVP)
C
C
      H1=DEPTH(1)
      RKM1=RANGE(1)
C
      IF(IMAT .EQ. 1)   THEN 
      REWIND LUSVP
      READ(LUSVP,*) NPW,NPB
      DO 11 KK=1,NPW
      READ(LUSVP,*) DEPW(KK),CINTW(KK),CGRADW(KK),RHOW(KK),GRHOW(KK)
   11 CONTINUE
      DO 12 KK=1,NPB
      READ(LUSVP,*) DEPB(KK),CINTB(KK),CGRADB(KK),RHOB(KK),GRHOB(KK)
   12 CONTINUE
      CALL AVGIN(DEPW,CGRADW,CINTW,NPW,MX,H1,AVG,LHW)
      CALL BOTDEPS(H1,DEPB,CGRADB,CINTB,NPB,AVGB,LHB,MX)
      CW=CB/SQRT(AVG)
      FKW=2.0*PI*FREQ/CW
      AVGW(1)=AVG
C
      RHOWBOT(1)=RHOW(LHW)*DEXP(GRHOW(LHW)*(H1-DEPW(LHW)))
      ROHW=RHOWBOT(1)
      RHOBTOP(1)=RHOB(1)
      ROHB=RHOBTOP(1)
C
C     CHECK FOR MODE CUTOFF, AVOID IF NECESSARY BY INCREASING
C     THE WATER DEPTH BY 1/1000 OF A WAVE LENGTH, AND REDEFINE
C     THE AVERAGE INDEX OF REFRACTION IN THE WATER AND THE DEPTHS
C     AND INTERCEPTS IN THE BOTTOM
C
        CUTOFF=RCF(H1,1.0D0)
        IF(DABS(CUTOFF) .LT. 1.0D-12) THEN
        DEPINC=2.0D0*PI/(1000.0D0*FKW)
        WRITE(6,*) ' *** WARNING *** '
        WRITE(6,*) 'MODE CUTOFF AT RANGE=',RANGE(1),' KM'
        WRITE(6,*) 'DEPTH INCREASED BY ',DEPINC,' M'
        WRITE(9,*) ' '
        WRITE(9,*) ' *** WARNING *** '
        WRITE(9,*) 'MODE CUTOFF AT RANGE=',RANGE(1),' KM'
        WRITE(9,*) 'DEPTH INCREASED BY ',DEPINC,' M'
        DEPTH(1)=DEPTH(1)+DEPINC
        H1=DEPTH(1)
        CALL AVGIN(DEPW,CGRADW,CINTW,NPW,MX,H1,AVG,LHW)
        CALL BOTDEPS(H1,DEPB,CGRADB,CINTB,NPB,AVGB,LHB,MX)
        CW=CB/SQRT(AVG)
        FKW=2.0*PI*FREQ/CW
        AVGW(1)=AVG
        RHOWBOT(1)=RHOW(LHW)*DEXP(GRHOW(LHW)*(H1-DEPW(LHW)))
        ROHW=RHOWBOT(1)
        END IF
C
C
      NPWL=NPW
      LHWL=LHW
      DO 14 KK=1,NPWL
      DEPWL(KK)=DEPW(KK)
      RHOWL(KK)=RHOW(KK)
      GRHOWL(KK)=GRHOW(KK)
   14 CONTINUE
C
      NPBL=NPB
      LHBL=LHB
      DO 16 KK=1,NPBL
      DEPBL(KK)=DEPB(KK)
      RHOBL(KK)=RHOB(KK)
      GRHOBL(KK)=GRHOB(KK)
   16 CONTINUE
C
C      WRITE(9,*) 'NPBL,LHBL= ',NPBL,LHBL
C      WRITE(6,*) 'NPBL,LHBL= ',NPBL,LHBL
C
      END IF
CCC
      FKWL=FKW
      ROHBL=ROHB
      ROHWL=ROHW
CCC
C         WRITE(9,*) 'CW,CB= ',CW,CB
C         WRITE(9,*) 'NPW,LHW= ',NPW,LHW
C         DO 25 KK=1,NPW
C         WRITE(9,26) DEPW(KK),CINTW(KK)+CGRADW(KK)*DEPW(KK),CGRADW(KK)
C   25    CONTINUE
C         WRITE(9,26) H1,CINTW(LHW)+CGRADW(LHW)*H1,CGRADW(LHW)
C         WRITE(9,*) 'NPB,LHB= ',NPB,LHB
C         DO 27 KK=1,NPB
C         WRITE(9,26) DEPB(KK),CINTB(KK)+CGRADB(KK)*DEPB(KK),CGRADB(KK)
C   26    FORMAT(1X,F10.4,2X,F10.4,2X,E12.4,2X,E12.4,2X,E12.4)
C   27    CONTINUE
C         WRITE(9,26) HB,CINTB(LHB)+CGRADB(LHB)*HB,CGRADB(LHB)
CC
C     OPEN SCRATCH AND OTHER FILES
C
      CALL FILE(MAMP,BSOUT,MX,MXT2)
C
C     WRITE HEADERS ON THE OUTPUT FILES
C
      CALL HEADER(TITLE,FREQ,ZS,NDEP,NDINC,ZR,NREG,RANGE,DEPTH,MD,
     1            NRX,MAMP,BSOUT)
C
C     FIND THE FIRST SET OF EIGENVALUES AND NORMALIZATION
C     FACTORS
C
      IF(IMAT .EQ. 0)   THEN
      CALL SEARCH(1,RKM1,H1,H1,M,ZZ,EGVL,FNORM,
     &            EGVL,NATEN,NDPTH,IEIG,IPRT,MX,WRK)
      ELSE
      CALL GALRKN(H1,M,ZZ,EGVL,FNORM,
     1            BEGVL,BMATL,VMAT,MX,WRK,WRK1,RSPD,CLR,CRL,IPS,INTH,
     2            MXSD2,FA,FB,FU,FV,FCS,FZ1,FZ2,FD,FE,
     3            DEPW,CGRADW,CINTW,RHOW,GRHOW,NPW,AVG,LHW,
     4            DEPB,CGRADB,CINTB,RHOB,GRHOB,NPB,AVGB,LHB)
      END IF
C
C
      IF(IPRT .LE. 0) GO TO 60
C
      WRITE(9,30)
   30 FORMAT(/)
      WRITE(6,35) 1,RANGE(1),DEPTH(1)
      WRITE(9,35) 1,RANGE(1),DEPTH(1)
   35 FORMAT(1X,26HTHE EIGENVALUES IN REGION ,I5,11H ENDING AT ,F10.3,
     1       16H  KM WITH DEPTH ,F10.2,18H  M ARE AS FOLLOWS//)
      WRITE(9,37)
   37 FORMAT(2X,3HNO.,6X,10HEIGENVALUE,9X,20HNORMALIZATION FACTOR,
     1       8X,15HHORIZ. WAVE NO.,8X,22HVERT. WAVE NO. IN BOT.,
     2        4X,21HVERT. WAVE NO. IN H2O/)
C
      DO 50 I=1,M
      FKH=FKB*CDSRT(ONE-EGVL(I))
      IF(REAL(FKH) .LT. 0.0)   THEN
      WRITE(9,*) ' ERROR IN FIRST REGION :'
      WRITE(9,*) ' NEGATIVE WAVE NUMBER FOR MODE NO. ',I
      WRITE(9,*) ' WAVE NUMBER : ',FKH
      END IF
      FKVW=FKB*CDSRT((FKW/FKB)**2+EGVL(I)-ONE)
      FKVS=FKB*CDSRT(EGVL(I)+CI*ATEN)
      WRITE(9,45) I,EGVL(I),FNORM(I),FKH,FKVS,FKVW
   45 FORMAT(1X,I3,1P,2(1X,2E11.3),3(1X,2E13.5))
   50 CONTINUE
C
C
   60 CONTINUE
C
      IF(IREIG(1) .GT. 0) THEN
C
C     STORE UNIQUE SEQUENCE OF EIGENVALUES ECT., FOR RETRIEVAL.
C
        IF(IMAT .GE. 1)  THEN
        ISTART=(IREIG(1)-1)*(M+3)
        WRITE(18,REC=ISTART+1) (BEGVL(I),I=1,M)
        DO 63 I=1,M
        WRITE(18,REC=ISTART+1+I) (BMATL(II,I),II=1,M)
   63   CONTINUE
        WRITE(18,REC=ISTART+M+2) (EGVL(I),I=1,M)
        WRITE(18,REC=ISTART+M+3) (FNORM(I),I=1,M)
        ELSE
        ISTART=(IREIG(1)-1)*2
        WRITE(18,REC=ISTART+1) (EGVL(I),I=1,M)
        WRITE(18,REC=ISTART+2) (FNORM(I),I=1,M)
        END IF
C
      END IF
C
      IF(BSOUT .EQ. 1) GO TO 65
      IF(IMAT .GE. 1) WRITE(8) (BEGVL(I),I=1,M)
      IF(IMAT .GE. 1) WRITE(8) ((BMATL(II,I),II=1,M),I=1,M)
      WRITE(8) (EGVL(I),I=1,M)
      WRITE(8) (FNORM(I),I=1,M)
   65 CONTINUE
C
      RNG1=1000.*RANGE(1)
      DO 67 I=1,M
      C1(I)=ZERO
   67 CONTINUE
C
C     STORE THE VECTOR d IN C1. 
C
      IF(IMAT .LT. 1) THEN
C
C     USE ONLY BASIC EIGEFUNCTIONS
C
      DO 70 I=1,M
C
      FKH=FKB*CDSRT(ONE-EGVL(I))
      FKVW=FKB*CDSRT((FKW/FKB)**2+EGVL(I)-ONE)
      FKVS=FKB*CDSRT(EGVL(I)+CI*ATEN)
      IF(IGEOM .EQ. 1) THEN
      FAC(I)=CDEXP(CI*RNG1*FKH)*CI/(2.0D0*FKH)
      ELSE
      FAC(I)=HK01(RNG1*FKH)*CI/4.0D0
      END IF
C
C     SUM OVER SOURCE DEPTHS
C
      DO 68 J=1,NSDEP
      IF(ZSD(J) .GT. HB) STOP 'SOURCE DEPTHS MUST BE .LE. HB'
      BDF1=BDF(ZSD(J),H1,FKVW,FKVS,FNORM(I))
C
C     FIND THE DENSITY AT ZSD(J)
C
      IF(ZSD(J) .LE. H1) THEN
      RHOZSD=ROHW
      ELSE
      RHOZSD=ROHB
      END IF
C
      C1(I)=C1(I)+BDF1*FAC(I)/RHOZSD
C
   68 CONTINUE
      C1(I)=C1(I)/NSDEP
C
   70 CONTINUE
C
      ELSE
C
C     USE DEPTH FUNCTIONS CONSTRUCTED FROM THE BASIC
C     EIGENFUNCTIONS AND THE MATRIX EIGENVECTORS IN
C     THE ARRAY BMATL 
C
      DO 80 I=1,M
      ALPHAL(I)=FKB*CDSRT((FKW/FKB)**2+BEGVL(I)-ONE)
      BETAL(I)=FKB*CDSRT(BEGVL(I))
      FKH=FKB*CDSRT(ONE-EGVL(I))
      IF(IGEOM .EQ. 1) THEN
      FAC(I)=CDEXP(CI*RNG1*FKH)*CI/(2.0D0*FKH)
      ELSE
      FAC(I)=HK01(RNG1*FKH)*CI/4.0D0
      END IF
   80 CONTINUE
C
      DO 100 I=1,M
C
C     SUM OVER SOURCE DEPTHS
C
      DO 90 J=1,NSDEP
      IF(ZSD(J) .GT. HB) STOP 'SOURCE DEPTHS MUST BE .LE. HB'
C
C     FIND THE DENSITY AT ZSD(J)
C
      IF(ZSD(J) .LE. H1) THEN
      DO 82 L=1,LHW
      IF(ZSD(J) .GE. DEPW(L)) THEN
      RHOZSD=RHOW(L)*DEXP(GRHOW(L)*(ZSD(J)-DEPW(L)))
      END IF
   82 CONTINUE
      ELSE
      DO 86 L=1,LHB
      IF(ZSD(J) .GE. DEPB(L)) THEN
      RHOZSD=RHOB(L)*DEXP(GRHOB(L)*(ZSD(J)-DEPB(L)))
      END IF
   86 CONTINUE
      END IF
C
C     SUM OVER BASIC EIGENFUNCTIONS
C
      SUM=ZERO
      DO 87 II=1,M
      SUM=SUM+BMATL(II,I)*BDF(ZSD(J),H1,ALPHAL(II),
     1                        BETAL(II),FNORM(II))
   87 CONTINUE
C
      C1(I)=C1(I)+SUM*FAC(I)/RHOZSD
C
   90 CONTINUE
      C1(I)=C1(I)/NSDEP
C
  100 CONTINUE
C
      END IF
C
      IF(BSOUT .NE. 1) GO TO 200
C
C     FIND THE OUTGOING COEFFICIENTS IN THE FIRST REGION (BSOUT=1)
C
      WRITE(9,105)
  105 FORMAT(//)
      WRITE(6,110) BSOUT
      WRITE(9,110) BSOUT
  110 FORMAT(1X,'BACKSCATTER WILL BE NEGLECTED AND ONLY AN',
     1       ' OUTGOING SOLUTION IS FOUND,','BSOUT= ',I5,/)   
C    
      IF (IOUT .EQ. 1) THEN  
      WRITE(6,112) IOUT
      WRITE(9,112) IOUT
  112 FORMAT(1X,'ONE-WAY SOLUTION IS USED: IOUT= ',I5,/)   
      ELSE IF (IOUT .EQ. -1) THEN
      WRITE(6,113) IOUT
      WRITE(9,113) IOUT
  113 FORMAT(1X,'SINGLE SCATTER APPROXIMATION IS USED: IOUT= ',I5,///)
      END IF
C
      DO 120 I=1,M
      A(I)=C1(I)
      B(I)=ZERO
  120 CONTINUE
C
C      UNORMALIZED IN AND OUTGOING COEFICIENTS ARE PRINTED
C      BELOW AND IN ALL SUBSQUENT PRINTS.
C
      IF(IPRT .LE. 0) GO TO 150
C
      WRITE(6,130) 1,RANGE(1),DEPTH(1)
      WRITE(9,130) 1,RANGE(1),DEPTH(1)
  130 FORMAT(1X,27HTHE COEFFICIENTS IN REGION ,I5,11H ENDING AT ,F10.3,
     1       16H  KM WITH DEPTH ,F10.2,18H  M ARE AS FOLLOWS///
     2       10H  MODE NO.,11X,8HOUTGOING,12X,13HOUTGOING (DB)//)
C
      DO 140 I=1,M
C
      ATL=200.
      AABS=CDABS(A(I))
      IF(AABS .GT. 1.0D-10) ATL=-20.*DLOG10(AABS)
C
      WRITE(9,135) I,A(I),ATL
  135 FORMAT(1X,I5,5X,1X,2E12.4,5X,F8.2)
  140 CONTINUE
C
  150 CONTINUE
C
C     THIS INITIALIZES THE RANGE LOOP FOR THE PRESSURE CALCULATION
C     (BSOUT=1)
C
      RKM=RMIN
C
      IF(RANGE(1) .LT. RMIN) GO TO 200
C
      R2KM=RANGE(1)
      R1KM=RANGE(1)
C
      JBOT=0
C
C     COMPUTE THE DEPTH FUNCTIONS AND PRESSURE IN THE FIRST REGION
C     (BSOUT=1)
C
      CALL CDFUN(M,EGVL,FNORM,H1,ZR,NDEP,CDF,MX,MD,
     1           IMAT,BEGVL,BMATL,ALPHA,FAC,RAT,BETA)
C
C
      CALL CPRES(M,RINC,RMAX,R1KM,R2KM,RKM,EGVL,A,B,
     1            NDEP,NDINC,CDF,JBOT,MX,MD,P,P0,P1,P2,
     2            TL,TL0,TL1,TL2,BSOUT,MAMP)
C
C
  200 CONTINUE
C
C
C ******** START OUTGOING LOOP TO FIND EIGENVALUES,COMPUTE *********
C ******** PRESSURE (BSOUT=1) AND GENERATE R, T, U AND Y1   *********
C
      NREM1=NREG-1
      DO 1000 J=1,NREM1
      H1=DEPTH(J)
      H2=DEPTH(J+1)
      RKMJP1=RANGE(J+1)
C
C     FIND OR RETRIEVE EIGENVALUES AND NORMALIZATION FACTORS
C
      IF(IMAT .EQ. 0)   THEN
        IF(IREIG(J+1) .LT. 0) THEN
        ISTART=(-IREIG(J+1)-1)*2
        READ(18,REC=ISTART+1) (EGVR(I),I=1,M)
        READ(18,REC=ISTART+2) (FNORM(I),I=1,M)
        ELSE
        CALL SEARCH(J+1,RKMJP1,H1,H2,M,ZZ,EGVL,FNORM,
     &              EGVR,NATEN,NDPTH,IEIG,IPRT,MX,WRK)
        END IF
      ELSE
       IF(NEWSVP(J+1) .EQ. 'NEW')   THEN
         READ(LUSVP,*) NPW,NPB
         DO 215 KK=1,NPW
         READ(LUSVP,*) DEPW(KK),CINTW(KK),CGRADW(KK),RHOW(KK),GRHOW(KK)   
  215    CONTINUE
         DO 216 KK=1,NPB
         READ(LUSVP,*) DEPB(KK),CINTB(KK),CGRADB(KK),RHOB(KK),GRHOB(KK)
  216    CONTINUE
       END IF
       CALL AVGIN(DEPW,CGRADW,CINTW,NPW,MX,H2,AVG,LHW)
       CALL BOTDEPS(H2,DEPB,CGRADB,CINTB,NPB,AVGB,LHB,MX)
       CW=CB/SQRT(AVG)
       FKW=2.0*PI*FREQ/CW
       AVGW(J+1)=AVG
       RHOWBOT(J+1)=RHOW(LHW)*DEXP(GRHOW(LHW)*(H2-DEPW(LHW)))
       ROHW=RHOWBOT(J+1)
       RHOBTOP(J+1)=RHOB(1)
       ROHB=RHOBTOP(J+1)
C
C     CHECK FOR MODE CUTOFF, AVOID IF NECESSARY BY INCREASING
C     THE WATER DEPTH BY 1/1000 OF A WAVE LENGTH, AND REDEFINE
C     THE AVERAGE INDEX OF REFRACTION IN THE WATER AND THE DEPTHS
C     AND INTERCEPTS IN THE BOTTOM
C
        CUTOFF=RCF(H2,1.0D0)
        IF(DABS(CUTOFF) .LT. 1.0D-12) THEN
        DEPINC=2.0D0*PI/(1000.0D0*FKW)
        WRITE(6,*) ' *** WARNING *** '
        WRITE(6,*) 'MODE CUTOFF AT RANGE=',RANGE(J+1),' KM'
        WRITE(6,*) 'DEPTH INCREASED BY ',DEPINC,' M'
        WRITE(9,*) ' '
        WRITE(9,*) ' *** WARNING *** '
        WRITE(9,*) 'MODE CUTOFF AT RANGE=',RANGE(J+1),' KM'
        WRITE(9,*) 'DEPTH INCREASED BY ',DEPINC,' M'
        DEPTH(J+1)=DEPTH(J+1)+DEPINC
        H2=DEPTH(J+1)
        CALL AVGIN(DEPW,CGRADW,CINTW,NPW,MX,H2,AVG,LHW)
        CALL BOTDEPS(H2,DEPB,CGRADB,CINTB,NPB,AVGB,LHB,MX)
        CW=CB/SQRT(AVG)
        FKW=2.0*PI*FREQ/CW
        AVGW(J+1)=AVG
        RHOWBOT(J+1)=RHOW(LHW)*DEXP(GRHOW(LHW)*(H2-DEPW(LHW)))
        ROHW=RHOWBOT(J+1)
        END IF
CC       
C         WRITE(9,*) 'CW,CB= ',CW,CB
C         WRITE(9,*) 'NPW,LHW= ',NPW,LHW
C         DO 218 KK=1,NPW
C         WRITE(9,227) DEPW(KK),CINTW(KK)+CGRADW(KK)*DEPW(KK),CGRADW(KK)
C  218    CONTINUE
C         WRITE(9,227) H2,CINTW(LHW)+CGRADW(LHW)*H2,CGRADW(LHW)
C         WRITE(9,*) 'NPB,LHB= ',NPB,LHB
C         DO 229 KK=1,NPB
C         WRITE(9,227) DEPB(KK),CINTB(KK)+CGRADB(KK)*DEPB(KK),CGRADB(KK)
C  227    FORMAT(1X,F10.4,2X,F10.4,2X,E12.4,2X,E12.4,2X,E12.4)
C  229    CONTINUE
C         WRITE(9,227) HB,CINTB(LHB)+CGRADB(LHB)*HB,CGRADB(LHB)
CC
        IF(IREIG(J+1) .LT. 0) THEN
        ISTART=(-IREIG(J+1)-1)*(M+3)
        READ(18,REC=ISTART+1) (BEGVR(I),I=1,M)
        DO 242 I=1,M
        READ(18,REC=ISTART+1+I) (BMATR(II,I),II=1,M)
  242   CONTINUE
        READ(18,REC=ISTART+M+2) (EGVR(I),I=1,M)
        READ(18,REC=ISTART+M+3) (FNORM(I),I=1,M)
        ELSE
        CALL GALRKN(H2,M,ZZ,EGVR,FNORM,
     1             BEGVR,BMATR,VMAT,MX,WRK,WRK1,RSPD,CLR,CRL,IPS,INTH,
     2             MXSD2,FA,FB,FU,FV,FCS,FZ1,FZ2,FD,FE,
     3             DEPW,CGRADW,CINTW,RHOW,GRHOW,NPW,AVG,LHW,
     4             DEPB,CGRADB,CINTB,RHOB,GRHOB,NPB,AVGB,LHB)
        END IF
C
      NPWR=NPW
      LHWR=LHW
      DO 250 KK=1,NPWR
      DEPWR(KK)=DEPW(KK)
      RHOWR(KK)=RHOW(KK)
      GRHOWR(KK)=GRHOW(KK)
  250 CONTINUE
C
      NPBR=NPB
      LHBR=LHB
      DO 253 KK=1,NPBR
      DEPBR(KK)=DEPB(KK)
      RHOBR(KK)=RHOB(KK)
      GRHOBR(KK)=GRHOB(KK)
  253 CONTINUE
C
      END IF
C
C      MOVED FOLLOWING LINE HERE ON 8/20/91. IT WAS ONLY DONE
C      IN THE GALERKIN METHOD BUT WAS ALSO NEEDED IN THE SEARCH 
C      METHOD. R. B. EVANS (SAIC, NEW LONDON, CT)
CCC
      FKWR=FKW
      ROHBR=ROHB
      ROHWR=ROHW
CCC
C
      DO 280 I=1,M
      FKH=FKB*CDSRT(ONE-EGVR(I))
      IF(REAL(FKH) .LT. 0.0)   THEN
      WRITE(9,*) ' ERROR IN REGION NO :',J+1
      WRITE(9,*) ' NEGATIVE WAVE NUMBER FOR MODE NO. ',I
      WRITE(9,*) ' WAVE NUMBER : ',FKH
      END IF
  280 CONTINUE
      JP1=J+1
      IF(IPRT .LE. 0) GO TO 330
      IF(JP1 .EQ. NREG) GO TO 290
      IF(MOD(JP1,IPRT) .NE. 0) GO TO 330
  290 CONTINUE
C
      WRITE(9,30)
      WRITE(6,35) JP1,RANGE(JP1),DEPTH(JP1)
      WRITE(9,35) JP1,RANGE(JP1),DEPTH(JP1)
      WRITE(9,30)
C
      DO 300 I=1,M
      FKH=FKB*CDSRT(ONE-EGVR(I))
      FKVS=FKB*CDSRT(EGVR(I)+CI*ATEN)
      FKVW=FKB*CDSRT((FKW/FKB)**2+EGVR(I)-ONE)
      WRITE(9,45) I,EGVR(I),FNORM(I),FKH,FKVS,FKVW
  300 CONTINUE
C
  330 CONTINUE
C
C     STORE UNIQUE SEQUENCE OF EIGENVALUES ECT., FOR RETRIEVAL
C
      IF(IREIG(J+1) .GT. 0) THEN
        IF(IMAT .GE. 1) THEN
        ISTART=(IREIG(J+1)-1)*(M+3)
        WRITE(18,REC=ISTART+1) (BEGVR(I),I=1,M)
        DO 342 I=1,M
        WRITE(18,REC=ISTART+1+I) (BMATR(II,I),II=1,M)
  342   CONTINUE
        WRITE(18,REC=ISTART+M+2) (EGVR(I),I=1,M)
        WRITE(18,REC=ISTART+M+3) (FNORM(I),I=1,M)
        ELSE
        ISTART=(IREIG(J+1)-1)*2
        WRITE(18,REC=ISTART+1) (EGVR(I),I=1,M)
        WRITE(18,REC=ISTART+2) (FNORM(I),I=1,M)
        END IF
      END IF
C
      IF(BSOUT .EQ. 1) GO TO 350
      IF(IMAT .GE. 1) WRITE(8) (BEGVR(I),I=1,M)
      IF(IMAT .GE. 1) WRITE(8) ((BMATR(II,I),II=1,M),I=1,M)
      WRITE(8) (EGVR(I),I=1,M)
      WRITE(8) (FNORM(I),I=1,M)
  350 CONTINUE
C
C     COMPUTE THE CROSS COUPLING MATRICES
C
      IF(IMAT .EQ. 0)   THEN
      CALL CRSCUP(H1,H2,M,EGVL,EGVR,CLR,CRL,MX,
     &            IMAT,BMATL,BMATR,WRK1,
     &            ALPHAR,BETAR,FNORMR,
     &            ALPHAL,BETAL,FNORML,FKWL,FKWR,ROHBL,ROHBR)
C      
C
      ELSE
      CALL CRSCUPB(H1,H2,M,BEGVL,BEGVR,CLR,CRL,MX,
     1            BMATL,BMATR,WRK1,ALPHAR,BETAR,FNORMR,
     2            ALPHAL,BETAL,FNORML,FKWL,FKWR,
     3            ROHWL,NPWL,DEPWL,RHOWL,GRHOWL,LHWL,
     4            ROHWR,NPWR,DEPWR,RHOWR,GRHOWR,LHWR,
     5            ROHBL,NPBL,DEPBL,RHOBL,GRHOBL,LHBL,
     6            ROHBR,NPBR,DEPBR,RHOBR,GRHOBR,LHBR)
C      
C
      END IF
C
C      WRITE(9,*) 'ROHBL,ROHBR= ',ROHBL,ROHBR
C
      IF(IPRT .EQ. 1) CALL PRTMAT(M,M,'CLR ',CLR,MX) 
      IF(IPRT .EQ. 1) CALL PRTMAT(M,M,'CRL ',CRL,MX) 
C
      RNG1=RANGE(J)*1000.
      IF(J .GT. 1)  RNG1=RANGE(J-1)*1000.
      RNG2=RANGE(J)*1000.
      MT2=M*2
C
C     COMPUTE THE PROPAGATOR MATRIX R
C
      CALL PROPM(M,RNG1,RNG2,EGVL,EGVR,CLR,CRL,R,MX,MXT2,IOUT)
C
C
      IF(BSOUT .NE. 1) GO TO 500
C
C     GENERATE THE OUTGOING COEFFICIENTS (BSOUT=1)
C
      DO 370 II=1,M
      SUM=ZERO
      DO 360 I=1,M
      SUM=SUM+R(II+M,I+M)*A(I)
  360 CONTINUE
      B(II)=SUM
  370 CONTINUE
C
      DO 380 I=1,M
      A(I)=B(I)
      B(I)=ZERO
  380 CONTINUE  
C
      IF(IPRT .LE. 0) GO TO 400
      IF(JP1 .EQ. NREG) GO TO 385
      IF(MOD(JP1,IPRT) .NE. 0) GO TO 400
  385 CONTINUE
C
      WRITE(9,105)
      WRITE(6,130) JP1,RANGE(JP1),DEPTH(JP1)
      WRITE(9,130) JP1,RANGE(JP1),DEPTH(JP1)
C
      DO 390 I=1,M
C
      ATL=200.
      AABS=CDABS(A(I))
      IF(AABS .GT. 1.0D-10) ATL=-20.*DLOG10(AABS)
      WRITE(9,135) I,A(I),ATL
  390 CONTINUE
C
  400 CONTINUE
C
      IF((RANGE(J+1) .LT. RMIN) .OR. (RANGE(J) .GE. RMAX)) GO TO 900
      IF(RKM .GT. RANGE(J+1)) GO TO 900
C
      R1KM=RANGE(J)
      R2KM=RANGE(J+1)
      JBOT=0
C
C     CALCULATE DEPTH FUNCTION AND PRESSURE (BSOUT=1)
C
C
      CALL CDFUN(M,EGVR,FNORM,H2,ZR,NDEP,CDF,MX,MD,
     1           IMAT,BEGVR,BMATR,ALPHA,FAC,RAT,BETA)
C
C
      CALL CPRES(M,RINC,RMAX,R1KM,R2KM,RKM,EGVR,A,B,
     1            NDEP,NDINC,CDF,JBOT,MX,MD,P,P0,P1,P2,
     2            TL,TL0,TL1,TL2,BSOUT,MAMP)
C
C
      GO TO 900
C 
  500 CONTINUE  
C
      IF(J .GT. 1) GO TO 580
C
      DO 550 I=1,MT2
      DO 540 II=1,MT2
      WRK2(II,I)=R(II,I)
  540 CONTINUE
  550 CONTINUE
C
      GO TO 600
C
  580 CONTINUE
C
C     STORE THE PRODUCT R*T IN WRK2 (WRK2=R*T)
C
      CALL MMULT(R,T,WRK2,MT2,MXT2) 
C
C
  600 CONTINUE
C
C     DO MODIFIED GRAM-SCHMIDT DECOMPOSITION OF (WRK2=T*U) 
C
C
      CALL MGS(WRK2,T,U,MT2,MXT2)
C
C     THE MATRICES T AND  U ARE PARTITIONED AS FOLLOWS:
C
C         T4 T3              UB  UC
C     T =         AND   U = 
C         T2 T1              0   UE
C
C     DEFINE UE
C
      DO 650 I=1,M
      DO 640 II=1,M
      UE(II,I)=U(M+II,M+I)
  640 CONTINUE
  650 CONTINUE
C
C     STORE UB, UC AND T
C
      WRITE(2) ((U(II,I),II=1,I),I=1,M)
      WRITE(2) ((U(II,M+I),II=1,M),I=1,M)
      WRITE(4) ((T(II,I),II=1,MT2),I=1,MT2)
C
      IF(J .GT. 1) GO TO 820
C
      DO 800 I=1,M
      DO 700 II=1,M
C
      Y1(II,I)=UE(II,I)
C
  700 CONTINUE
  800 CONTINUE
C
      GO TO 850
C
  820 CONTINUE
C
C     ADVANCE Y1 (Y1=UE*Y1)
C
      CALL MMULT(UE,Y1,WRK1,M,MX) 
C
C
      DO 840 I=1,M
      DO 830 II=1,I
      Y1(II,I)=WRK1(II,I)
  830 CONTINUE
  840 CONTINUE
C
  850 CONTINUE
C
      WRITE(21) ((Y1(II,I),II=1,I),I=1,M)
C
  900 CONTINUE
C
      DO 920 I=1,M
      BEGVL(I)=BEGVR(I)
      DO 910 II=1,M
      BMATL(II,I)=BMATR(II,I)
  910 CONTINUE
  920 CONTINUE
C
      DO 950 I=1,M
      EGVL(I)=EGVR(I)
  950 CONTINUE
C
      IF(IMAT .NE. 0) THEN
      NPWL=NPWR
      LHWL=LHWR
      DO 970 KK=1,NPWL
      DEPWL(KK)=DEPWR(KK)
      RHOWL(KK)=RHOWR(KK)
      GRHOWL(KK)=GRHOWR(KK)
  970 CONTINUE
C
      NPBL=NPBR
      LHBL=LHBR
      DO 975 KK=1,NPBL
      DEPBL(KK)=DEPBR(KK)
      RHOBL(KK)=RHOBR(KK)
      GRHOBL(KK)=GRHOBR(KK)
  975 CONTINUE
      END IF
CCC
      FKWL=FKWR
      ROHBL=ROHBR
      ROHWL=ROHWR
CCC
C 
 1000 CONTINUE
C
C ***** IF BSOUT=1,THE OUTGOING SOLUTION IS HAS BEEN OBTAINED *****
C *****               THE CALCULATION IN OVER                *****
C
      IF(BSOUT .EQ. 1) GO TO 8000
C
C     THE MATRIX Y1, IN THE LAST REGION, IS NOT READ FROM UNIT21
C     IN THE LOOP TO GENERATE Y3, BUT IS USED IMEDIATELY IN THE 
C     SOLVE FOR Y3
C
      ENDFILE 21
      BACKSPACE 21
      BACKSPACE 21
      ENDFILE 2
      BACKSPACE 2
C
      ENDFILE 4
      REWIND 4
C
      ENDFILE 8
      REWIND 8
C
C     SET UP MATRIX EQUATION FOR Y3 IN THE LAST REGION. T3 IS 
C     MULTIPLIED BY -1 FOR CONVENIENCE. 
C
      DO 1200 I=1,M
      DO 1100 II=1,M
      T4(II,I)=T(II,I)
      T3(II,I)=-T(II,M+I)
 1100 CONTINUE
 1200 CONTINUE
C
C************ SOLVE MATRIX EQUATION FOR Y3 ***************
C
      CALL MMULT(T3,Y1,Y3,M,MX)
      IF(IPRT .GE. 1) CALL PRTMAT(M,M,'T4  ',T4,MX) 
      CALL CLINEQS(M,MX,M,MX,T4,Y3,WRK1,WRK,EGVR,IPS,IER)
C
      IFLAG=3
C
C     ABORT NOT COMMENTED OUT
C
      IF(IER .NE. 0) CALL ABORT(IFLAG)
C
      WRITE(9,105)
      IF(IER .EQ. 1)   THEN
      WRITE(6,1261) 
      WRITE(9,1261) 
      ELSE
      WRITE(6,1260) IER
      WRITE(9,1260) IER
      END IF
 1260 FORMAT(1X,4HIER=,I5///)
 1261 FORMAT(1X,///,
     & ' ***************************************************** ',
     & //,' WARNING :  FAILURE TO IMPROVE BY IMPRUV IN CLINEQS ',/, 
     &    '            AS ITERATION DID NOT CONVERGE IN SOLVE ',//,
     & ' *********************************************** ',///)
C
      WRITE(3) ((Y3(II,I),II=1,M),I=1,M)  
C
C************* START IN GOING LOOP TO GENERATE Y3 **************
C
C
      DO 2000 JJ=1,NREM1
      J=NREM1-JJ+1
C
      BACKSPACE 2
      BACKSPACE 2
      READ(2) ((UB(II,I),II=1,I),I=1,M)
      READ(2) ((UC(II,I),II=1,M),I=1,M)
      BACKSPACE 2
      BACKSPACE 2
C
      IF(J .GT. 1) GO TO 1500
C
      DO 1400 I=1,M
      DO 1300 II=1,M
      WRK1(II,I)=Y3(II,I)-UC(II,I)
 1300 CONTINUE
 1400 CONTINUE
      GO TO 1900
C
 1500 CONTINUE
C
      BACKSPACE 21
      READ(21) ((Y1(II,I),II=1,I),I=1,M)
      BACKSPACE 21
C
C
      CALL MMULT(UC,Y1,WRK1,M,MX)
C
C
      DO 1800 I=1,M
      DO 1700 II=1,M
      WRK1(II,I)=Y3(II,I)-WRK1(II,I)
 1700 CONTINUE
 1800 CONTINUE
C
C
 1900 CONTINUE
C
C
      CALL BACKSUB(UB,Y3,WRK1,M,MX)
C
C
      IF(J .GT. 1) WRITE(3) ((Y3(II,I),II=1,M),I=1,M)
C
 2000 CONTINUE
C
      ENDFILE 3
      BACKSPACE 3
C 
      REWIND 21
C
C     THE LAST Y3 (J=1) COMPUTED IS THE REFLECTION MATRIX FOR
C     REGION 2 THROUGH NREG. THE MATRIX Y3 IS USED IN THE
C     SET UP OF THE MATRIX EQUATION FOR THE VECTOR C1 THAT 
C     SATISFIES THE SOURCE CONDITION IN THE FIRST REGION.
C     THE MATRIX Y3 IS ALSO USED IN TO GENERATE THE INCOMING
C     COEFFICIENTS IN THE FIRST REGION. 
C
      IF(IMAT .GE. 1) READ(8) (BEGVL(I),I=1,M)
      IF(IMAT .GE. 1) READ(8) ((BMATL(II,I),II=1,M),I=1,M)
      READ(8) (EGVL(I),I=1,M)
      READ(8) (FNORM(I),I=1,M)
C
      H1=DEPTH(1)
C
      IF(IMAT .NE. 0)   THEN
      AVG=AVGW(1)
      ROHW=RHOWBOT(1)
      ROHB=RHOBTOP(1)
      CW=CB/SQRT(AVG)
      FKW=2.0*PI*FREQ/CW
      END IF
C
      RNG1=RANGE(1)*1000.
C
C     STORE THE MATRIX I-D*Y3 IN T4
C
      IF(NEWSBC .GT. 0)   THEN
      WRITE(6,2100)
      WRITE(9,2100)
 2100 FORMAT(1X,/,
     & ' *** NEW INITIAL SOURCE BOUNDARY CONDITIONS ARE COMPUTED ***',/)
      END IF
C
      DO 2500 II=1,M
C
      FKH=FKB*CDSRT(ONE-EGVL(II))
      IF(-DIMAG(2.*FKH*RNG1) .LT. -88.) GO TO 2150
      IF(IGEOM .EQ. 1) THEN
      CXP=CDEXP(2.*CI*FKH*RNG1)
      ELSE
      CXP=-CI*CDEXP(2.*CI*FKH*RNG1)
      END IF
      GO TO 2200
 2150 CONTINUE
      CXP=ZERO
 2200 CONTINUE
      IF(NEWSBC .EQ. 0)   THEN
      DO 2400 I=1,M
      T4(II,I)=-CXP*Y3(II,I)
      IF(I .EQ. II) T4(II,I)=ONE+T4(II,I)
 2400 CONTINUE
      ELSE
      DO 2450 I=1,M
      T4(II,I)=ZERO
      IF(I .EQ. II) T4(II,I)=ONE
 2450 CONTINUE
      END IF
C
 2500 CONTINUE
C
C 
      IF(IPRT .GE. 1) CALL PRTMAT(M,M,'REFL',Y3,MX) 
      IF(IPRT .GE. 1) CALL PRTMAT(M,M,'I-DY',T4,MX) 
C
C ********** SOLVE MATRIX EQUATION FOR C1 *****************
C
      CALL CLINEQS(M,MX,1,1,T4,C1,WRK1,WRK,EGVR,IPS,IER)
C     
C
      IFLAG=3
C
C     ABORT NOT COMMENTED OUT
C
      IF(IER .NE. 0) CALL ABORT(IFLAG)
C
      WRITE(9,105)
      IF(IER .EQ. 1)   THEN
      WRITE(6,1261) 
      WRITE(9,1261) 
      ELSE
      WRITE(6,1260) IER
      WRITE(9,1260) IER
      END IF
C
      WRITE(6,3690) 1,RANGE(1),DEPTH(1)
      WRITE(9,3690) 1,RANGE(1),DEPTH(1)
 3690 FORMAT(1X,27HTHE COEFFICIENTS IN REGION ,I5,11H ENDING AT ,F10.3,
     1       16H  KM WITH DEPTH ,F10.2,18H  M ARE AS FOLLOWS///
     2       10H  MODE NO.,11X,8HOUTGOING,14X,11HBACKSCATTER,
     3       12X,13HOUTGOING (DB),4X,16HBACKSCATTER (DB),3X,
     4       10HTOTAL (DB)//)
C
C     GENERATE THE COEFFICIENTS IN THE FIRST REGION
C
      DO 4000 II=1,M
      A(II)=C1(II)
      B(II)=C1(II)
 4000 CONTINUE
C
C     B=Y3*C1
C
      CALL CVMULT(M,Y3,B,MX,WRK) 
C
C
      DO 4100 I=1,M
C
      ATL=200.
      BTL=200.
      TTL=200.
      AABS=CDABS(A(I))
      BABS=CDABS(B(I))
      TABS=CDABS(A(I)+B(I))
      IF(AABS .GT. 1.0D-10) ATL=-20.*DLOG10(AABS)
      IF(BABS .GT. 1.0D-10) BTL=-20.*DLOG10(BABS)
      IF(TABS .GT. 1.0D-10) TTL=-20.*DLOG10(TABS)
C
      WRITE(9,4050) I,A(I),B(I),ATL,BTL,TTL
 4050 FORMAT(1X,I5,5X,2(1X,2E12.4),5X,F8.2,2(10X,F8.2))
 4100 CONTINUE
C
C     THIS INITIALIZES THE RANGE LOOP FOR THE PRESSURE CALCULATION
C     (BSOUT .NE. 1)
C
      RKM=RMIN
C
      IF(RANGE(1) .LT. RMIN) GO TO 4200
C
      R2KM=RANGE(1)
      R1KM=RANGE(1)
C
      JBOT=0
C
C     COMPUTE THE DEPTH FUNCTIONS AND PRESSURE IN THE FIRST REGION
C     (BSOUT .NE. 1)
C
      CALL CDFUN(M,EGVL,FNORM,H1,ZR,NDEP,CDF,MX,MD,
     1           IMAT,BEGVL,BMATL,ALPHA,FAC,RAT,BETA)
C
C
      CALL CPRES(M,RINC,RMAX,R1KM,R2KM,RKM,EGVL,A,B,
     1            NDEP,NDINC,CDF,JBOT,MX,MD,P,P0,P1,P2,
     2            TL,TL0,TL1,TL2,BSOUT,MAMP)
C
C
 4200 CONTINUE
C
C ************** LOOP FOR PRESSURE CALCULATION *********************
C **************         (BSOUT .NE. 1)         *********************
C
C
      DO 7000 J=1,NREM1
C
      IF(IMAT .GE. 1) READ(8) (BEGVR(I),I=1,M)
      IF(IMAT .GE. 1) READ(8) ((BMATR(II,I),II=1,M),I=1,M)
      READ(8) (EGVR(I),I=1,M)
      READ(8) (FNORM(I),I=1,M)
C
      H1=DEPTH(J)
      H2=DEPTH(J+1)
C
      IF(IMAT .EQ. 1) THEN
      AVG=AVGW(J+1)
      ROHW=RHOWBOT(J+1)
      ROHB=RHOBTOP(J+1)
      CW=CB/SQRT(AVG)
      FKW=2.0*PI*FREQ/CW
      END IF
C
      READ(4) ((T(II,I),II=1,MT2),I=1,MT2)
C
 6500 CONTINUE
C 
      READ(21) ((Y1(II,I),II=1,I),I=1,M)
C
      BACKSPACE 3
      READ(3) ((Y3(II,I),II=1,M),I=1,M)
      BACKSPACE 3
C
C     GENERATE COEFFICIENTS A AND B
C
      CALL GENAB(T,Y1,Y3,C1,A,B,WRK1,CLR,M,MX,MXT2)
C
C
      JP1=J+1
      IF(IPRT .LE. 0) GO TO 6850
      IF(JP1 .EQ. NREG) GO TO 6780
      IF(MOD(JP1,IPRT) .NE. 0) GO TO 6850
 6780 CONTINUE
C
      WRITE(9,105)
      WRITE(6,3690) JP1,RANGE(JP1),DEPTH(JP1)
      WRITE(9,3690) JP1,RANGE(JP1),DEPTH(JP1)
C
      DO 6800 I=1,M
C
      ATL=200.
      BTL=200.
      TTL=200.
      AABS=CDABS(A(I))
      BABS=CDABS(B(I))
      TABS=CDABS(A(I)+B(I))
      IF(AABS .GT. 1.0D-10) ATL=-20.*DLOG10(AABS)
      IF(BABS .GT. 1.0D-10) BTL=-20.*DLOG10(BABS)
      IF(TABS .GT. 1.0D-10) TTL=-20.*DLOG10(TABS)
C
      WRITE(9,4050) I,A(I),B(I),ATL,BTL,TTL
 6800 CONTINUE
      WRITE(9,105)
C
 6850 CONTINUE
C
      IF(J .LT. NREM1) GO TO 6880
C
      BMAX=0.
      DO 6860 I=1,M
      BMAX=DMAX1(BMAX,CDABS(B(I)))
      B(I)=ZERO
 6860 CONTINUE
C
      WRITE (6,105)
      WRITE(6,6870) BMAX
      WRITE(9,6870) BMAX
 6870 FORMAT(1X,'THE MAXIMUM MAGNITUDE OF THE BACKSCATTER COEFFICIENTS',
     1 ' IN THE LAST REGION WAS',/,E12.4,25H BEFORE BEING SET TO ZERO/)
C
 6880 CONTINUE
C
      IF((RANGE(J+1) .LT. RMIN) .OR. (RANGE(J) .GE. RMAX)) GO TO 6900
      IF(RKM .GT. RANGE(J+1)) GO TO 6900
C
      R1KM=RANGE(J)
      R2KM=RANGE(J+1)
      JBOT=0
C
C     CALCULATE DEPTH FUNCTION AND PRESSURE (BSOUT .NE. 1)
C
      CALL CDFUN(M,EGVR,FNORM,H2,ZR,NDEP,CDF,MX,MD,
     1           IMAT,BEGVR,BMATR,ALPHA,FAC,RAT,BETA)
C
C
      CALL CPRES(M,RINC,RMAX,R1KM,R2KM,RKM,EGVR,A,B,
     1            NDEP,NDINC,CDF,JBOT,MX,MD,P,P0,P1,P2,
     2            TL,TL0,TL1,TL2,BSOUT,MAMP)
C
C
 6900 CONTINUE
C
      DO 6920 I=1,M
      BEGVL(I)=BEGVR(I)
      DO 6910 II=1,M
      BMATL(II,I)=BMATR(II,I)
 6910 CONTINUE
 6920 CONTINUE
C
      DO 6950 I=1,M
      EGVL(I)=EGVR(I)
 6950 CONTINUE
C
 7000 CONTINUE
 8000 CONTINUE
C
      ENDFILE 7
      ENDFILE 10
      IF(MAMP .GT. 0) ENDFILE 11
      IF(BSOUT .NE. 1) THEN
      ENDFILE 12
      ENDFILE 13
      ENDFILE 14
      ENDFILE 15
      ENDFILE 16
      ENDFILE 17
      END IF
C
      REWIND 7
      REWIND 10
      REWIND LUSVP
      IF(MAMP .GT. 0) REWIND 11
      IF(BSOUT .NE. 1) THEN
      REWIND 12
      REWIND 13
      REWIND 14
      REWIND 15
      REWIND 16
      REWIND 17
      END IF
C
C     PRINT TRANSMISSION LOSS
C
      WRITE(6,*) 'CALL PRTTL'
      WRITE(9,*) 'CALL PRTTL'
      CALL PRTTL(TITLE,FREQ,ZS,ZR,TL)
C
C     CLOSE THE SCRATCH FILES
C
      CLOSE(21,STATUS='DELETE')
      CLOSE(2,STATUS='DELETE')
      CLOSE(3,STATUS='DELETE')
      CLOSE(4,STATUS='DELETE')
      CLOSE(8,STATUS='DELETE')
      CLOSE(18,STATUS='DELETE')
      CLOSE(LUSVP,STATUS='DELETE')
C 
C     FIND ELAPSED TIME IN UNIX
C
      IENDS=time()
      ELAPSE=IENDS-ISTARTS
C 
C     FIND ELAPSED TIME IN LAHEY
C
C      CALL TIMER(IHU)
C      ENDS=.01*IHU
C      ELAPSE=ENDS-STARTS
C
      WRITE(6,8100) ELAPSE
      WRITE(9,8100) ELAPSE
 8100 FORMAT(1X,'TOTAL ELAPSED TIME= ',F10.3,'  SECONDS')    
C
 9000 CONTINUE
C
      ENDFILE 9
      ENDFILE 6
C
      STOP
      END

      COMPLEX*16 FUNCTION CHDH(EGV,RNG1,RNG2)
C
C     THIS FUNCTION COMPUTES AN ASYMPTOTIC APPROX. FOR THE RATIO OF
C     HANKEL FUNCTIONS OF ORDER ZERO TYPE ONE WHICH APPEARS IN
C     THE REPRESENTATION OF THE COMPLEX PRESSURE. RNG2 IS THE CURRENT
C     RANGE AND RNG1 IS THE RANGE OF THE LAST (.LE. RNG2) INTERFACE.
C     THIS FUNCTION ALSO APPEARS IN TRANSM.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
      COMMON /FLAGS/ IGEOM,NEWSBC
      COMPLEX*16 ONE,CI,EGV
      COMPLEX*16 FKH
      COMPLEX*16 CDSRT 
C
      ONE=DCMPLX(1.0,0.0)
      CI=DCMPLX(0.0,1.0)
C
      FKH=FKB*CDSRT(ONE-EGV)
      IF(IGEOM .EQ. 1) THEN
      CHDH=CDEXP(CI*FKH*(RNG2-RNG1))
      ELSE
      CHDH=SQRT(RNG1/RNG2)*CDEXP(CI*FKH*(RNG2-RNG1))
      END IF
C
      RETURN
      END

      SUBROUTINE GENAB(T,Y1,Y3,C1,A,B,WRK1,WRK2,M,MX,MXT2)
C
C     THIS SUBROUTINE GENERATES THE COEFFICEINTS OF THE OUTGOING
C     AND INGOING WAVES USING THE EQUATIONS: B=(T4*Y3+T3*Y1)*C1
C     AND A=(T2*Y3+T1*Y1)*C1
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 T(MXT2,MXT2)
      COMPLEX*16 Y1(MX,MX),Y3(MX,MX),WRK1(MX,MX),WRK2(MX,MX)
      COMPLEX*16 A(MX),B(MX),C1(MX)
      COMPLEX*16 SUM1,SUM2,ZERO
C
      ZERO=DCMPLX(0.0,0.0)
C
      DO 300 II=1,M
      DO 200 I=1,M
C
      SUM1=ZERO
      SUM2=ZERO
C
      DO 100 K=1,M
C
      SUM1=SUM1+T(II,K)*Y3(K,I)+T(II,M+K)*Y1(K,I)
      SUM2=SUM2+T(M+II,K)*Y3(K,I)+T(M+II,M+K)*Y1(K,I)
C
  100 CONTINUE
C
      WRK1(II,I)=SUM1
      WRK2(II,I)=SUM2
C
  200 CONTINUE
  300 CONTINUE
C
      DO 600 II=1,M
C
      SUM1=ZERO
      SUM2=ZERO
C
      DO 500 I=1,M
C
      SUM1=SUM1+WRK1(II,I)*C1(I)
      SUM2=SUM2+WRK2(II,I)*C1(I)
C
  500 CONTINUE
C
      B(II)=SUM1
      A(II)=SUM2
C
  600 CONTINUE
C
      RETURN
      END

      SUBROUTINE TMMULT(M,BMATR,CLR,BMATL,MX,W4)
C
C     THIS SUBROUTINE COMPUTES THE PRODUCT TRANSPOSE(BMATR)*
C     CLR*BMATL AND STORES THE RESULT IN CLR.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 CLR(MX,MX)
      COMPLEX*16 BMATR(MX,MX),BMATL(MX,MX)
      COMPLEX*16 W4(MX,MX)
      COMPLEX*16 ZERO,SUM1
C
C
      ZERO=DCMPLX(0.0,0.0)
C
      DO 300 II=1,M
      DO 200 I=1,M
C
      SUM1=ZERO
C
      DO 100 K=1,M
C
      SUM1=SUM1+CLR(II,K)*BMATL(K,I)
C
  100 CONTINUE
C
      W4(II,I)=SUM1
C
  200 CONTINUE
  300 CONTINUE
C
      DO 600 II=1,M
      DO 500 I=1,M
C
      CLR(II,I)=W4(II,I)
C
  500 CONTINUE
  600 CONTINUE
C
C
      DO 900 II=1,M
      DO 800 I=1,M
C
      SUM1=ZERO
C
      DO 700 K=1,M
C
      SUM1=SUM1+BMATR(K,II)*CLR(K,I)
C
  700 CONTINUE
C
      W4(II,I)=SUM1
C
  800 CONTINUE
  900 CONTINUE
C
      DO 1100 II=1,M
      DO 1000 I=1,M
C
      CLR(II,I)=W4(II,I)
C
 1000 CONTINUE
 1100 CONTINUE
C
      RETURN
      END

      SUBROUTINE CDFUN(M,EGVL,FNORM,H1,ZR,NDEP,CDF,MX,
     1                 MD,IMAT,BEGVL,BMATL,ALPHA,FAC,RAT,BETA)
C
C     THIS SUBROUTINE COMPUTES THE VALUES OF THE COMPLEX*16 DEPTH FUNCTION
C     CDF AT EACH OF THE NDEP OUTPUT DEPTHS ZR IN THE REGION WITH
C     EIGENVALUES GIVEN BY EGVL
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION ZR(MD)
      COMPLEX*16 BEGVL(MX),BMATL(MX,MX)
      COMPLEX*16 EGVL(MX),FNORM(MX),CDF(MX,MD)
      COMPLEX*16 ALPHA(MX), FAC(MX), RAT(MX), BETA(MX)
      COMPLEX*16 CDSRT,ONE,CI
      COMPLEX*16 SUM,ZERO
      COMPLEX*16 CSDS, BDF1
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      ONE=DCMPLX(1.0,0.0)
      ZERO=DCMPLX(0.0,0.0)
      CI=DCMPLX(0.0,1.0)
      FKW2=FKW**2
      FKB2=FKB**2
C
      IF(IMAT .LT. 1)   THEN
C
       DO 100   I=1,M
       BETA(I)=CDSRT(FKB2*(EGVL(I)+CI*ATEN))
       ALPHA(I)=CDSRT(FKW2+FKB2*(EGVL(I)-ONE))
       FAC(I)=FKB2/(ALPHA(I)*CDSRT(FNORM(I)))
       RAT(I)=FAC(I)*CDSIN(ALPHA(I)*H1)
  100  CONTINUE
C
       DO 300 I=1,M
C
       DO 200 J=1,NDEP
       IF(ZR(J) .LT. H1)   THEN
        CDF(I,J)=FAC(I)*CDSIN(ALPHA(I)*ZR(J))
       ELSE
        CDF(I,J)=RAT(I)*CSDS(ZR(J),H1,BETA(I))
       END IF
  200  CONTINUE
C
  300  CONTINUE
C
      ELSE
C
       DO 420   I=1,M
       ALPHA(I)=CDSRT(FKW2+FKB2*(BEGVL(I)-ONE))
       FAC(I)=FKB2/(ALPHA(I)*CDSRT(FNORM(I)))
       RAT(I)=FAC(I)*CDSIN(ALPHA(I)*H1)
       BETA(I)=CDSRT(FKB2*BEGVL(I))
  420  CONTINUE
C
       DO 900 J=1,NDEP
       IF(ZR(J) .LE. H1)   THEN
C
        DO 600 I=1,M
        SUM=ZERO
        DO 500 II=1,M
        BDF1=FAC(II)*CDSIN(ALPHA(II)*ZR(J))
        SUM=SUM+BMATL(II,I)*BDF1
  500   CONTINUE
        CDF(I,J)=SUM
  600   CONTINUE
C
       ELSE
C
        DO 800 I=1,M
        SUM=ZERO
        DO 700 II=1,M
        BDF1=RAT(II)*CSDS(ZR(J),H1,BETA(II))
        SUM=SUM+BMATL(II,I)*BDF1
  700   CONTINUE
        CDF(I,J)=SUM
  800   CONTINUE
C
       END IF
C
  900  CONTINUE
C
      END IF
C
      RETURN
      END

      SUBROUTINE BMAT(HW,M,BEGVL,FNORM,B,MX,DEPW,RHOW,GRHOW,NPW,LHW,
     1                DEPB,RHOB,GRHOB,NPB,LHB)
C
C     THE FOLLOWING SUBROUTINE COMPUTES THE POSITIVE DEFINITE 
C     SYMETRIC MATRIX B NEEDED BY GALRKN. THIS MATRIX IS USED 
C     TO FORM PART OF THE GENERALIZED PROBLEM THAT IS SOLVED TO
C     FIND THE EIGENVALUES AND EIGENFUNCTIONS IN TERMS OF THE BASIC
C     EIGENFUNCTIONS.
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION DEPW(MX),RHOW(MX),GRHOW(MX)
      DIMENSION DEPB(MX),RHOB(MX),GRHOB(MX)
      REAL*8 B(MX,MX)
      COMPLEX*16 BEGVL(MX)
      COMPLEX*16 ONE
      COMPLEX*16 CDSRT,CEXIB,CEXIW
      COMPLEX*16 ALPHA1,ALPHA2,BETA1,BETA2
      COMPLEX*16 FNORM(MX)
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      ONE=DCMPLX(1.0,0.0)
      LHWM1=LHW-1
      LHBM1=LHB-1
C
C     COMPUTE THE (REAL) SYMMETRIC MATRIX B 
C
      DO 500 I=1,M
      ALPHA1=CDSRT(FKW**2+FKB**2*(BEGVL(I)-ONE))
      BETA1=CDSRT(FKB**2*BEGVL(I))
      DO 400 II=I,M
      ALPHA2=CDSRT(FKW**2+FKB**2*(BEGVL(II)-ONE))
      BETA2=CDSRT(FKB**2*BEGVL(II))
C
C     INITIALIZE WITH ZERO
C
      B(II,I)=0.0D0
C
C     SUM OVER WATER LAYERS
C
      IF(LHWM1 .EQ. 0) GO TO 200
      DO 150 L=1,LHWM1
      Z1=DEPW(L)
      Z2=DEPW(L+1)
      B(II,I)=B(II,I)+DREAL(CEXIW(Z1,Z2,DEPW(L),RHOW(L),
     1                      GRHOW(L),ALPHA1,ALPHA2))
  150 CONTINUE
  200 CONTINUE
C
      Z1=DEPW(LHW)
      B(II,I)=B(II,I)+DREAL(CEXIW(Z1,HW,DEPW(LHW),RHOW(LHW),
     1                      GRHOW(LHW),ALPHA1,ALPHA2))
C
C     SUM OVER BOTTOM LAYERS
C
      IF(LHBM1 .EQ. 0) GO TO 300
      DO 250 L=1,LHBM1
      Z1=DEPB(L)
      Z2=DEPB(L+1)
      B(II,I)=B(II,I)+DREAL(CEXIB(HW,HW,Z1,Z2,DEPB(L),RHOB(L),
     1                      GRHOB(L),ALPHA1,ALPHA2,BETA1,BETA2))
  250 CONTINUE
  300 CONTINUE
C
      Z1=DEPB(LHB)
      B(II,I)=B(II,I)+DREAL(CEXIB(HW,HW,Z1,HB,DEPB(LHB),RHOB(LHB),
     1                      GRHOB(LHB),ALPHA1,ALPHA2,BETA1,BETA2))
C
C     APPLY NORMALIZATION FOR THE BASIC EIGENFUNCTIONS
C
      B(II,I)=B(II,I)/DREAL(CDSRT(FNORM(II))*CDSRT(FNORM(I)))
C
C     DEFINE THE SUB DIAGONAL ENTRIES BY SYMMETRY
C
      IF(II .NE. I) B(I,II)=B(II,I)
C
  400 CONTINUE
  500 CONTINUE
C
      RETURN
      END

      SUBROUTINE CEGV(H,M,EGV,MX,ERMAX)
C
C     THIS SUBROUTINE COMPUTES THE COMPLEX EIGENVALUES USING NEWTONS
C     METHOD STARTING WITH THE INITIAL ESTIMATES IN EGV.THIS IS THE
C     DOUBLE PRECISION VERSION
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 EGV(MX)
      COMPLEX*16 ALPHA,BETA,A,B,Z,U,V,W,DELTA
      COMPLEX*16 X,Y,DEGV
      COMPLEX*16 CDTAN
      COMPLEX*16 CDSRT
      COMPLEX*16 ONE,CI
C
      REAL*8 ERMAX,ERR,ESP2
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      DATA ESP1,ESP2,ITMAX /.1D-09,.1D-13,20/
C
C
      CI=DCMPLX(0.0D0,1.0D0)
      ONE=DCMPLX(1.0D0,0.0D0)
      ERMAX=0.
C
      IF(ATEN .LT. ESP1) GO TO 600
C
      DO 500 I=1,M
C
      K=0
      DEGV=EGV(I)
C
  100 CONTINUE
C
      K=K+1
      ALPHA=CDSRT(FKW**2+FKB**2*(DEGV-ONE))
      BETA=CDSRT(FKB**2*(DEGV+CI*ATEN))
      A=ALPHA*H
      B=BETA*(H-HB)
      X=A*CDCOS(A)-CDSIN(A)
      Y=B-CDTAN(B)
C
      Z=2.0*(ALPHA*BETA)**2/FKB**2
      U=ROHW*BETA*CDSIN(A)-ROHB*ALPHA*CDCOS(A)*CDTAN(B)
      V=ROHW*BETA**3*X-ROHB*ALPHA**3*Y*CDCOS(A)
      W=(ALPHA*BETA)**2*CDSIN(A)*CDTAN(B)*(ROHW*HB+(ROHB-ROHW)*H)
C
      DELTA=Z*U/(V+W)
      DEGV=DEGV-DELTA
C
      ERR=CDABS(DELTA/DEGV)
      IF(ERR .LT. ESP2) GO TO 300
      IF(K .GT. ITMAX) GO TO 200
C
      GO TO 100
C
  200 CONTINUE
      ERMAX=DMAX1(ERR,ERMAX)
      EGV(I)=DEGV
C
      GO TO 500
C
  300 CONTINUE
      ERMAX=DMAX1(ERR,ERMAX)
      EGV(I)=DEGV 
C
C
  500 CONTINUE
C
C
      IFLAG=0
      IF(ERMAX .GT. ESP1) CALL ABORTC(IFLAG)
C
  600 CONTINUE
C
      RETURN
      END

      COMPLEX*16 FUNCTION CDJ0(Z)
C
C     THIS FUNCTION COMPUTES J0 FOR A SMALL COMPLEX ARGUMENT USING
C     EIGHT TERMS IN THE POWER SERIES EXPANSION ABOUT ZERO 
C     (SEE ABRAMOWITZ & STEGUM PG. 360, EQ. 9.1.10). IT SHOULD BE
C     USEFUL WHEN CDABS(Z) .LT. 2.0D0. THIS IS THE COMPLEX DOUBLE
C     PRECISION VERSION.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 Z,W,ONE,SUM,FACT
C
      ONE=DCMPLX(1.0D0,0.0D0)
C
      W=(-0.25D0)*(Z**2)
      FACT=ONE
      SUM=ONE
C
      DO 100 I=1,7
      FACT=FACT*DBLE(FLOAT(I))
      SUM=SUM+(W**I)/(FACT**2)
  100 CONTINUE
C
      CDJ0=SUM
C
      RETURN
      END

      COMPLEX*16 FUNCTION CCDS(H1,H2,BETA)
C
C     THIS FUNCTION EVALUATES THE RATIOS OF COSINE AND SINE
C     FUNCTIONS WHICH APPEARS IN THE CROSS COUPLING INTEGRALS.
C     IT IS DESIGNED SPECIFICALLY FOR THE CASE WHEN (H-HB)*BETA
C     HAS A LARGE IMAGINARY PART.
C
      IMPLICIT REAL*8 (A-H,O-Z)
C      COMMON /ACCUR/ CONST1
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      COMPLEX*16 BETA,CI,U,V,W,ARG1,ARG2
C
      CI=DCMPLX(0.0,1.0)
C
      ARG1=BETA*2.0*(HB-H1)
      ARG2=BETA*2.0*(HB-H2)
C
C     88.0D0 IS A MACHINE DEPENDENT CONSTANT, THE FOLLOWING LOGIC
C     ELIMINATES UNDERFLOW ERRORS.
C
      IF(DIMAG(ARG1) .GT. 88.0D0) THEN
      U=DCMPLX(1.0,0.0)
      ELSE
      U=1.0+CDEXP(CI*ARG1)
      END IF
C
      IF(DIMAG(ARG2) .GT. 88.0D0) THEN
      V=DCMPLX(1.0,0.0)
      ELSE
      V=1.0-CDEXP(CI*ARG2)
      END IF
C
      W=CDEXP(CI*BETA*(H1-H2))
      CCDS=CI*W*U/V
C
      RETURN
      END

      SUBROUTINE PRTMAT(MR,MC,NAME,S4,MX)
C
C     THIS SUBROUTINE GENERATES A ONE PAGE PRINT OUT OF THE ABSOLUTE
C     VALUE OF THE ELEMENTS IN A 20X20 COMPLEX MATRIX IN E6.1 FORMAT
C     WITH THE DIAGONAL ELEMENTS UNDERLINED. IN ADDITION THE MIN. AND
C     MAX. OF:  THE FIRST AND LAST ROW AND COL., THE ELEMENTS ABOVE THE
C     DIAGONAL, THE ELEMENTS ON THE DIAG., AND  THE ELEMENTS BELOW THE 
C     DIAG. ARE PRINTED.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION XMAG(20)
      CHARACTER*4 NAME
      CHARACTER*6 IDIAG(20),BLANK,DASH
      COMPLEX*16  S4(MX,MX)
C
      DATA BLANK,DASH /'      ','______'/
C
      MP=MIN0(20,MR,MC)
      M=MIN0(MR,MC)
      WRITE(9,100) NAME
  100 FORMAT(1H1,6HARRAY-,A4/)
C
      WRITE(9,200) (I,I=1,MP)
  200 FORMAT(5X,20I6)
C
      DO 800 II=1,MP
C
      DO 300 I=1,MP
      XMAG(I)=CDABS(S4(II,I))
  300 CONTINUE
C
      WRITE(9,400) II,(SNGL(XMAG(I)),I=1,MP)
  400 FORMAT(1X,I2,2X,20E6.1)
C
      IIM1=II-1
      IIP1=II+1
C
      DO 500 I=1,IIM1
      IDIAG(I)=BLANK
  500 CONTINUE
C
      IDIAG(II)=DASH
C
      DO 600 I=IIP1,MP
      IDIAG(I)=BLANK
  600 CONTINUE
C
      WRITE(9,700) (IDIAG(I),I=1,MP)
  700 FORMAT(1X,4X,20A6)
C
  800 CONTINUE
C
      XMAG(1)=.1D+38
      XMAG(2)=0.0D0
      XMAG(3)=.1D+38
      XMAG(4)=0.0D0
C
      DO 900 II=1,MR
      XMAG(1)=DMIN1(XMAG(1),CDABS(S4(II,1)))
      XMAG(2)=DMAX1(XMAG(2),CDABS(S4(II,1)))
      XMAG(3)=DMIN1(XMAG(3),CDABS(S4(II,MC)))
      XMAG(4)=DMAX1(XMAG(4),CDABS(S4(II,MC)))
  900 CONTINUE
C
      XMAG(5)=.1D+38
      XMAG(6)=0.0D0
      XMAG(7)=.1D+38
      XMAG(8)=0.0D0
C
      DO 1000 I=1,MC
      XMAG(5)=DMIN1(XMAG(5),CDABS(S4(1,I)))
      XMAG(6)=DMAX1(XMAG(6),CDABS(S4(1,I)))
      XMAG(7)=DMIN1(XMAG(7),CDABS(S4(MR,I)))
      XMAG(8)=DMAX1(XMAG(8),CDABS(S4(MR,I)))
 1000 CONTINUE
C
C
      XMAG(9)=.1D+38
      XMAG(10)=0.0D0
      XMAG(11)=.1D+38
      XMAG(12)=0.0D0
      XMAG(13)=.1D+38
      XMAG(14)=0.0D0
      FMAXD=-.1D+38
      FMIND=+.1D+38
C
      DO 1300 I=1,MC
      DO 1200 II=1,MR
      IF(II .LT. I) THEN
      XMAG(9)=DMIN1(XMAG(9),CDABS(S4(II,I)))
      XMAG(10)=DMAX1(XMAG(10),CDABS(S4(II,I)))
      ELSE IF (II .EQ. I) THEN
      XMAG(11)=DMIN1(XMAG(11),CDABS(S4(II,I)))
      XMAG(12)=DMAX1(XMAG(12),CDABS(S4(II,I)))
C
C      WRITE(9,*) II,DREAL(S4(II,I))
C      WRITE(6,*) II,DREAL(S4(II,I))
C
      FMAXD=DMAX1(FMAXD,DREAL(S4(II,I)))
      FMIND=DMIN1(FMIND,DREAL(S4(II,I)))
      ELSE IF (II .GT. I) THEN
      XMAG(13)=DMIN1(XMAG(13),CDABS(S4(II,I)))
      XMAG(14)=DMAX1(XMAG(14),CDABS(S4(II,I)))
      END IF 
 1200 CONTINUE
 1300 CONTINUE
C
      WRITE(9,1500)
 1500 FORMAT(//)
C
      WRITE(9,1600) 1,SNGL(XMAG(1)),SNGL(XMAG(2))
      WRITE(9,1600) MC,SNGL(XMAG(3)),SNGL(XMAG(4))
 1600 FORMAT(1X,'THE MIN. AND MAX. MAG. IN COL.',I5,' ARE ',2E12.4/)
C
      WRITE(9,1700) 1,SNGL(XMAG(5)),SNGL(XMAG(6))
      WRITE(9,1700) MR,SNGL(XMAG(7)),SNGL(XMAG(8))
 1700 FORMAT(1X,'THE MIN. AND MAX. MAG. IN ROW ',I5,' ARE ',2E12.4/)
      WRITE(9,1500)
C
      WRITE(9,1800) SNGL(XMAG(9)),SNGL(XMAG(10))
 1800 FORMAT(1X,'THE MIN. AND MAX. MAG. ABOVE THE DIAG. ARE ',2E12.4/)
C
      WRITE(9,1900) SNGL(XMAG(11)),SNGL(XMAG(12))
 1900 FORMAT(1X,'THE MIN. AND MAX. MAG. ON THE DIAG. ARE ',2E12.4/)
C
      WRITE(9,1950) SNGL(FMIND),SNGL(FMAXD)
 1950 FORMAT(1X,'THE MIN. AND MAX. ON THE DIAG. ARE ',2E12.4/)
C
      WRITE(9,2000) SNGL(XMAG(13)),SNGL(XMAG(14))
 2000 FORMAT(1X,'THE MIN. AND MAX. MAG. BELOW THE DIAG. ARE ',2E12.4/)
C
      RETURN
      END
 

      SUBROUTINE AVGIN(DEP,CGRAD,CINT,NP,MX,H,AVG,LH)
C
C     THIS SUBROUTINE COMPUTES THE AVERAGE AVG OF THE REAL PART OF
C     THE PIECEWISE LINEAR SQUARE OF THE INDEX OF REFRACTION ON THE 
C     INTERVAL 0 TO H. IT ALSO RETURNS THE INDEX LH OF THE INTERVAL 
C     IN THE SOUND VELOCITY PROFILE WHICH CONTAINS H. IF H .GT. 
C     DEP(NP) THEN LH=NP AND THE REAL PART OF THE SQUARE OF THE 
C     INDEX OF REFRACTION IS LINEARLY EXTRAPOLATED TO H TO OBTAIN 
C     THE AVERAGE.      
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION DEP(MX)
C      REAL*8 DREAL
      COMPLEX*16 CGRAD(MX),CINT(MX)
C
      AVG=0.0D0
C
      DO 100 LH=1,NP-1
      IF(DEP(LH+1) .GE. H) GO TO 200
  100 CONTINUE
C
C     IF H .GT. DEP(NP), EXTRAPOLATION WILL BE DONE
C
      LH=NP
  200 CONTINUE
C
      IF(LH .GT. 1)   THEN
C
      DO 300 I=1,LH-1
      DD=DEP(I+1)-DEP(I)
      DDSD2=(DEP(I+1)**2-DEP(I)**2)/2.0
      AVG=AVG+DREAL(CGRAD(I))*DDSD2+DREAL(CINT(I))*DD
  300 CONTINUE
C
      END IF
C
      DD=H-DEP(LH)
      DDSD2=(H**2-DEP(LH)**2)/2.0
      AVG=AVG+DREAL(CGRAD(LH))*DDSD2+DREAL(CINT(LH))*DD
C      
      AVG=AVG/H
C
      RETURN
      END

C     ..................................................................
C                                                                       
C        SUBROUTINE CIGMAT                                              
C                                                                       
C        PURPOSE                                                        
C           COMPUTE EIGENVALUES AND EIGENVECTORS OF A COMPLEX MATRIX    
C           COMPLEX*16 VERSION                                          
C                                                                       
C        USAGE                                                          
C           CALL CIGMAT(A,LAMBDA,M,MAX,MULT,INT,INTH,H,VECT,NCAL,HL)    
C                                                                       
C        DESCRIPTION OF PARAMETERS                                      
C           A(MAX,MAX)-      COMPLEX INPUT MATRIX                       
C           LAMBDA(MAX)-     COMPLEX EIGENVALUES IN ORDER BY INCREASING 
C                            REAL PART                                  
C           M-               ORDER OF A                                 
C           MAX-             MAXIMUM ORDER OF A FROM CALLING PROGRAM    
C           MULT(MAX)-       TEMPORARY COMPLEX ARRAY                    
C           INT(MAX)-        TEMPORARY INTEGER ARRAY                    
C           INTH(MAX)-       TEMPORARY INTEGER ARRAY                    
C           H(MAX,MAX)-      TEMPORARY COMPLEX MATRIX                   
C           VECT(MAX,MAX)-   COMPLEX EIGENVECTORS IN SAME SEQUENCE AS   
C                            EIGENVALUES                                
C           NCAL-            NUMBER OF EIGENVALUES(AND EIGENVECTORS)    
C                            DESIRED                                    
C           HL(MAX,MAX)-     TEMPORARY COMPLEX MATRIX                   
C                                                                       
C        REMARKS                                                        
C           THE 11 SUBROUTINE ARGUMENTS INCLUBE 5 COMPLEX 2-DIM         
C           ARRAYS, 1 COMPLEX 1-DIM ARRAY, 2 INTEGER 1-DIM              
C           ARRAYS, AND 3 INTEGER SCALARS.  BE CERTAIN THAT ARGUMENT    
C           TYPES IN MAIN PROGRAM ARE MATCHED WITH THESE IN SUBROUTINE. 
C                                                                       
C        METHOD                                                         
C           QR ALGORITHM OBTAINED FROM M. WERBY                         
C                                                                       
C     ..................................................................
C                                                                       
      SUBROUTINE CIGMAT (A,LAMBDA,M,MAX,MULT,INT,INTH,H,VECT,NCAL,HL)   
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16  A(MAX,MAX),LAMBDA(MAX),SHIFT(3),TEMP,TEMP1,TEMP2,SINN,
     1H(MAX,MAX),HL(MAX,MAX),VECT(MAX,MAX),MULT(MAX),COSS               
      LOGICAL TWICE                                                     
      REAL*8 EPS,SUM,ZERO,BIG,RHO,ABIG,ABSSQ,FN,DREAL                   
      INTEGER INT(MAX),INTH(MAX),R,RP1,RP2                              
      ZERO=DBLE(0.0)                                                    
      DO 10 I=1,M                                                       
      DO 10 J=1,M                                                       
10    HL(J,I)=A(J,I)                                                    
C
      NV=NCAL                                                           
      N=M                                                               
      NCAL=N                                                            
      IF (N.NE.1) GO TO 20                                              
      LAMBDA(1)=A(1,1)                                                  
      VECT(1,1)=DCMPLX(1.0,0.0)                                         
      GO TO 640                                                         
20    ICOUNT=0                                                          
      SHIFT(1)=DCMPLX(0.0,0.0)                                          
      IF (N.NE.2) GO TO 50                                              
30    TEMP=(A(1,1)+A(2,2)+CDSQRT((A(1,1)+A(2,2))**2-4.0*(A(2,2)*A(1,1)- 
     1A(2,1)*A(1,2))))/2.0                                              
      IF (DREAL(TEMP).NE.ZERO.OR.DIMAG(TEMP).NE.ZERO) GO TO 40          
      LAMBDA(M)=SHIFT(1)                                                
      LAMBDA(M-1)=A(1,1)+A(2,2)+SHIFT(1)                                
      GO TO 390                                                         
40    LAMBDA(M)=TEMP+SHIFT(1)                                           
      LAMBDA(M-1)=(A(2,2)*A(1,1)-A(2,1)*A(1,2))/(LAMBDA(M)-SHIFT(1))+SHI
     1FT(1)                                                             
      GO TO 390                                                         
C                                                                       
C        REDUCE MATRIX TO HESSENBERG FORM                               
C                                                                       
50    NM2=N-2                                                           
      DO 160 R=1,NM2                                                    
      RP1=R+1                                                           
      RP2=R+2                                                           
      ABIG=ZERO                                                         
      INT(R)=RP1                                                        
      DO 60 I=RP1,N                                                     
      ABSSQ=DREAL(A(I,R))**2+DIMAG(A(I,R))**2                           
      IF (ABSSQ.LE.ABIG) GO TO 60                                       
      INT(R)=I                                                          
      ABIG=ABSSQ                                                        
60    CONTINUE                                                          
      INTER=INT(R)                                                      
      IF (ABIG.EQ.ZERO) GO TO 160                                       
      IF (INTER.EQ.RP1) GO TO 90                                        
      DO 70 I=R,N                                                       
      TEMP=A(RP1,I)                                                     
      A(RP1,I)=A(INTER,I)                                               
70    A(INTER,I)=TEMP                                                   
      DO 80 I=1,N                                                       
      TEMP=A(I,RP1)                                                     
      A(I,RP1)=A(I,INTER)                                               
80    A(I,INTER)=TEMP                                                   
90    DO 100 I=RP2,N                                                    
      MULT(I)=A(I,R)/A(RP1,R)                                           
100   A(I,R)=MULT(I)                                                    
      DO 120 I=1,RP1                                                    
      TEMP=DCMPLX(0.0,0.0)                                              
      DO 110 J=RP2,N                                                    
110   TEMP=TEMP+A(I,J)*MULT(J)                                          
120   A(I,RP1)=A(I,RP1)+TEMP                                            
      DO 140 I=RP2,N                                                    
      TEMP=DCMPLX(0.0,0.0)                                              
      DO 130 J=RP2,N                                                    
130   TEMP=TEMP+A(I,J)*MULT(J)                                          
140   A(I,RP1)=A(I,RP1)+TEMP-MULT(I)*A(RP1,RP1)                         
      DO 150 I=RP2,N                                                    
      DO 150 J=RP2,N                                                    
150   A(I,J)=A(I,J)-MULT(I)*A(RP1,J)                                    
160   CONTINUE                                                          
C                                                                       
C        CALCULATE EPSILON                                              
C                                                                       
      EPS=ZERO                                                          
      DO 170 I=1,N                                                      
170   EPS=EPS+CDABS(A(1,I))                                             
      DO 190 I=2,N                                                      
      SUM=ZERO                                                          
      IM1=I-1                                                           
      DO 180 J=IM1,N                                                    
180   SUM=SUM+CDABS(A(I,J))                                             
      IF (SUM.GT.EPS) EPS=SUM                                           
190   CONTINUE                                                          
CC      FN=DBLE(FLOAT(N))                                               
      FN=DBLE(FLOAT(N))                                                 
      EPS=DSQRT(FN)*EPS*1.D-12                                          
      IF (EPS.EQ.ZERO)EPS=DBLE(1.0E-12)                                 
      DO 200 I=1,N                                                      
      DO 200 J=1,N                                                      
200   H(I,J)=A(I,J)                                                     
210   IF (N.NE.1) GO TO 220                                             
      LAMBDA(M)=A(1,1)+SHIFT(1)                                         
      GO TO 390                                                         
220   IF (N.EQ.2) GO TO 30                                              
230   MN1=M-N+1                                                         
      IF (DREAL(A(N,N)).NE.ZERO.OR.DIMAG(A(N,N)).NE.ZERO) IF(DABS(DREAL 
     1(A(N,N-1)/A(N,N)))+DABS(DIMAG(A(N,N-1)/A(N,N)))-1.D-9)            
     2 250,250,240                                                      
240   IF (DABS(DREAL(A(N,N-1)))+DABS(DIMAG(A(N,N-1))).GE.EPS) GO TO 260 
250   LAMBDA(MN1)=A(N,N)+SHIFT(1)                                       
      ICOUNT=0                                                          
      N=N-1                                                             
      GO TO 220                                                         
C                                                                       
C        DETERMINE SHIFT                                                
C                                                                       
260   SHIFT(2)=(A(N-1,N-1)+A(N,N)+CDSQRT((A(N-1,N-1)+A(N,N))**2-4.0*(A(N
     1,N)*A(N-1,N-1)-A(N,N-1)*A(N-1,N))))/2.0                           
      IF (DREAL(SHIFT(2)).NE.ZERO.OR.DIMAG(SHIFT(2)).NE.ZERO) GO TO 270 
      SHIFT(3)=A(N-1,N-1)+A(N,N)                                        
      GO TO 280                                                         
270   SHIFT(3)=(A(N,N)*A(N-1,N-1)-A(N,N-1)*A(N-1,N))/SHIFT(2)           
280   IF (CDABS(SHIFT(2)-A(N,N)).LT.CDABS(SHIFT(3)-A(N,N))) GO TO 290   
      INDEX=3                                                           
      GO TO 300                                                         
290   INDEX=2                                                           
300   IF (CDABS(A(N-1,N-2)).GE.EPS) GO TO 310                           
      LAMBDA(MN1)=SHIFT(2)+SHIFT(1)                                     
      LAMBDA(MN1+1)=SHIFT(3)+SHIFT(1)                                   
      ICOUNT=0                                                          
      N=N-2                                                             
      GO TO 210                                                         
310   SHIFT(1)=SHIFT(1)+SHIFT(INDEX)                                    
      DO 320 I=1,N                                                      
320   A(I,I)=A(I,I)-SHIFT(INDEX)                                        
C                                                                       
C      PERFORM GIVENS ROTATIONS, QR ITERATES. INCREASED NUMBER
C      OF INTERATIONS TO 13 ON 6/29/94 (R.B. EVANS, SAIC, NEW
C      LONDON, CT) 
C
      IF (ICOUNT.LE.13) GO TO 330                                       
      NCAL=M-N                                                          
      GO TO 390                                                         
330   NM1=N-1                                                           
      TEMP1=A(1,1)                                                      
      TEMP2=A(2,1)                                                      
      DO 380 R=1,NM1                                                    
      RP1=R+1                                                           
      RHO=DSQRT(DREAL(TEMP1)**2+DIMAG(TEMP1)**2+DREAL(TEMP2)**2+        
     1DIMAG(TEMP2)**2)                                                  
      IF (RHO.NE.ZERO) GO TO 340                                        
      TEMP1=A(RP1,RP1)                                                  
      IF (MAX-R.GE.2) TEMP2=A(R+2,R+1)                                  
      GO TO 380                                                         
340   COSS=TEMP1/RHO                                                    
      SINN=TEMP2/RHO                                                    
      INDEX=MAX0(R-1,1)                                                 
      DO 350 I=INDEX,N                                                  
      TEMP=DCONJG(COSS)*A(R,I)+DCONJG(SINN)*A(RP1,I)                    
      A(RP1,I)=-SINN*A(R,I)+COSS*A(RP1,I)                               
350   A(R,I)=TEMP                                                       
      TEMP1=A(RP1,RP1)                                                  
      IF (MAX-R.GE.2) TEMP2=A(R+2,R+1)                                  
      DO 360 I=1,R                                                      
      TEMP=COSS*A(I,R)+SINN*A(I,RP1)                                    
      A(I,RP1)=-DCONJG(SINN)*A(I,R)+DCONJG(COSS)*A(I,RP1)               
360   A(I,R)=TEMP                                                       
      INDEX=MIN0(R+2,N)                                                 
      DO 370 I=RP1,INDEX                                                
      A(I,R)=SINN*A(I,RP1)                                              
370   A(I,RP1)=DCONJG(COSS)*A(I,RP1)                                    
380   CONTINUE                                                          
      ICOUNT=ICOUNT+1                                                   
      GO TO 230                                                         
C                                                                       
C        VALUES IN INCREASING ORDER OF REAL PARTS                       
C
390   CONTINUE                                                          
C
      DO 400 I=1,NCAL                                                   
      K=NCAL+1-I                                                        
      VECT(I,1)=LAMBDA(K)
400   CONTINUE                                                          
      L=NCAL-1                                                          
      DO 420 I=1,L                                                      
      K=I+1                                                             
      DO 410 J=K,NCAL                                                   
      IF (DREAL(VECT(J,1)).GE.DREAL(VECT(I,1))) GO TO 410               
      TEMP=VECT(J,1)                                                    
      VECT(J,1)=VECT(I,1)                                               
      VECT(I,1)=TEMP                                                    
410   CONTINUE                                                          
420   LAMBDA(I)=VECT(I,1)                                               
      LAMBDA(NCAL)=VECT(NCAL,1)                                         
      N=M                                                               
      NM1=N-1                                                           
      IF (N.NE.2) GO TO 430                                             
      EPS=DMAX1(CDABS(LAMBDA(1)),CDABS(LAMBDA(2)))*1.D-8                
      IF (EPS.EQ.ZERO) EPS=DBLE(1.E-12)                                 
      H(1,1)=A(1,1)                                                     
      H(1,2)=A(1,2)                                                     
      H(2,1)=A(2,1)                                                     
      H(2,2)=A(2,2)                                                     
430   DO 440 I=1,M                                                      
      DO 440 J=1,M                                                      
440   A(J,I)=HL(J,I)                                                    
C                                                                       
C        CALCULATE VECTORS                                              
C                                                                       
      NC=MIN0(NCAL,NV)                                                  
      IF (NC.EQ.0) GO TO 640                                            
      DO 630 L=1,NC                                                     
      DO 460 I=1,N                                                      
      DO 450 J=1,N                                                      
450   HL(I,J)=H(I,J)                                                    
460   HL(I,I)=HL(I,I)-LAMBDA(L)                                         
      DO 500 I=1,NM1                                                    
      MULT(I)=DCMPLX(0.0,0.0)                                           
      INTH(I)=0                                                         
      IP1=I+1                                                           
      IF (CDABS(HL(I+1,I)).LE.CDABS(HL(I,I))) GO TO 480                 
      INTH(I)=1                                                         
      DO 470 J=I,N                                                      
      TEMP=HL(I+1,J)                                                    
      HL(I+1,J)=HL(I,J)                                                 
470   HL(I,J)=TEMP                                                      
480   IF (DREAL(HL(I,I)).EQ.ZERO.AND.DIMAG(HL(I,I)).EQ.ZERO) GO TO 500  
      MULT(I)=-HL(I+1,I)/HL(I,I)                                        
      DO 490 J=IP1,N                                                    
490   HL(I+1,J)=HL(I+1,J)+MULT(I)*HL(I,J)                               
500   CONTINUE                                                          
      DO 510 I=1,N                                                      
510   VECT(I,L)=DCMPLX(1.0,0.0)                                         
      TWICE=.FALSE.                                                     
520   IF (DREAL(HL(N,N)).EQ.ZERO.AND.DIMAG(HL(N,N)).EQ.ZERO)            
     1  HL(N,N)=DCMPLX(EPS,ZERO)                                        
      VECT(N,L)=VECT(N,L)/HL(N,N)                                       
      DO 540 I=1,NM1                                                    
      K=N-I                                                             
      DO 530 J=K,NM1                                                    
530   VECT(K,L)=VECT(K,L)-HL(K,J+1)*VECT(J+1,L)                         
      IF (DREAL(HL(K,K)).EQ.ZERO.AND.DIMAG(HL(K,K)).EQ.ZERO) HL(K,K)=   
     1  DCMPLX(EPS,ZERO)                                                
540   VECT(K,L)=VECT(K,L)/HL(K,K)                                       
      BIG=ZERO                                                          
      DO 550 I=1,N                                                      
      SUM=DABS(DREAL(VECT(I,L)))+DABS(DIMAG(VECT(I,L)))                 
      IF (SUM.GT.BIG) BIG=SUM                                           
550   CONTINUE                                                          
      DO 560 I=1,N                                                      
560   VECT(I,L)=VECT(I,L)/BIG                                           
      IF (TWICE) GO TO 580                                              
      DO 570 I=1,NM1                                                    
      IF (INTH(I).EQ.0) GO TO 570                                       
      TEMP=VECT(I,L)                                                    
      VECT(I,L)=VECT(I+1,L)                                             
      VECT(I+1,L)=TEMP                                                  
570   VECT(I+1,L)=VECT(I+1,L)+MULT(I)*VECT(I,L)                         
      TWICE=.TRUE.                                                      
      GO TO 520                                                         
580   IF (N.EQ.2) GO TO 610                                             
      NM2=N-2                                                           
      DO 600 I=1,NM2                                                    
      N1I=N-1-I                                                         
      NI1=N-I+1                                                         
      DO 590 J=NI1,N                                                    
590   VECT(J,L)=H(J,N1I)*VECT(N1I+1,L)+VECT(J,L)                        
      INDEX=INT(N1I)                                                    
      TEMP=VECT(N1I+1,L)                                                
      VECT(N1I+1,L)=VECT(INDEX,L)                                       
600   VECT(INDEX,L)=TEMP                                                
C                                                                       
C        NORMALIZE VECTORS TO UNIT LENGTH                               
C                                                                       
610   CONTINUE                                                          
      TEMP=DCMPLX(0.0,0.0)                                              
      DO 620 I=1,N                                                      
620   TEMP=VECT(I,L)*VECT(I,L)+TEMP                                     
      TEMP=CDSQRT(TEMP)                                                 
      DO 630 I=1,N                                                      
630   VECT(I,L)=VECT(I,L)/TEMP                                          
640   RETURN                                                            
      END                                                               

      SUBROUTINE CPTBH(M,H1,H2,EGVL,FNORM,EGVR,MX)
C
C     THIS SUBROUTINE COMPUTES AN ESTIMATE OF THE EIGEN VALUES EGVR IN
C     REGION J+1 (DEPTH=H2) BASED ON THE EIGEN VALUES IN REGION J
C     (DEPTH=H1).
C     IT USES THE PERTURBATION METHOD ON PG. 228 IN PRINC. AND TECH.
C     OF APPLIED MATH BY B. FRIEDMAN
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 EGVL(MX),FNORM(MX),EGVR(MX)
      COMPLEX*16 ALPHA,BETA,CCDS,CSDS,CISP
      COMPLEX*16 CDSRT,ONE,CI,U,V,W,B,Z
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      ONE=DCMPLX(1.0D0,0.0D0)
      CI=DCMPLX(0.0D0,1.0D0)
C
      IF(H1 .EQ. H2) GO TO 600
C
      DO 500 I=1,M
C
      ALPHA=CDSRT(FKW**2+FKB**2*(EGVL(I)-ONE))
      BETA=CDSRT(FKB**2*(EGVL(I)+CI*ATEN))
C
      IF(H1 .GT. H2) GO TO 200
C
C     THIS IS THE DOWN SLOPE CASE
C
      V=DCMPLX(1.-(FKW/FKB)**2,ATEN)/(FNORM(I)*ROHB)
      W=FKB**4*CDSIN(ALPHA*H1)**2/ALPHA**2
      U=CCDS(H1,H1,BETA)-CCDS(H2,H1,BETA)*CSDS(H2,H1,BETA)
      U=U/(2.*BETA)
      B=BETA*(HB-H1)
      IF(DIMAG(B) .GT. 44.0D0) GO TO 100
      Z=.5*(H2-H1)/CDSIN(BETA*(H1-HB))**2
      GO TO 150
C 
  100 CONTINUE
      Z=DCMPLX(0.0D0,0.0D0)
C
  150 CONTINUE
      EGVR(I)=EGVL(I)+V*W*(U+Z)
C
      GO TO 500
C
  200 CONTINUE
C
C     THIS IS THE UPSLOPE CASE
C
      U=CISP(ALPHA,H2,ALPHA,H2)-CISP(ALPHA,H1,ALPHA,H1)
      V=DCMPLX(1.-(FKW/FKB)**2,ATEN)/(FNORM(I)*ROHW)
      W=FKB**4/(ALPHA**2)
C
      EGVR(I)=EGVL(I)+U*V*W
C
  500 CONTINUE
      GO TO 800
C
  600 CONTINUE
      DO 700 I=1,M
      EGVR(I)=EGVL(I)
  700 CONTINUE
C
  800 CONTINUE     
C
      RETURN
      END

      COMPLEX*16 FUNCTION BDF(Z,H,ALPHA,BETA,FNORM)
C
C     THIS FUNCTION COMPUTES THE VALUE OF THE BASIC DEPTH FUNCTION
C     AT DEPTH Z.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 ALPHA,BETA,FNORM,FAC,RAT
      COMPLEX*16 CSDS,CDSRT
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
C
      FAC=FKB**2/(ALPHA*CDSRT(FNORM))
      RAT=CDSIN(ALPHA*H)
C
C
      IF(Z .LE. H)   THEN
      BDF=FAC*CDSIN(ALPHA*Z)
      ELSE
      BDF=FAC*RAT*CSDS(Z,H,BETA)
      END IF
C
      RETURN
      END

      SUBROUTINE BACKSUB(B,Y,P,M,MX)
C
C     THIS SUBROUTINE SOLVES THE MATRIX EQUATION B*Y=P BY 
C     BACKSUBSTITUTION WHERE B IS UPPER TRIANGULAR
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 B(MX,MX),Y(MX,MX),P(MX,MX),SUM
C

      MM1=M-1
      DO 1000 J=1,M
       Y(M,J)=P(M,J)/B(M,M)
       DO 800 I=MM1,1,-1
        IP1=I+1
        SUM=DCMPLX(0.0,0.0)
        DO 600 II=IP1,M
         SUM=SUM+B(I,II)*Y(II,J)
 600   CONTINUE
        Y(I,J)=(P(I,J)-SUM)/B(I,I)
 800   CONTINUE
 1000 CONTINUE
C
      RETURN
      END

      SUBROUTINE CVMULT(M,S3,B,MX,W)
C
C     THIS SUBROUTINE DOES COMPLEX MATRIX TIMES VECTOR (S3*B)
C     MULTIPLICATION. THE RESULT IS STORED IN B.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 S3(MX,MX),B(MX)
      COMPLEX*16 W(MX)
      COMPLEX*16 SUM
C
      DO 200 II=1,M
C
      SUM=DCMPLX(0.0,0.0)
      DO 100 I=1,M
      SUM=SUM+S3(II,I)*B(I)
  100 CONTINUE
C
      W(II)=SUM
C
  200 CONTINUE
C
      DO 300 II=1,M
      B(II)=W(II)
  300 CONTINUE
C
      RETURN
      END

      SUBROUTINE FORESUB(B,Y,P,M,MX)
C
C     THIS SUBROUTINE SOLVES THE MATRIX EQUATION B*Y=P BY 
C     FORWARD SUBSTITUTION WHERE B IS A REAL LOWER TRIANGULAR
C     MATRIX AND P IS COMPLEX
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 B(MX,MX)
      COMPLEX*16 Y(MX,MX),P(MX,MX),SUM
C
      DO 1000 J=1,M
C
C     SOLVE FOR THE JTH COLUMN IN Y USING THE JTH COLUMN IN P
C
       Y(1,J)=P(1,J)/DCMPLX(B(1,1),0.0D0)
       DO 800 I=2,M
        IM1=I-1
        SUM=DCMPLX(0.0,0.0)
        DO 600 II=1,IM1
         SUM=SUM+DCMPLX(B(I,II),0.0D0)*Y(II,J)
 600   CONTINUE
        Y(I,J)=(P(I,J)-SUM)/DCMPLX(B(I,I),0.0D0)
 800   CONTINUE
C
 1000 CONTINUE
C
      RETURN
      END

      SUBROUTINE FILE(MAMP,IOUT,MX,MXT2)
C
C     THIS SUBROUTINE OPENS THE SCRATCH AND OUTPUT FILES GENERATED BY 
C     COUPLE 
C 
C     RECL=16*MX*MX IS NEEDED TO WRITE A MX*MX COMPLEX MATRIX 
C     (2*MX*MX 8 BYTE (64 BIT) WORDS) ON UNIT 1,2,3 AND 8
C
C     ELIMINATED STATUS='SCRATCH' FOR LF90 ON 8/20/96
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
CCC      NRECL=16*MX*MX
CCC      OPEN(1,STATUS='SCRATCH',RECL=NRECL,FORM='UNFORMATTED')
CCC      OPEN(2,STATUS='SCRATCH',RECL=NRECL,FORM='UNFORMATTED')
CCC      OPEN(3,STATUS='SCRATCH',RECL=NRECL,FORM='UNFORMATTED')
CCC      OPEN(8,STATUS='SCRATCH',RECL=NRECL,FORM='UNFORMATTED')
C
C      OPEN(21,STATUS='SCRATCH',FORM='UNFORMATTED',IOSTAT=I21)
C      OPEN(2, STATUS='SCRATCH',FORM='UNFORMATTED',IOSTAT=I2)
C      OPEN(3, STATUS='SCRATCH',FORM='UNFORMATTED',IOSTAT=I3)
C      OPEN(8, STATUS='SCRATCH',FORM='UNFORMATTED',IOSTAT=I8)
C      
C
      OPEN(21,FILE='SCRACH21.DAT',STATUS='UNKNOWN',FORM='UNFORMATTED'
     1       ,IOSTAT=I21)
      OPEN(2, FILE='SCRACH2.DAT', STATUS='UNKNOWN',FORM='UNFORMATTED'
     1       ,IOSTAT=I2)
      OPEN(3, FILE='SCRACH3.DAT', STATUS='UNKNOWN',FORM='UNFORMATTED'
     1       ,IOSTAT=I3)
      OPEN(8, FILE='SCRACH8.DAT', STATUS='UNKNOWN',FORM='UNFORMATTED'
     1       ,IOSTAT=I8)
C
C     OPEN DIRECT ACCESS FILE FOR STORAGE OR RETRIEVAL OF
C     EIGENVALUES WITH IREIG .NE. 0
C
      IRECL=16*MX
C      OPEN(18,STATUS='SCRATCH',FORM='UNFORMATTED',ACCESS='DIRECT',
C     1        RECL=IRECL,IOSTAT=I18)
C      
      OPEN(18,FILE='SCRACH18.DAT',STATUS='UNKNOWN',FORM='UNFORMATTED'
     1       ,ACCESS='DIRECT',RECL=IRECL,IOSTAT=I18)
C
CCC      NRECL=16*MXT2*MXT2
CCC      OPEN(4,STATUS='SCRATCH',RECL=NRECL,FORM='UNFORMATTED')
C      OPEN(4,STATUS='SCRATCH',FORM='UNFORMATTED',IOSTAT=I4)
C
      OPEN(4,FILE='SCRACH4.DAT',STATUS='UNKNOWN',FORM='UNFORMATTED'
     1      ,IOSTAT=I4)
C
      OPEN(10,FILE='COUPLE.TL',FORM='FORMATTED',IOSTAT=I10)
      IF(MAMP .GT. 0) OPEN(11,FILE='COUPLE.AMP',FORM='FORMATTED')
      OPEN(7 ,FILE='COUPLE.CPR',FORM='UNFORMATTED',IOSTAT=I7)
C
      IF(IOUT .NE. 1) THEN 
      OPEN(12,FILE='COUPLEO.TL',FORM='FORMATTED',IOSTAT=I12)
      OPEN(13,FILE='COUPLEI.TL',FORM='FORMATTED',IOSTAT=I13)
      OPEN(17,FILE='COUPLES.TL',FORM='FORMATTED',IOSTAT=I17)
C
      OPEN(14,FILE='COUPLEO.CPR',FORM='UNFORMATTED',IOSTAT=I14)
      OPEN(15,FILE='COUPLEI.CPR',FORM='UNFORMATTED',IOSTAT=I15)
      OPEN(16,FILE='COUPLES.CPR',FORM='UNFORMATTED',IOSTAT=I16)
      END IF
C
      RETURN
      END

      REAL*8 FUNCTION RCF(H,X)
C
C     THIS FUNCTION EVALUATES THE CHARACTERISTIC FUNCTION FOR THE
C     PROBLEM WITH ATEN=0.0 USING DOUBLE PRECISION.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 ALPHA,BETA,X,ZERO,SDALP,CALP
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
C     IT IS ASSUMED THAT X IS LARGE ENOUGH TO MAKE ALPHA REAL. BETA IS
C     DEFINED SO AS TO ELIMINATE THE NEED FOR COMPLEX TRIG. FUNCTIONS.
C
      ZERO=0.0D0
      ALPHA=DSQRT(DABS(FKW**2+FKB**2*(X-1)))
      BETA=DSQRT(DABS(FKB**2*X))
C
C     THE FOLLOWING LOGIC ACCOMODATES SMALL VALUES OF ALPHA
C
      IF(ALPHA .LT. .1D-28) THEN
      SDALP=H
      ELSE
      SDALP=DSIN(ALPHA*H)/ALPHA
      END IF
      CALP=DCOS(ALPHA*H)
C
C     THE VALUE OF THE CHARACTERISTIC FUNCTION WHEN X=ZERO IS STORED 
C     IN RCF
C
      RCF=ROHW*SDALP-ROHB*CALP*(H-HB)
C
C     WHEN X IS .LT. ZERO THE VALUE OF THE CHARACTERISTIC FUNCTION IS
C     DIVIDED BY COSH(BETA*(H-HB) FOR NUMERICAL PURPOSES. THE ZEROES
C     OF THE RESULTING FUNCTION ARE STILL THE SAME.
C
      IF(X .LT. ZERO)
     1 RCF=ROHW*SDALP
     2    -ROHB*CALP*DTANH(BETA*(H-HB))/BETA
C
C
      IF(X .GT. ZERO)
     1 RCF=ROHW*SDALP*DCOS(BETA*(H-HB))
     2    -ROHB*CALP*DSIN(BETA*(H-HB))/BETA
C
      RETURN
      END

      SUBROUTINE AMAT(HW,M,EGVL,FNORM,A,MX,
     1                DEPW,CGRADW,CINTW,RHOW,GRHOW,NPW,AVGW,LHW,
     2                DEPB,CGRADB,CINTB,RHOB,GRHOB,NPB,AVGB,LHB)
C
C     THE FOLLOWING SUBROUTINE COMPUTES THE COMPLEX SYMETRIC MATRIX
C     A NEEDED BY GALRKN. THIS MATRIX IS USED TO FORM PART OF THE
C     GENERALIZED MATRIX EIGENVALUE PROBLEM THAT IS SOLVED TO FIND
C     THE EIGENVALUES AND EIGENFUNCTIONS IN TERMS OF THE BASIC 
C     EIGENVALUES AND EIGENFUNCTIONS. THIS VERSION USES THE BASIC
C     EIGENVLAUES, ON THE DIAGONAL, IN THE FORMATION OF A.
C
      IMPLICIT REAL*8 (A-H,O-Z)
C
      DIMENSION DEPW(MX),RHOW(MX),GRHOW(MX)
      DIMENSION DEPB(MX),RHOB(MX),GRHOB(MX)
      COMPLEX*16 CGRADW(MX),CINTW(MX)
      COMPLEX*16 CGRADB(MX),CINTB(MX)
      COMPLEX*16 EGVL(MX),FNORM(MX)
      COMPLEX*16 ONE
      COMPLEX*16 CDSRT,CEXIBD,CEXIB,ZCEXIB
      COMPLEX*16 CEXIWD,CEXIW,ZCEXIW
      COMPLEX*16 EGV1,EGV2,ALPHA1,ALPHA2,BETA1,BETA2
      COMPLEX*16 A(MX,MX),U
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      ONE=DCMPLX(1.0,0.0)
      ZERO=0.0D0
      LHWM1=LHW-1
      LHBM1=LHB-1
C
C     STORE THE INTEGRALS IN THE WATER AND SEDIMENT IN THE MATRIX A
C
      DO 700 I=1,M
C
      EGV1=EGVL(I)
      ALPHA1=CDSRT(FKW**2+FKB**2*(EGV1-ONE))
      BETA1=CDSRT(FKB**2*EGV1)
C
      DO 500 II=I,M
C
      EGV2=EGVL(II)
      ALPHA2=CDSRT(FKW**2+FKB**2*(EGV2-ONE))
      BETA2=CDSRT(FKB**2*EGV2)
C
      U=CDSRT(FNORM(I))*CDSRT(FNORM(II))
C
C     INITIALIZE WITH ZERO
C
      A(II,I)=DCMPLX(0.0D0,0.0D0)
C
C     SUM OVER LAYERS IN THE WATER SOUND SPEED-DENSITY PROFILE
C
      IF(LHW .EQ. 1) GO TO 200
      DO 150 L=1,LHWM1
      Z1=DEPW(L)
      Z2=DEPW(L+1)
      A(II,I)=A(II,I)+CEXIWD(Z1,Z2,DEPW(L),RHOW(L),GRHOW(L),
     1                            ALPHA1,ALPHA2)
     2               -CEXIWD(Z1,Z2,ZERO,ROHW,ZERO,
     3                            ALPHA1,ALPHA2)
      A(II,I)=A(II,I)+(AVGW-CINTW(L))*CEXIW(Z1,Z2,DEPW(L),RHOW(L),
     1                   GRHOW(L),ALPHA1,ALPHA2)
     2               -CGRADW(L)*ZCEXIW(Z1,Z2,DEPW(L),RHOW(L),
     3                   GRHOW(L),ALPHA1,ALPHA2)
  150 CONTINUE
  200 CONTINUE
C
      Z1=DEPW(LHW)
      Z2=HW
      A(II,I)=A(II,I)+CEXIWD(Z1,Z2,DEPW(LHW),RHOW(LHW),
     1                            GRHOW(LHW),ALPHA1,ALPHA2)
     2               -CEXIWD(Z1,Z2,ZERO,ROHW,ZERO,
     3                            ALPHA1,ALPHA2)
      A(II,I)=A(II,I)+(AVGW-CINTW(LHW))*CEXIW(Z1,Z2,DEPW(LHW),
     1                   RHOW(LHW),GRHOW(LHW),ALPHA1,ALPHA2)
     2               -CGRADW(LHW)*ZCEXIW(Z1,Z2,DEPW(LHW),
     3                   RHOW(LHW),GRHOW(LHW),ALPHA1,ALPHA2)
C
C     SUM OVER LAYERS IN BOTTOM SOUND SPEED - DENSITY PROFILE
C
      IF(LHB .EQ. 1) GO TO 300
      DO 250 L=1,LHBM1
      Z1=DEPB(L)
      Z2=DEPB(L+1)
      A(II,I)=A(II,I)+CEXIBD(HW,Z1,Z2,DEPB(L),RHOB(L),GRHOB(L),
     1                            ALPHA1,ALPHA2,BETA1,BETA2)
     2               -CEXIBD(HW,Z1,Z2,HW,ROHB,ZERO,
     3                            ALPHA1,ALPHA2,BETA1,BETA2)
      A(II,I)=A(II,I)+(AVGB-CINTB(L))*CEXIB(HW,HW,Z1,Z2,DEPB(L),
     1                  RHOB(L),GRHOB(L),ALPHA1,ALPHA2,BETA1,BETA2)
     2               -CGRADB(L)*ZCEXIB(HW,Z1,Z2,DEPB(L),
     3                  RHOB(L),GRHOB(L),ALPHA1,ALPHA2,BETA1,BETA2)
  250 CONTINUE
  300 CONTINUE
C
      Z1=DEPB(LHB)
      Z2=HB      
      A(II,I)=A(II,I)+CEXIBD(HW,Z1,Z2,DEPB(LHB),RHOB(LHB),GRHOB(LHB),
     1                            ALPHA1,ALPHA2,BETA1,BETA2)
     2               -CEXIBD(HW,Z1,Z2,HW,ROHB,ZERO,
     3                            ALPHA1,ALPHA2,BETA1,BETA2)
      A(II,I)=A(II,I)+(AVGB-CINTB(LHB))*CEXIB(HW,HW,Z1,Z2,DEPB(LHB),
     1                 RHOB(LHB),GRHOB(LHB),ALPHA1,ALPHA2,BETA1,BETA2)
     2               -CGRADB(LHB)*ZCEXIB(HW,Z1,Z2,DEPB(LHB),
     3                 RHOB(LHB),GRHOB(LHB),ALPHA1,ALPHA2,BETA1,BETA2)
C
C     APPLY NORMALIZATION FACTORS OF BASIC DEPTH FUNCTIONS
C
      A(II,I)=A(II,I)/U
C
C
      IF(II .EQ. I) THEN
C
C     ADD THE BASIC EIGENVALUES TO THE DIAGONAL OF A
C
      A(II,II)=A(II,II)+EGV2
C
      ELSE
C
C     DEFINE THE REST OF A BY SYMMETRY
C
      IF(II .NE. I) A(I,II)=A(II,I)
C
      END IF
C
C
  500 CONTINUE
  700 CONTINUE
C
      RETURN
      END

      SUBROUTINE ESPI(DBPWL,FREQ,CB,FKB,ATEN)
C
C     THIS SUBROUTINE USES NEWTON'S METHOD TO CONVERT DB PER WAVE 
C     LENGTH (DBPWL) TO AN IMAGINARY PART OF THE SQUARE OF THE INDEX
C     OF REFRACTION. THE ATTENUATION ONLY EFFECT THE IMAGINARY PART
C     OF THE SQUARE OF THE INDEX OF REFRACTION, WHICH IS USEFUL IN
C     THE PERTURBATION-CONTINUATION PROCEDURE USE IN SUBROUTINE 
C     SEARCH TO FIND THE EIGENVALUES. THE RESULT (ESP) IS RETURNED
C     IN ATEN. THIS IS USED ONLY IN THE SEARCH METHOD. 
C
C     IN CONTRAST, THE GALERKIN METHOD USES THE ATENUATION PROFILE 
C     IN SUBROUTINE CFACIN TO DEFINE A COMPLEX WAVE NUMBER THAT IS
C     THEN SQUARED AND DIVIDED BY THE REAL REFERENCE WAVE NUMBER 
C     SQUARED SO THAT THE ATTENUATION EFFECTS BOTH THE REAL AND
C     IMAGINARY PART OF THE COMPLEX INDEX OF REFRACTION  SQUARED.
C
C     GENERATE CONSTANTS
C
      IMPLICIT REAL*8 (A-H,O-Z)
      PI=2.*ACOS(0.0)
      E=EXP(1.0)
      FAC=20.*DLOG10(E)      
C
C     FIND WAVE LENGTH
C
      WL=CB/FREQ
      DBPM=DBPWL/WL
      FK=DBPM/FAC
C
C     THE FOLLOWING IS A GOOD APPROXIMATE FOR ATEN WITH 
C     REASONABLE ATTENUATIONS. IT ALSO MAKES THE SEARCH METHOD  
C     AGREE APPROXIMATELY WITH THE GALERKIN METHOD IN REGARDS 
C     TO THE TREATMENT OF ATTENUATION.
C
      ESP=2.*FK/FKB
      I=0
C
C     START THE ITERATIONS OF NEWTON'S METHOD
C
  100 CONTINUE
C
      IF(I .GT. 20) GO TO 500
      I=I+1
      X=(1.0+ESP**2)**.25
      Y=SIN(ATAN(ESP)/2.)
      Z=COS(ATAN(ESP)/2.)
      W=X**3
C
      F=FKB*X*Y-FK
      FP=FKB*(ESP*Y+Z)/W           
      ESP=ESP-F/FP
C
      GO TO 100
C
  500 CONTINUE
      ATEN=ESP
C
      RETURN
      END

      SUBROUTINE BOTDEPS(HW,DEPB,CGRADB,CINTB,NPB,AVGB,LHB,MX)
C
C     THIS SUBROUTINE REDEFINES THE DEPTHS AND INTERCEPTS OF
C     THE INDEX OF REFRACTION SQUARED IN THE BOTTOM. THE DEPTHS
C     MOVE UP AND DOWN AS THE WATER DEPTH HW CHANGES WHILE THE 
C     INTERCEPTS MOVE WITH THEM. THE SUBROUTINE THE FINDS THE 
C     INDEX LHB OF THE LAYER IN THE NEW DEPTH PRROFILE THAT 
C     CONTAINS HB. THE SQUARED INDEX OF REFRACTION CAN BE 
C     INTERPOLATED OR EXTRAPOLATED TO HB BASED ON LHB.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 CGRADB(MX),CINTB(MX) 
      DIMENSION DEPB(MX)
C
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
C     SET AVERAGE INDEX OF REFRACTION SQUARED IN THE BOTTOM
C     TO ONE
C
      AVGB=1.0D0
C
C     DEPB(1) IS ASSUMED TO BE THE WATER DEPTH BEFORE THE DEPTH
C     CHANGES TO HW. MOVE THE DEPTHS AND INTERCEPTS.
C
      DELH=HW-DEPB(1)
      DO 50 I=1,NPB
      DEPB(I)=DEPB(I)+DELH
      CINTB(I)=CINTB(I)-CGRADB(I)*DCMPLX(DELH,0.0D0)
   50 CONTINUE
C
      IF(HB .LE. DEPB(1)) THEN
      WRITE(6,*) 'NO BOTTOM PROFILE WATER DEPTH= ',HW
      WRITE(6,*) 'AND BOTTOM DEPTH= ',HB
      WRITE(6,*) '*** MAKE HB BIGGER ***'
      WRITE(9,*) 'NO BOTTOM PROFILE WATER DEPTH= ',HW
      WRITE(9,*) 'AND BOTTOM DEPTH= ',HB
      WRITE(9,*) '*** MAKE HB BIGGER ***'
      STOP 'MAKE HB BIGGER'
      END IF 
C
      LHB=0
      NPBM1=NPB-1
      DO 100 I=1,NPBM1
      IF(DEPB(I+1) .GE. HB) GO TO 200
  100 CONTINUE
C
C     HB IS .GT. DEPB(NP)
C
      LHB=NPB
      GO TO 250
C
  200 CONTINUE
      LHB=I
  250 CONTINUE
C
      RETURN
      END

      INTEGER FUNCTION INDEP(H,DEP,NP,MX)
C
C     FIND THE INDEX SUCH THAT H IS BETWEEN DEP(INDEX)
C     AND DEPWL(INDEX+1)
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION DEP(MX)
C
      INDEP=0
      NPM1=NP-1
      DO 70 L=1,NPM1
      IF(DEP(L+1) .GE. H) GO TO 90
   70 CONTINUE
C     
C     H IS .GT. DEP(NP)
C
      INDEP=NP
      GO TO 100
C
   90 CONTINUE
      INDEP=L
  100 CONTINUE
C
      RETURN
      END

      COMPLEX*16 FUNCTION CIB0(H1,H2,ALPHA1,ALPHA2,BETA1,BETA2)
C
C     THIS FUNCTION EVALUATES THE PART OF THE CROSS COUPLING INTEGRAL
C     IN THE SEDIMENT. DIVISION BY ROHB NOT DONE IN THIS VESION.
C
      IMPLICIT REAL*8 (A-H,O-Z)
      COMPLEX*16 ALPHA1,ALPHA2,BETA1,BETA2,U,V,W,Z,B
      COMPLEX*16 CCDS,CSDS
      COMMON /BLKEVN/ HB,CW,CB,FKW,FKB,ROHW,ROHB,ATEN
C
      HMAX=DMAX1(H1,H2)
      U=FKB**4*CDSIN(ALPHA1*H1)*CDSIN(ALPHA2*H2)
      IF(CDABS(BETA1-BETA2) .LT. .5D-13) GO TO 100
      V=(BETA1**2-BETA2**2)*ALPHA1*ALPHA2
      W=BETA1*CCDS(HMAX,H1,BETA1)*CSDS(HMAX,H2,BETA2)
     1  -BETA2*CSDS(HMAX,H1,BETA1)*CCDS(HMAX,H2,BETA2)
      GO TO 500
C
  100 CONTINUE
      V=2.*BETA1*ALPHA1*ALPHA2
      B=BETA1*(2.*HB-H1-H2)
      IF(DIMAG(B) .GT. 88.0D0) GO TO 200
      Z=CDSIN(BETA1*(H1-HB))*CDSIN(BETA1*(H2-HB)) 
      W=CCDS(HMAX,H1,BETA1)*CSDS(HMAX,H2,BETA1)-BETA1*(HMAX-HB)/Z
      GO TO 500
C
  200 CONTINUE
      W=CCDS(HMAX,H1,BETA1)*CSDS(HMAX,H2,BETA1)
C           
  500 CONTINUE
      CIB0=U*W/V
C
      RETURN
      END

      SUBROUTINE ABORTC(IFLAG)       
C    
C     THIS SUBROUTINE ABORTS THE RUN FOR THE FOLLOWING REASONS:
C
C      0. FAILURE TO CONVERGE IN CEGV
C      1. MULTIPLE EIGEN VALUES IN SEARCH   
C      2. ZERO DETERMINANT RETURNED BY DECOMP IN CLINEQS
C      3. FAILURE TO IMPROVE BY IMPRUV IN CLINEQS ON 
C         RETURN TO COUPLE
C      4. FAILURE TO CONVERGE IN CIGMAT
C    
      IMPLICIT REAL*8 (A-H,O-Z)
      WRITE(9,100) IFLAG
  100 FORMAT(1X,///,' ***** RUN ABORTED FOR REASON ',I5,
     1       '  *****',////)
C
      WRITE(9,200)
  200 FORMAT(5X,40H0. FAILURE TO CONVERGE IN CEGV          /
     1       5X,40H1. MULTIPLE EIGEN VALUES IN SEARCH      /
     2       5X,40H2. ZERO DETERMINANT RETURNED BY DECOMP  /
     3       5X,40H3. FAILURE TO INPROVE BY IMPRUV         /
     4       5X,40H3. FAILURE TO CONVERGE IN CIGMAT        /)
C              
      STOP
      END

REM
REM COMPILE ALL SUBROUTINES FOR COUPLE
REM
REM lf90 -c COUPLE
REM
lf90 -c ABORTC.FOR 
lf90 -c AMAT.FOR
lf90 -c AVGIN.FOR 
lf90 -c BACKSUB.FOR 
lf90 -c BATHY.FOR 
lf90 -c BESSJ0.FOR 
lf90 -c BESSY0.FOR 
lf90 -c BDF.FOR 
lf90 -c BMAT.FOR
lf90 -c BOTDEPS.FOR 
lf90 -c CCDS.FOR 
lf90 -c CDFUN.FOR
lf90 -c CDJ0.FOR 
lf90 -c CDSRT.FOR 
lf90 -c CDTAN.FOR 
lf90 -c CEGV.FOR
lf90 -c CEXIB.FOR
lf90 -c CEXIBD.FOR
lf90 -c CEXIW.FOR
lf90 -c CEXIWB.FOR
lf90 -c CEXIWD.FOR
lf90 -c CFACIN.FOR 
lf90 -c CHDH.FOR 
lf90 -c CHECK.FOR 
lf90 -c CHOLDC.FOR
lf90 -c CIB0.FOR 
lf90 -c CSYMEIG.FOR 
lf90 -c CISP.FOR 
lf90 -c CIW0.FOR 
lf90 -c CIWB.FOR 
lf90 -c CJDJ.FOR 
lf90 -c CLINEQS.FOR 
lf90 -c CMMULT.FOR 
lf90 -c CPRES.FOR 
lf90 -c CPTBH.FOR 
lf90 -c CPTURB.FOR 
lf90 -c CRSCUP.FOR
lf90 -c CRSCUPB.FOR
lf90 -c CSDS.FOR 
lf90 -c CUPB.FOR 
lf90 -c CUPBW.FOR 
lf90 -c CUPW.FOR 
lf90 -c CUPWB.FOR 
lf90 -c CVMULT.FOR 
lf90 -c DREAL.FOR 
lf90 -c EGNVAL.FOR 
lf90 -c ESPI.FOR 
lf90 -c FILE.FOR 
lf90 -c FORESUB.FOR
lf90 -c GALRKN.FOR 
lf90 -c GAMA.FOR 
lf90 -c GAMA0.FOR 
lf90 -c GAMA00.FOR 
lf90 -c GENAB.FOR 
lf90 -c HEADER.FOR 
lf90 -c HK01.FOR 
lf90 -c HK02.FOR 
lf90 -c INDEP.FOR 
lf90 -c INPUT.FOR 
lf90 -c MGS.FOR 
lf90 -c MMULT.FOR 
lf90 -c PROPM.FOR 
lf90 -c PRTMAT.FOR 
lf90 -c PRTTL.FOR
lf90 -c PTURB.FOR 
lf90 -c RCF.FOR 
lf90 -c SEARCH.FOR 
lf90 -c TMMULT.FOR 
lf90 -c ZCEXIB.FOR
lf90 -c ZCEXIW.FOR

DEL COUPLE.EXE
lf90 -c COUPLE.FOR                                                     
REM lf90 -c GALRKN.FOR                                                     
REM lf90 -c AMAT.FOR                                                     
REM lf90 -c AVGIN.FOR                                                     
REM lf90 -c BMAT.FOR                                                     
REM lf90 -c CRSCUPB.FOR                                                     
REM lf90 -c CUPB.FOR                                                     
REM lf90 -c CUPBW.FOR                                                     
REM lf90 -c CUPW.FOR                                                     
REM lf90 -c CUPWB.FOR                                                     
REM lf90 -c CEXIW.FOR                                                     
REM lf90 -c CEXIWB.FOR                                                     
REM lf90 -c CEXIWD.FOR                                                     
REM lf90 -c ZCEXIW.FOR                                                     
REM lf90 -c INPUT.FOR                                                     
REM lf90 -c INDEP.FOR                                                     
REM lf90 -c SEARCH.FOR                                                     
lf90 -pack @COUPLE.LNK

rem Limit input file name to 7 characters to allow space for S, O and I
COPY %1.DAT COUPLE.DAT
ERASE COUPLE.LOG
ERASE COUPLE.PRT
COUPLE.EXE
COPY COUPLE.LOG %1.LOG
COPY COUPLE.PRT %1.PRT
COPY COUPLE.TL %1.TL
COPY COUPLES.TL %1S.TL
COPY COUPLEO.TL %1O.TL
COPY COUPLEI.TL %1I.TL
REM
COPY COUPLE.CPR %1.CPR
COPY COUPLES.CPR %1S.CPR
COPY COUPLEO.CPR %1O.CPR
COPY COUPLEI.CPR %1I.CPR
REM
REM ERASE COUPLE.DAT
REM ERASE COUPLE.PRT
ERASE COUPLE.TL
ERASE COUPLES.TL
ERASE COUPLEO.TL
ERASE COUPLEI.TL
ERASE COUPLE.CPR
ERASE COUPLES.CPR
ERASE COUPLEO.CPR
ERASE COUPLEI.CPR
REM ERASE SCRATCH FILES
REM ERASE SCRACH21.DAT          
REM ERASE SCRACH2.DAT 
REM ERASE SCRACH3.DAT 
REM ERASE SCRACH4.DAT 
REM ERASE SCRACH8.DAT 
REM ERASE SCRACH18.DAT 
REM ERASE LUSVP.DAT 

#
#Batch file to run couple
#use"%s/oldname/newname/g" to change input data name
#
cd /home/oalib/evans/couple97
cp examp3.dat COUPLE.DAT
couple
cp COUPLE.LOG examp3.log
cp COUPLE.PRT examp3.prt
rm COUPLE.LOG
rm COUPLE.PRT
cp COUPLE.TL examp3.tl
cp COUPLES.TL examp3s.tl
cp COUPLEO.TL examp3o.tl
cp COUPLEI.TL examp3i.tl
cp COUPLE.CPR examp3.cpr
cp COUPLES.CPR examp3s.cpr
cp COUPLEO.CPR examp3o.cpr
cp COUPLEI.CPR examp3i.cpr
rm COUPLE.TL
rm COUPLES.TL
rm COUPLEO.TL
rm COUPLEI.TL
rm COUPLE.CPR
rm COUPLES.CPR
rm COUPLEO.CPR
rm COUPLEI.CPR
rm COUPLE.DAT
#
#rm SCRACH21.DAT
#rm SCRACH2.DAT
#rm SCRACH3.DAT
#rm SCRACH4.DAT
#rm SCRACH8.DAT
#rm SCRACH18.DAT
